#!/bin/sh
#
# avahi-daemon init script
HOSTNAME=`/usr/sbin/sqldb_read /sys/network/hostname`
HTTPPORT=`/usr/sbin/sqldb_read /sys/network/httpserver/port`
MAC=`/sbin/ifconfig    | grep 'br0'    | tr -s ' '    | cut -d ' ' -f5 | cut -b 10-17 | tr -d ':'` 
HOSTNAMEMAC="${HOSTNAME}-${MAC}"

sed -i 's/host-name=.*/host-name='${HOSTNAMEMAC}'/g' /etc/avahi/avahi-daemon.conf
sed -i 's/<port>.*<\/port>/<port>'${HTTPPORT}'<\/port>/g' /etc/avahi/services/httpd.service
DAEMON=/usr/sbin/avahi-daemon
case "$1" in
    start)
	$DAEMON -c || $DAEMON -D
	;;
    stop)
	$DAEMON -c && $DAEMON -k
	;;
    reload)
	$DAEMON -c && $DAEMON -r
	;;
    *)
	echo "Usage: S50avahi-daemon {start|stop|reload}" >&2
	exit 1
	;;
esac
