#!/bin/sh

HOSTNAME=`/usr/sbin/sqldb_read /sys/network/hostname`
LOCALDOMAIN=`/usr/sbin/sqldb_read /sys/network/localdomain`
IP=`/usr/sbin/sqldb_read /sys/network/lan/ipaddress`
NETMASK=`/usr/sbin/sqldb_read /sys/network/lan/netmask`
GW=`/usr/sbin/sqldb_read /sys/network/lan/gateway`
DNS1=`/usr/sbin/sqldb_read /sys/network/lan/dns1`
DNS2=`/usr/sbin/sqldb_read /sys/network/lan/dns2`
TZ=`/usr/sbin/sqldb_read /sys/network/tz`
WLAN_MODE=`/usr/sbin/sqldb_read /sys/network/wlan/mode`

case "$1" in
start)
	echo "Starting system runtime config ..."

	echo "***************  |  SYS:001" > /var/log/messages
	
	#setting hostname
	echo "Setting hostname ...$HOSTNAME" > /dev/console
        echo "$IP	$HOSTNAME.$LOCALDOMAIN	$HOSTNAME" > /etc/hosts
	echo "127.0.0.1	localhost.$LOCALDOMAIN	localhost" >> /etc/hosts
 	/bin/hostname $HOSTNAME
 	
 	# prepare rgb_demon...
	echo "Start rgb_demon ..." > /dev/console
	/usr/sbin/rgb_demon > /dev/console &
	#/etc/scripts/timezone.sh set
	#/etc/templates/logs.sh
 	
 	
	echo "Inserting modules ..." > /dev/console
	# wireless driver
	 if [ ${WLAN_MODE} = "ap" ] ;then
 	insmod /root/rt3070ap.ko
	else
 	insmod /root/rt3070sta.ko
	fi

	# Setup bridge
	brctl addbr br0 	> /dev/console
	brctl stp br0 off	> /dev/console
	brctl setfd br0 0	> /dev/console

        
	# Start up LAN interface & httpd
	ifconfig br0 0.0.0.0 up			> /dev/console
	/etc/scripts/httpd.sh start	> /dev/console
	;;
stop)

	;;
esac
