#!/bin/sh

IP=`/usr/sbin/sqldb_read /sys/network/lan/ipaddress`
NETMASK=`/usr/sbin/sqldb_read /sys/network/lan/netmask`
GW=`/usr/sbin/sqldb_read /sys/network/lan/gateway`
DNS1=`/usr/sbin/sqldb_read /sys/network/lan/dns1`
DNS2=`/usr/sbin/sqldb_read /sys/network/lan/dns2`

case $1 in

 	start)
	echo "Starting network....."
	ifconfig eth0 0.0.0.0 up
	brctl addif br0 eth0
	/sbin/ifconfig br0 ${IP} netmask ${NETMASK} > /dev/null 2>&1
	route delete default
	route add -net 0.0.0.0 netmask 0.0.0.0 gw ${GW}
	
	echo "search allnet.local" > /etc/resolv.conf
	echo "nameserver $DNS1" >> /etc/resolv.conf
	echo "nameserver $DNS2" >> /etc/resolv.conf
	
      ;;
      
    stop)
    
	#ifconfig br0 down
	ifconfig eth0 down
	brctl delif br0 eth0
	 	
       ;;
       
    restart)
        $0 stop
# sleep 1 second
        sleep 1        
        $0 start        
     ;;

    *)
      $0 restart
      ;;
esac
