#! /bin/sh
#
# System-V init script for the openntp daemon
#

PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DESC="network time protocol daemon"
NAME=ntpd
DAEMON=/usr/sbin/$NAME
NTPDATE_BIN=/usr/bin/ntpdate
ENABLED=`/usr/sbin/sqldb_read /sys/network/ntpd/enabled`
SERVER1=`/usr/sbin/sqldb_read /sys/network/ntpd/server1`
SERVER2=`/usr/sbin/sqldb_read /sys/network/ntpd/server2`
SERVER3=`/usr/sbin/sqldb_read /sys/network/ntpd/server3`
SERVERS1=`/usr/sbin/sqldb_read /sys/network/ntpd/servers1`
TZ=`/usr/sbin/sqldb_read /sys/network/ntpd/tz`

rm -f /etc/ntpd.conf
echo "server $SERVER1" > /etc/ntpd.conf
echo "server $SERVER2" >> /etc/ntpd.conf
echo "server $SERVER3" >> /etc/ntpd.conf
echo "servers $SERVERS1" >> /etc/ntpd.conf

echo "$TZ" > /etc/TZ 

# Gracefully exit if the package has been removed.
test -x $DAEMON || exit 0

# Read config file if it is present.
if [ -r /etc/default/$NAME ]
then
	. /etc/default/$NAME
fi

case "$1" in
  start)

	if [ "$ENABLED" = "1" ] ; then
		if test x$NTPDATE = xyes ; then
			echo -n "Getting initial time via ntp"
			$NTPDATE_BIN $NTPDATE_OPTS $NTPSERVERS > /dev/null 2>&1 &
			echo "."
		fi
		if test x$NTPD = xyes ; then
			echo -n "Starting $DESC: $NAME"
			start-stop-daemon -S -q -x $DAEMON
			echo "."
		fi
	fi
	;;
  stop) echo -n "Stopping $DESC: $NAME"
	start-stop-daemon -K -q -n $NAME
	echo "."
	;;
  reload|force-reload) echo -n "Reloading $DESC configuration..."
	start-stop-daemon -K -q -n $NAME -s 1
	echo "done."
  ;;
  restart) echo "Restarting $DESC: $NAME"
	$0 stop
	sleep 1
	$0 start
	;;
  *) echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
	exit 1
	;;
esac

exit 0
