// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   actor_r_readpower.c   -   Anzeigen der Aktor-Power-Daten aus dem Shared Memory                                **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2009 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <time.h>
#include <sys/time.h>
#include <unistd.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include "../sqlite/sqlite-3.7.3_arm/sqlite3.h"
#include "at91gpio.h"
#include "all_i2c.h"
#include "i2c_chips.h"
#include "sqldb.h"
#include "sensor_demon.h"
#include "shm_use.h"



// *****   Hauptschleife   *****

int main(int argc,char **argv)
	{
	int												shID;
	int												rw = 0;
	struct s_shm_actordata*		shm_actor_r_data;						// Aktordaten im Shared-RAM
	signed short int					nummer;

	if (argc != 2)
		{
		printf("ERROR: usage: actor_r_readpower \"logical_actor_number\"\n");
		rw = -2;
		goto ende;
		}
	nummer = atoi(argv[1]);																// Nummer aus der Commandline holen
	if (nummer < 0)
		{
		printf("ERROR: Numer must be positive or 0 !\n");
		rw = -3;
		goto ende;
		}
	if (nummer >= MAX_LOGICAL_ACTORS)
		{
		printf("ERROR: Numer must be less than MAX_LOGICAL_ACTORS (%d) !\n",MAX_LOGICAL_ACTORS);
		rw = -3;
		goto ende;
		}


	// auf existierendes Shared Memory fr Aktordaten Read zugreifen
	shID = shmget(SHM_ID_ACTOR_R_DATA,SHM_ACTOR_R_DATA_SIZE,0666);
	if (shID >= 0)
		{
		shm_actor_r_data = shmat(shID,0,0);
		if (shm_actor_r_data == (struct s_shm_actordata *)-1)
			{
			printf("Problem beim Zugriff auf ACTOR_R_DATA shared memory !\n");
			goto ende;
			}
		else
			{
			// printf("SHM_Actor_r_data OK.\n");
			}
		}
	else
		{
		// shmget lief schief
		printf("shmget fr SHM_Actor_r_data war erfolglos ! (shm_create nicht aufgerufen ?)\n");
		goto ende;
    }

		printf("%4.2f\n",shm_actor_r_data[nummer].value_float);


ende:
	return(rw);
	}
