// **********   all_i2c.h - Allnet multiplexed I2C bus functions   **********



// *****   Definitionen von Konstanten und globalen Variablen   *****

#define PORT_A 0
#define PORT_B 1
#define PORT_C 2
#define PORT_D 3
#define PORT_E 4


extern unsigned long int			bus_speed;
extern const unsigned char		zp[9];
extern unsigned char					bus_select_port;
extern unsigned char					bus_select_gruppe;
extern AT91S_PIO							*all_i2c_pioa;
extern AT91S_PIO							*all_i2c_piob;
extern AT91S_PIO							*all_i2c_pioc;
extern AT91S_PIO							*all_i2c_piod;
extern AT91S_PIO							*all_i2c_pioe;



// *****   Deklarationen der verwendeten Funktionen   *****

unsigned long									get_10us_now							(void);
void													gpio_devmem_open					(void);
void													gpio_port_init_input			(unsigned int portnummer,unsigned char bitnummer);
void													gpio_port_init_output			(unsigned int portnummer,unsigned char bitnummer);
unsigned char									gpio_port_read						(unsigned int portnummer,unsigned char bitnummer);
void													gpio_port_write						(unsigned int portnummer,unsigned char bitnummer,unsigned char wert);
unsigned char									i2c_byte_receive					(unsigned int busnummer);
void													i2c_byte_send							(unsigned int busnummer,unsigned char b);
void													i2c_data_high							(unsigned int busnummer);
void													i2c_data_low							(unsigned int busnummer);
void													i2c_data_in								(unsigned int busnummer);
void													i2c_data_out							(unsigned int busnummer);
void													i2c_debug_ein							(void);
void													i2c_debug_aus							(void);
void													i2c_clock_high						(unsigned int busnummer);
void													i2c_clock_low							(unsigned int busnummer);
void													i2c_clock_out							(unsigned int busnummer);
void													i2c_delay									(unsigned long d);
unsigned char									i2c_read_data							(unsigned int busnummer);
unsigned char									i2c_receive_byte					(unsigned int busnummer,unsigned char ack);
void													i2c_ruhe									(unsigned int busnummer);
void													i2c_send_ack							(unsigned int busnummer);
unsigned char									i2c_send_byte							(unsigned int busnummer,unsigned char b,unsigned char ack);
void													i2c_send_nak							(unsigned int busnummer);
void													i2c_send_start						(unsigned int busnummer);
void													i2c_send_start_sht				(unsigned int busnummer);
void													i2c_send_stop							(unsigned int busnummer);
unsigned char									i2c_wait_for_ack					(unsigned int busnummer);
void													i2c_port_group_out				(unsigned int busnummer);
void													selektiere_gruppe					(unsigned int busnummer,unsigned char nummer);
void													selektiere_port						(unsigned int busnummer,unsigned char nummer);
