// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   cv_demon.c   -   Demon zum verarbeiten der Kontrollspannungseingnge (Poti-Eingnge) f. ALL3651               **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2011 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************

// **********   Eintrge in der Konfigurations-Datenbank, die vom Demon ausgewertet werden   **********
//
// /control/cv/enabled																	Muss berhaupt etwas getan werden ?
// /control/cv/reloadcounter														wird bei nderungen der config hochgezhlt
// /control/cv/loglevel																	Loglevel 0...4
// /control/cv/cv0/type																	0: inaktiv, 1: Copy to Color gem. Target, 2: Switch ab Level in Threshold
// /control/cv/cv0/target																0:keines,1:r0,2:g0,3:b0,4:w0,5:r1,6:g1,7:b1,8:w1,9:alle Ch0,10:alle Ch1,11:Alle Ch0+1,12:r0+r1,13:g0+g1,14:b0+b1,15:w0+w1
// /control/cv/cv0/threshold														Schaltschwelle, ab der geschaltet werden soll
// /control/cv/cv1/type																	0: inaktiv, 1: Copy to Color gem. Target, 2: Switch ab Level in Threshold
// /control/cv/cv1/target																0:keines,1:r0,2:g0,3:b0,4:w0,5:r1,6:g1,7:b1,8:w1,9:alle Ch0,10:alle Ch1,11:Alle Ch0+1,12:r0+r1,13:g0+g1,14:b0+b1,15:w0+w1
// /control/cv/cv1/threshold														Schaltschwelle, ab der geschaltet werden soll
// /control/cv/cv2/type																	0: inaktiv, 1: Copy to Color gem. Target, 2: Switch ab Level in Threshold
// /control/cv/cv2/target																0:keines,1:r0,2:g0,3:b0,4:w0,5:r1,6:g1,7:b1,8:w1,9:alle Ch0,10:alle Ch1,11:Alle Ch0+1,12:r0+r1,13:g0+g1,14:b0+b1,15:w0+w1
// /control/cv/cv2/threshold														Schaltschwelle, ab der geschaltet werden soll
// /control/cv/cv3/type																	0: inaktiv, 1: Copy to Color gem. Target, 2: Switch ab Level in Threshold
// /control/cv/cv3/target																0:keines,1:r0,2:g0,3:b0,4:w0,5:r1,6:g1,7:b1,8:w1,9:alle Ch0,10:alle Ch1,11:Alle Ch0+1,12:r0+r1,13:g0+g1,14:b0+b1,15:w0+w1
// /control/cv/cv3/threshold														Schaltschwelle, ab der geschaltet werden soll
// /control/cv/cv4/type																	0: inaktiv, 1: Copy to Color gem. Target, 2: Switch ab Level in Threshold
// /control/cv/cv4/target																0:keines,1:r0,2:g0,3:b0,4:w0,5:r1,6:g1,7:b1,8:w1,9:alle Ch0,10:alle Ch1,11:Alle Ch0+1,12:r0+r1,13:g0+g1,14:b0+b1,15:w0+w1
// /control/cv/cv4/threshold														Schaltschwelle, ab der geschaltet werden soll
// /control/cv/cv5/type																	0: inaktiv, 1: Copy to Color gem. Target, 2: Switch ab Level in Threshold
// /control/cv/cv5/target																0:keines,1:r0,2:g0,3:b0,4:w0,5:r1,6:g1,7:b1,8:w1,9:alle Ch0,10:alle Ch1,11:Alle Ch0+1,12:r0+r1,13:g0+g1,14:b0+b1,15:w0+w1
// /control/cv/cv5/threshold														Schaltschwelle, ab der geschaltet werden soll
// /control/cv/storage/r0																Merker fr R0
// /control/cv/storage/g0																Merker fr G0
// /control/cv/storage/b0																Merker fr B0
// /control/cv/storage/w0																Merker fr W0
// /control/cv/storage/r1																Merker fr R1
// /control/cv/storage/g1																Merker fr G1
// /control/cv/storage/b1																Merker fr B1
// /control/cv/storage/w1																Merker fr W1


#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <string.h>
#include <netinet/in.h>
#include <fcntl.h>
#include <time.h>
#include <sys/time.h>
#include <sys/shm.h>
#include "at91gpio.h"
#include "all_i2c.h"
#include "i2c_chips.h"
#include "../sqlite/sqlite-3.7.3_arm/sqlite3.h"
#include "cv_demon.h"
#include "sqldb.h"
#include "logging.h"
#include "shm_use.h"



// *****   Globale Variablen   *****

#define CONFIG_DATABASE_FILE "/etc/allnetenv/config.s3db"
#define VAR_DATABASE_FILE "/tmp/var.s3db"


unsigned long int	ti = 0;																// Zhler, geht bei jedem Durchlauf um 1 hoch
signed short int	programm_nummer = -1;									// Nummer des gerade aktiven Programms
signed short int	programm_az = -1;											// gerade abgearbeitete Zeilennummer
signed short int	programm_status = -1;									// Status (-2:muss geladen werden, -1:angehalten, 1: in Delay innerhalb der Zeile, 0:Zeile muss bearbeitet werden)
signed short int	programm_delaycounter = 0;						// Delayzhler innerhalb der Zeile
signed short int	programm_zeilennummer = -1;						// aktuelle Zeilennummer
signed short int	programm_max_steps = 16;							// Anzahl zulssiger Zeilennummern
signed short int	fernbedienung = -1;										// Typ der Fernbedienung (-1: Keine, 0: alte kleine FB mit altem Tiny85,
																												//                        1: PortaLuce FB mit neuem Tiny85,
																												//                        2: alte kleine FB mit neuem Tiny85)
signed short int	old_tiny_major = 0;										// IR-Empfnger Major ID
signed short int	old_tiny_minor = 0;										// IR-Empfnger Minor ID

/*
struct programmzeile
	{
	signed short int 		cmdtoken;													// 0:NOP, 1:RGB_Set, 2:Restart 3:End
	signed short int		r0;
	signed short int		g0;
	signed short int		b0;
	signed short int		w0;
	signed short int		dim0;
	signed short int		r1;
	signed short int		g1;
	signed short int		b1;
	signed short int		w1;
	signed short int		dim1;
	signed short int		delay;
	signed short int		target;
	signed short int		switchtype;
	} pz;
struct programmzeile programm_zeile[101];
*/



// *****   sql_read_rgbvalues_nodim()   -   Daten aus der tmpDB holen   *****

signed short int sql_read_rgbvalues_nodim(sqlite3 *ptr,unsigned char *r0,unsigned char *g0,unsigned char *b0,unsigned char *w0,unsigned char *r1,unsigned char *g1,unsigned char *b1,unsigned char *w1)
	{
	signed short int rw = 0;
	sqlite3_stmt *vm;
	char *sql_query;
	signed short int i = 0;
	char zs[96];
	char sql[80] = "SELECT r0,g0,b0,w0,r1,g1,b1,w1 from rgboutput where id = 0;";


	//printf("cv_demon%ld: read Start\n",ti);
beginn:
	//printf("SQL:\"%s\"\n",sql);
	sql_query = sqlite3_mprintf("%s",sql);								// Vorbereitung des SQL-Querys
	
	// Umwandlung des SQl Querys in Byte-code
	rw = sqlite3_prepare(ptr,sql_query,strlen(sql_query),&vm,NULL);
	if (rw != SQLITE_OK)
		{
		// printf("(Error %d bei \"%s\")\n",rw,sql);
		// printf("SQLITE Read lock problem !!!!!\n");
		sqlite3_finalize(vm);																// Loeschen des Statements
		sqlite3_free(sql_query);														// freigeben des Bytecodes
		usleep(25000);																			// 25 ms warten
		goto beginn;
		}

	// Ausgabe des Datensatzes
	while(sqlite3_step(vm) != SQLITE_DONE)
		{
		i++;
		if(sqlite3_column_text(vm,0) == NULL)
			{
			// printf("cv_demon: sql_read_rgbvalues: NULL Pointer als Result bei \"%s\" - alte Werte werden beibehalten !\n",sql);
			rw = -1;
			goto final;
			}
		// printf("%s\n",sqlite3_column_text(vm,0));						// Inhalt des Datensatzes ausgeben
		strcpy(zs,(char *)sqlite3_column_text(vm,0));				// String aus dem DB-Recordset kopieren
		// printf("RW0:\"%s\"\n",zs);
		*r0 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,1));				// String aus dem DB-Recordset kopieren
		*g0 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,2));				// String aus dem DB-Recordset kopieren
		*b0 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,3));				// String aus dem DB-Recordset kopieren
		*w0 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,4));				// String aus dem DB-Recordset kopieren
		*r1 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,5));				// String aus dem DB-Recordset kopieren
		*g1 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,6));				// String aus dem DB-Recordset kopieren
		*b1 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,7));				// String aus dem DB-Recordset kopieren
		*w1 = atol(zs);
		rw = 1;
		}
	if(i < 1)																							// wenn kein Datensatz, -1 zurckgeben
		{
		printf("cv_demon: sql_read_rgbvalues: kein Datensatz - alte Werte werden beibehalten !\n");
		rw = 0;
		}

final:
	sqlite3_finalize(vm);																	// Loeschen des Statements
	sqlite3_free(sql_query);															// freigeben des Bytecodes
	// printf("cv_demon: read End\n");
	return(rw);
	}



// *****   sql_write_rgbvalues_nodim   -   Schreiben der RGB-Output-Werte in die tmpDB   *****

void sql_write_rgbvalues_nodim(sqlite3 *ptr,unsigned char r0,unsigned char g0,unsigned char b0,unsigned char w0,unsigned char r1,unsigned char g1,unsigned char b1,unsigned char w1)
	{
	char sql[255];

	sprintf(sql,"UPDATE rgboutput SET r0=%d,g0=%d,b0=%d,w0=%d,r1=%d,g1=%d,b1=%d,w1=%d WHERE id = 0;",r0,g0,b0,w0,r1,g1,b1,w1);
	do_sqlyy(ptr,sql,0);
	}



// *****   sql_read_potivalues   -   Lesen der Poti-Spannungen aus der tmpDB   *****

signed short int sql_read_potivalues(sqlite3 *ptr,unsigned char *p0,unsigned char *p1,unsigned char *p2,unsigned char *p3,unsigned char *p4,unsigned char *p5)
	{
	sqlite3_stmt *vm;
	char *sql_query;
	signed short int i = 0;
	char zs[96];
	signed short int rw;
	char sql[80] = "SELECT [p0],[p1],[p2],[p3],[p4],[p5] from [potis] where [id]=0;";


	// printf("SQL:\"%s\"\n",sql);
	sql_query = sqlite3_mprintf("%s",sql);								// Vorbereitung des SQL-Querys
	
	// Umwandlung des SQl Querys in Byte-code
	rw = sqlite3_prepare(ptr,sql_query,strlen(sql_query),&vm,NULL);
	if (rw != SQLITE_OK)
		{
		// printf("(Error %d bei \"%s\")\n",rw,sql);
		// printf("SQLITE Read lock problem !!!!!\n");
		sqlite3_finalize(vm);																// Loeschen des Statements
		sqlite3_free(sql_query);														// freigeben des Bytecodes
		rw = -2;																						// Rckmeldung: "DB-Fehler"
		goto ende;
		}

	// Ausgabe des Datensatzes
	while(sqlite3_step(vm) != SQLITE_DONE)
		{
		i++;
		if(sqlite3_column_text(vm,0) == NULL)
			{
			// printf("sql_read_potivalues: NULL Pointer als Result bei \"%s\" - alte Werte werden beibehalten !\n",sql);
			rw = -1;
			goto final;
			}
		// printf("%s\n",sqlite3_column_text(vm,0));						// Inhalt des Datensatzes ausgeben
		strcpy(zs,(char *)sqlite3_column_text(vm,0));				// String aus dem DB-Recordset kopieren
		*p0 = atoi(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,1));				// String aus dem DB-Recordset kopieren
		*p1 = atoi(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,2));				// String aus dem DB-Recordset kopieren
		*p2 = atoi(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,3));				// String aus dem DB-Recordset kopieren
		*p3 = atoi(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,4));				// String aus dem DB-Recordset kopieren
		*p4 = atoi(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,5));				// String aus dem DB-Recordset kopieren
		*p5 = atoi(zs);
		// printf("P0:%d\n",*p0);
		rw = 1;
		}
	if(i < 1)																							// wenn kein Datensatz, -1 zurckgeben
		{
		// printf("sql_read_potivalues: kein Datensatz - alte Werte werden beibehalten !\n");
		rw = -0;
		}

final:
	sqlite3_finalize(vm);																	// Loeschen des Statements
	sqlite3_free(sql_query);															// freigeben des Bytecodes

ende: return(rw);
	}



// *****   sql_write_rgbvalue_r0   -   nur den Wert fr R0 in die tmpDB schreiben   *****

void sql_write_rgbvalue_r0 (sqlite3 *ptr,unsigned char r0)
	{
	char sql[255];

	sprintf(sql,"UPDATE rgboutput SET r0=%d WHERE id = 0;",r0);
	do_sqlyy(ptr,sql,0);
	}



// *****   sql_write_rgbvalue_g0   -   nur den Wert fr G0 in die tmpDB schreiben   *****

void sql_write_rgbvalue_g0 (sqlite3 *ptr,unsigned char g0)
	{
	char sql[255];

	sprintf(sql,"UPDATE rgboutput SET g0=%d WHERE id = 0;",g0);
	do_sqlyy(ptr,sql,0);
	}



// *****   sql_write_rgbvalue_b0   -   nur den Wert fr B0 in die tmpDB schreiben   *****

void sql_write_rgbvalue_b0 (sqlite3 *ptr,unsigned char b0)
	{
	char sql[255];

	sprintf(sql,"UPDATE rgboutput SET b0=%d WHERE id = 0;",b0);
	do_sqlyy(ptr,sql,0);
	}



// *****   sql_write_rgbvalue_w0   -   nur den Wert fr W0 in die tmpDB schreiben   *****

void sql_write_rgbvalue_w0 (sqlite3 *ptr,unsigned char w0)
	{
	char sql[255];

	sprintf(sql,"UPDATE rgboutput SET w0=%d WHERE id = 0;",w0);
	do_sqlyy(ptr,sql,0);
	}



// *****   sql_write_rgbvalue_r1   -   nur den Wert fr R1 in die tmpDB schreiben   *****

void sql_write_rgbvalue_r1 (sqlite3 *ptr,unsigned char r1)
	{
	char sql[255];

	sprintf(sql,"UPDATE rgboutput SET r1=%d WHERE id = 0;",r1);
	do_sqlyy(ptr,sql,0);
	}



// *****   sql_write_rgbvalue_g1   -   nur den Wert fr G1 in die tmpDB schreiben   *****

void sql_write_rgbvalue_g1 (sqlite3 *ptr,unsigned char g1)
	{
	char sql[255];

	sprintf(sql,"UPDATE rgboutput SET g1=%d WHERE id = 0;",g1);
	do_sqlyy(ptr,sql,0);
	}



// *****   sql_write_rgbvalue_b1   -   nur den Wert fr B1 in die tmpDB schreiben   *****

void sql_write_rgbvalue_b1 (sqlite3 *ptr,unsigned char b1)
	{
	char sql[255];

	sprintf(sql,"UPDATE rgboutput SET b1=%d WHERE id = 0;",b1);
	do_sqlyy(ptr,sql,0);
	}



// *****   sql_write_rgbvalue_w1   -   nur den Wert fr W1 in die tmpDB schreiben   *****

void sql_write_rgbvalue_w1 (sqlite3 *ptr,unsigned char w1)
	{
	char sql[255];

	sprintf(sql,"UPDATE rgboutput SET w1=%d WHERE id = 0;",w1);
	do_sqlyy(ptr,sql,0);
	}



// *****   Hauptschleife   *****

int main(int argc,char **argv)
	{
	unsigned char 			cv[6];
	unsigned char 			old_cv[6];
	unsigned char				t = 0;
	signed long int			i;
	unsigned short int	az_cv = 0;												// nderungszhler Potis
	char								ep[1024];													// Puffer fr Logfile-Meldungen
	unsigned short int	cv_reloadcounter = -1;						// Reloadcounter
	signed short int		cv_enabled = 0;										// Aktiv 0/1
	signed short int		cv_type[6];												// Typ
	signed short int		cv_threshold[6];									// Schaltschwelle
	signed short int		cv_target[6];											// Ziel


	// auf existierendes Shared Memory fr Demonstatus zugreifen
	if (use_my_demonstatus_shm(8) != 1) goto errorende;		// MY_DEMON_ID = 8: cv_demon

	// Status von Demon in SHM eintragen
	my_demonstatus_data[my_demon_id].demon_id = my_demon_id;														// 0 ist Default, hier wird die eigene ID eingetragen
	sprintf(my_demonstatus_data[my_demon_id].name_string,"cv_demon");										// Name
	sprintf(my_demonstatus_data[my_demon_id].version_string,"%s",CVDEMON_VERSION);			// Versionsnummer
	my_demonstatus_data[my_demon_id].last_boot = time(0);																// Timestamp(UTC) des Starts
	my_demonstatus_data[my_demon_id].last_activity = time(0);														// Timestamp(UTC) der letzten Aktion
	my_demonstatus_data[my_demon_id].ti = ti;																						// Counter
	sprintf(my_demonstatus_data[my_demon_id].debug_message,"Start");										// letzte Debug-Meldung
	my_demonstatus_data[my_demon_id].error_message[0] = 0;															// letzte Fehlermeldung
	my_demonstatus_data[my_demon_id].status_long = 0;																		// numerischer Status
	sprintf(my_demonstatus_data[my_demon_id].status_string,"startup");									// String-Status

	// Logging-System initialisieren
	strcpy (log_filename,"/www/reports/cv_demon.log");		// Logfilenamen setzen
	log_level = sqldb_read_long("/control/cv/loglevel");	// Debuglevel setzen
	log_kill();																						// Logfile loeschen
	sprintf(ep,"----------   cv_demon V %s started (debuglevel=%d)   ----------",CVDEMON_VERSION,log_level);
	log_append(1,ep);																			// Startmeldung ins Logfile schreiben

	sqlite3_open(VAR_DATABASE_FILE,&sql_var_handle);			// SQLITE3-Datenbank ffnen





	// ----- Poti-Werte aus der tmpDB lesen -----
	// ... und gelesene Werte als alte Werte merken
	sql_read_potivalues(sql_var_handle,&old_cv[0],&old_cv[1],&old_cv[2],&old_cv[3],&old_cv[4],&old_cv[5]);

reload:
	cv_enabled = sqldb_read_long("/control/cv/enabled");	// Enabled
	log_level = sqldb_read_long("/control/cv/loglevel");	// Debuglevel
	cv_reloadcounter = sqldb_read_long("/control/cv/reloadcounter");	// Debuglevel
	for (t = 0;t < 6;t++)
		{
		sprintf(ep,"/control/cv/cv%d/type",t);
		cv_type[t] = sqldb_read_long(ep);
		sprintf(ep,"/control/cv/cv%d/threshold",t);
		cv_threshold[t] = sqldb_read_long(ep);
		sprintf(ep,"/control/cv/cv%d/target",t);
		cv_target[t] = sqldb_read_long(ep);
		}

	// Start loggen
	printf("cv_demon V %s started (enabled:%d, debuglevel:%d)\n",CVDEMON_VERSION,cv_enabled,log_level);


	update_demondebug("running");													// letzte Debug-Meldung
hauptschleife:
	update_demonstatus(ti,1,"main loop");									// Status von Demon in SHM aktualisieren
	i = 0;
	usleep(10000);																				// 10 ms warten
	ti++;																									// Schleifenzhler erhhen
	// printf("ti=%ld\n",ti);

	if (cv_reloadcounter != sqldb_read_long("/control/cv/reloadcounter")) goto reload;

	if (cv_enabled == 0)																	// Aktiv ?
		{
		update_demondebug("CV deactivated");								// letzte Debug-Meldung
		update_demonstatus(ti,1,"sleeping");								// Status von Demon in SHM aktualisieren
		sleep(2);
		goto hauptschleife;
		}


	// ----- Poti-Werte aus der tmpDB lesen -----
	sql_read_potivalues(sql_var_handle,&cv[0],&cv[1],&cv[2],&cv[3],&cv[4],&cv[5]);

	// feststellen, ob sich etwas gendert hat
	az_cv = 0;
	for (t = 0;t < 6;t++)
		{
		if (old_cv[t] != cv[t]) az_cv++;
		}
	if (az_cv == 0) goto hauptschleife;										// keine nderung, dann brauchen wir nichts zu tun
	// printf("CV0:%d, CV1:%d, CV2:%d, CV3:%d, CV4:%d, CV5:%d\n",cv[0],cv[1],cv[2],cv[3],cv[4],cv[5]);
	sprintf(ep,"CV0:%d,CV1:%d,CV2:%d,CV3:%d,CV4:%d,CV5:%d",cv[0],cv[1],cv[2],cv[3],cv[4],cv[5]);
	update_demondebug(ep);																// letzte Debug-Meldung



	// ----- Wenn an den Potis gedreht wurde, dann die RGB-Werte nach Potivorgaben setzen -----

	if (az_cv > 0)
		{
		// printf("az_cv:%d\n",az_cv);
		// printf("CV0:%d, CV1:%d, CV2:%d, CV3:%d, CV4:%d, CV5:%d\n",cv[0],cv[1],cv[2],cv[3],cv[4],cv[5]);
		for (t = 0;t < 6;t++)
			{
			if (cv_type[t] == 1)															// 1: Copy to Color
				{
				if (cv_target[t] == 1)
					{
					t_r0 = cv[t];
					sql_write_rgbvalue_r0(sql_var_handle,t_r0);
					}
				if (cv_target[t] == 2)
					{
					t_g0 = cv[t];
					sql_write_rgbvalue_g0(sql_var_handle,t_g0);
					}
				if (cv_target[t] == 3)
					{
					t_b0 = cv[t];
					sql_write_rgbvalue_b0(sql_var_handle,t_b0);
					}
				if (cv_target[t] == 4)
					{
					t_w0 = cv[t];
					sql_write_rgbvalue_w0(sql_var_handle,t_w0);
					}
				if (cv_target[t] == 5)
					{
					t_r1 = cv[t];
					sql_write_rgbvalue_r1(sql_var_handle,t_r1);
					}
				if (cv_target[t] == 6)
					{
					t_g1 = cv[t];
					sql_write_rgbvalue_g1(sql_var_handle,t_g1);
					}
				if (cv_target[t] == 7)
					{
					t_b1 = cv[t];
					sql_write_rgbvalue_b1(sql_var_handle,t_b1);
					}
				if (cv_target[t] == 8)
					{
					t_w1 = cv[t];
					sql_write_rgbvalue_w1(sql_var_handle,t_w1);
					}
				if (cv_target[t] == 9)
					{
					t_r0 = cv[t];
					t_g0 = cv[t];
					t_b0 = cv[t];
					t_w0 = cv[t];
					sql_write_rgbvalue_r0(sql_var_handle,t_r0);
					sql_write_rgbvalue_g0(sql_var_handle,t_g0);
					sql_write_rgbvalue_b0(sql_var_handle,t_b0);
					sql_write_rgbvalue_w0(sql_var_handle,t_w0);
					}
				if (cv_target[t] == 10)
					{
					t_r1 = cv[t];
					t_g1 = cv[t];
					t_b1 = cv[t];
					t_w1 = cv[t];
					sql_write_rgbvalue_r1(sql_var_handle,t_r1);
					sql_write_rgbvalue_g1(sql_var_handle,t_g1);
					sql_write_rgbvalue_b1(sql_var_handle,t_b1);
					sql_write_rgbvalue_w1(sql_var_handle,t_w1);
					}
				if (cv_target[t] == 11)
					{
					t_r0 = cv[t];
					t_g0 = cv[t];
					t_b0 = cv[t];
					t_w0 = cv[t];
					t_r1 = cv[t];
					t_g1 = cv[t];
					t_b1 = cv[t];
					t_w1 = cv[t];
					sql_write_rgbvalues_nodim(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1);
					}
				if (cv_target[t] == 12)
					{
					t_r0 = cv[t];
					t_r1 = cv[t];
					sql_write_rgbvalue_r0(sql_var_handle,t_r0);
					sql_write_rgbvalue_r1(sql_var_handle,t_r1);
					}
				if (cv_target[t] == 13)
					{
					t_g0 = cv[t];
					t_g1 = cv[t];
					sql_write_rgbvalue_g0(sql_var_handle,t_g0);
					sql_write_rgbvalue_g1(sql_var_handle,t_g1);
					}
				if (cv_target[t] == 14)
					{
					t_b0 = cv[t];
					t_b1 = cv[t];
					sql_write_rgbvalue_b0(sql_var_handle,t_b0);
					sql_write_rgbvalue_b1(sql_var_handle,t_b1);
					}
				if (cv_target[t] == 15)
					{
					t_w0 = cv[t];
					t_w1 = cv[t];
					sql_write_rgbvalue_w0(sql_var_handle,t_w0);
					sql_write_rgbvalue_w1(sql_var_handle,t_w1);
					}
				}
			if (cv_type[t] == 2)															// 2: Switch
				{
				if (cv[t] >= cv_threshold[t])
					{
					// Spannung >= Schwellwert
					if (cv_target[t] == 1)
						{
						t_r0 = sqldb_read_long("/control/cv/storage/r0");
						sql_write_rgbvalue_r0(sql_var_handle,t_r0);
						}
					if (cv_target[t] == 2)
						{
						t_g0 = sqldb_read_long("/control/cv/storage/g0");
						sql_write_rgbvalue_g0(sql_var_handle,t_g0);
						}
					if (cv_target[t] == 3)
						{
						t_b0 = sqldb_read_long("/control/cv/storage/b0");
						sql_write_rgbvalue_b0(sql_var_handle,t_b0);
						}
					if (cv_target[t] == 4)
						{
						t_w0 = sqldb_read_long("/control/cv/storage/w0");
						sql_write_rgbvalue_w0(sql_var_handle,t_w0);
						}
					if (cv_target[t] == 5)
						{
						t_r1 = sqldb_read_long("/control/cv/storage/r1");
						sql_write_rgbvalue_r1(sql_var_handle,t_r1);
						}
					if (cv_target[t] == 6)
						{
						t_g1 = sqldb_read_long("/control/cv/storage/g1");
						sql_write_rgbvalue_g1(sql_var_handle,t_g1);
						}
					if (cv_target[t] == 7)
						{
						t_b1 = sqldb_read_long("/control/cv/storage/b1");
						sql_write_rgbvalue_b1(sql_var_handle,t_b1);
						}
					if (cv_target[t] == 8)
						{
						t_w1 = sqldb_read_long("/control/cv/storage/w1");
						sql_write_rgbvalue_w1(sql_var_handle,t_w1);
						}
					if (cv_target[t] == 9)
						{
						t_r0 = sqldb_read_long("/control/cv/storage/r0");
						t_g0 = sqldb_read_long("/control/cv/storage/g0");
						t_b0 = sqldb_read_long("/control/cv/storage/b0");
						t_w0 = sqldb_read_long("/control/cv/storage/w0");
						sql_write_rgbvalue_r0(sql_var_handle,t_r0);
						sql_write_rgbvalue_g0(sql_var_handle,t_g0);
						sql_write_rgbvalue_b0(sql_var_handle,t_b0);
						sql_write_rgbvalue_w0(sql_var_handle,t_w0);
						}
					if (cv_target[t] == 10)
						{
						t_r1 = sqldb_read_long("/control/cv/storage/r1");
						t_g1 = sqldb_read_long("/control/cv/storage/g1");
						t_b1 = sqldb_read_long("/control/cv/storage/b1");
						t_w1 = sqldb_read_long("/control/cv/storage/w1");
						sql_write_rgbvalue_r1(sql_var_handle,t_r1);
						sql_write_rgbvalue_g1(sql_var_handle,t_g1);
						sql_write_rgbvalue_b1(sql_var_handle,t_b1);
						sql_write_rgbvalue_w1(sql_var_handle,t_w1);
						}
					if (cv_target[t] == 11)
						{
						t_r0 = sqldb_read_long("/control/cv/storage/r0");
						t_g0 = sqldb_read_long("/control/cv/storage/g0");
						t_b0 = sqldb_read_long("/control/cv/storage/b0");
						t_w0 = sqldb_read_long("/control/cv/storage/w0");
						t_r1 = sqldb_read_long("/control/cv/storage/r1");
						t_g1 = sqldb_read_long("/control/cv/storage/g1");
						t_b1 = sqldb_read_long("/control/cv/storage/b1");
						t_w1 = sqldb_read_long("/control/cv/storage/w1");
						sql_write_rgbvalues_nodim(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1);
						}
					if (cv_target[t] == 12)
						{
						t_r0 = sqldb_read_long("/control/cv/storage/r0");
						t_r1 = sqldb_read_long("/control/cv/storage/r1");
						sql_write_rgbvalue_r0(sql_var_handle,t_r0);
						sql_write_rgbvalue_r1(sql_var_handle,t_r1);
						}
					if (cv_target[t] == 13)
						{
						t_g0 = sqldb_read_long("/control/cv/storage/g0");
						t_g1 = sqldb_read_long("/control/cv/storage/g1");
						sql_write_rgbvalue_g0(sql_var_handle,t_g0);
						sql_write_rgbvalue_g1(sql_var_handle,t_g1);
						}
					if (cv_target[t] == 14)
						{
						t_b0 = sqldb_read_long("/control/cv/storage/b0");
						t_b1 = sqldb_read_long("/control/cv/storage/b1");
						sql_write_rgbvalue_b0(sql_var_handle,t_b0);
						sql_write_rgbvalue_b1(sql_var_handle,t_b1);
						}
					if (cv_target[t] == 15)
						{
						t_w0 = sqldb_read_long("/control/cv/storage/w0");
						t_w1 = sqldb_read_long("/control/cv/storage/w1");
						sql_write_rgbvalue_w0(sql_var_handle,t_w0);
						sql_write_rgbvalue_w1(sql_var_handle,t_w1);
						}
					}
				else
					{
					// Spannung < Schwellwert
					if (cv_target[t] == 1)
						{
						sql_read_rgbvalues_nodim(sql_var_handle,&t_r0,&t_g0,&t_b0,&t_w0,&t_r1,&t_g1,&t_b1,&t_w1);
						if (t_r0 > 0) sqldb_write_long("/control/cv/storage/r0",t_r0);
						sql_write_rgbvalue_r0(sql_var_handle,0);
						}
					if (cv_target[t] == 2)
						{
						sql_read_rgbvalues_nodim(sql_var_handle,&t_r0,&t_g0,&t_b0,&t_w0,&t_r1,&t_g1,&t_b1,&t_w1);
						if (t_g0 > 0) sqldb_write_long("/control/cv/storage/g0",t_g0);
						sql_write_rgbvalue_g0(sql_var_handle,0);
						}
					if (cv_target[t] == 3)
						{
						sql_read_rgbvalues_nodim(sql_var_handle,&t_r0,&t_g0,&t_b0,&t_w0,&t_r1,&t_g1,&t_b1,&t_w1);
						if (t_b0 > 0) sqldb_write_long("/control/cv/storage/b0",t_b0);
						sql_write_rgbvalue_b0(sql_var_handle,0);
						}
					if (cv_target[t] == 4)
						{
						sql_read_rgbvalues_nodim(sql_var_handle,&t_r0,&t_g0,&t_b0,&t_w0,&t_r1,&t_g1,&t_b1,&t_w1);
						if (t_w0 > 0) sqldb_write_long("/control/cv/storage/w0",t_w0);
						sql_write_rgbvalue_w0(sql_var_handle,0);
						}
					if (cv_target[t] == 5)
						{
						sql_read_rgbvalues_nodim(sql_var_handle,&t_r0,&t_g0,&t_b0,&t_w0,&t_r1,&t_g1,&t_b1,&t_w1);
						if (t_r1 > 0) sqldb_write_long("/control/cv/storage/r1",t_r1);
						sql_write_rgbvalue_r1(sql_var_handle,0);
						}
					if (cv_target[t] == 6)
						{
						sql_read_rgbvalues_nodim(sql_var_handle,&t_r0,&t_g0,&t_b0,&t_w0,&t_r1,&t_g1,&t_b1,&t_w1);
						if (t_g1 > 0) sqldb_write_long("/control/cv/storage/g1",t_g1);
						sql_write_rgbvalue_g1(sql_var_handle,0);
						}
					if (cv_target[t] == 7)
						{
						sql_read_rgbvalues_nodim(sql_var_handle,&t_r0,&t_g0,&t_b0,&t_w0,&t_r1,&t_g1,&t_b1,&t_w1);
						if (t_b1 > 0) sqldb_write_long("/control/cv/storage/b1",t_b1);
						sql_write_rgbvalue_b1(sql_var_handle,0);
						}
					if (cv_target[t] == 8)
						{
						sql_read_rgbvalues_nodim(sql_var_handle,&t_r0,&t_g0,&t_b0,&t_w0,&t_r1,&t_g1,&t_b1,&t_w1);
						if (t_w1 > 0) sqldb_write_long("/control/cv/storage/w1",t_w1);
						sql_write_rgbvalue_w1(sql_var_handle,0);
						}
					if (cv_target[t] == 9)
						{
						sql_read_rgbvalues_nodim(sql_var_handle,&t_r0,&t_g0,&t_b0,&t_w0,&t_r1,&t_g1,&t_b1,&t_w1);
						if ((t_r0 > 0) || (t_g0 > 0) || (t_b0 > 0) || (t_w0 > 0))
							{
							sqldb_write_long("/control/cv/storage/r0",t_r0);
							sqldb_write_long("/control/cv/storage/g0",t_g0);
							sqldb_write_long("/control/cv/storage/b0",t_b0);
							sqldb_write_long("/control/cv/storage/w0",t_w0);
							sql_write_rgbvalue_r0(sql_var_handle,1);
							sql_write_rgbvalue_g0(sql_var_handle,1);
							sql_write_rgbvalue_b0(sql_var_handle,1);
							sql_write_rgbvalue_w0(sql_var_handle,1);
							}
						}
					if (cv_target[t] == 10)
						{
						sql_read_rgbvalues_nodim(sql_var_handle,&t_r0,&t_g0,&t_b0,&t_w0,&t_r1,&t_g1,&t_b1,&t_w1);
						if ((t_r1 > 0) || (t_g1 > 0) || (t_b1 > 0) || (t_w1 > 0))
							{
							sqldb_write_long("/control/cv/storage/r1",t_r1);
							sqldb_write_long("/control/cv/storage/g1",t_g1);
							sqldb_write_long("/control/cv/storage/b1",t_b1);
							sqldb_write_long("/control/cv/storage/w1",t_w1);
							sql_write_rgbvalue_r1(sql_var_handle,1);
							sql_write_rgbvalue_g1(sql_var_handle,1);
							sql_write_rgbvalue_b1(sql_var_handle,1);
							sql_write_rgbvalue_w1(sql_var_handle,1);
							}
						}
					if (cv_target[t] == 11)
						{
						sql_read_rgbvalues_nodim(sql_var_handle,&t_r0,&t_g0,&t_b0,&t_w0,&t_r1,&t_g1,&t_b1,&t_w1);
						if ((t_r0 > 0) || (t_g0 > 0) || (t_b0 > 0) || (t_w0 > 0) || (t_r1 > 0) || (t_g1 > 0) || (t_b1 > 0) || (t_w1 > 0))
							{
							sqldb_write_long("/control/cv/storage/r0",t_r0);
							sqldb_write_long("/control/cv/storage/g0",t_g0);
							sqldb_write_long("/control/cv/storage/b0",t_b0);
							sqldb_write_long("/control/cv/storage/w0",t_w0);
							sqldb_write_long("/control/cv/storage/r1",t_r1);
							sqldb_write_long("/control/cv/storage/g1",t_g1);
							sqldb_write_long("/control/cv/storage/b1",t_b1);
							sqldb_write_long("/control/cv/storage/w1",t_w1);
							sql_write_rgbvalues_nodim(sql_var_handle,0,0,0,0,0,0,0,0);
							}
						}
					if (cv_target[t] == 12)
						{
						sql_read_rgbvalues_nodim(sql_var_handle,&t_r0,&t_g0,&t_b0,&t_w0,&t_r1,&t_g1,&t_b1,&t_w1);
						if (t_r0 > 0) sqldb_write_long("/control/cv/storage/r0",t_r0);
						if (t_r1 > 0) sqldb_write_long("/control/cv/storage/r1",t_r1);
						sql_write_rgbvalue_r0(sql_var_handle,0);
						sql_write_rgbvalue_r1(sql_var_handle,0);
						}
					if (cv_target[t] == 13)
						{
						sql_read_rgbvalues_nodim(sql_var_handle,&t_r0,&t_g0,&t_b0,&t_w0,&t_r1,&t_g1,&t_b1,&t_w1);
						if (t_g0 > 0) sqldb_write_long("/control/cv/storage/g0",t_g0);
						if (t_g1 > 0) sqldb_write_long("/control/cv/storage/g1",t_g1);
						sql_write_rgbvalue_g0(sql_var_handle,0);
						sql_write_rgbvalue_g1(sql_var_handle,0);
						}
					if (cv_target[t] == 14)
						{
						sql_read_rgbvalues_nodim(sql_var_handle,&t_r0,&t_g0,&t_b0,&t_w0,&t_r1,&t_g1,&t_b1,&t_w1);
						if (t_b0 > 0) sqldb_write_long("/control/cv/storage/b0",t_b0);
						if (t_b1 > 0) sqldb_write_long("/control/cv/storage/b1",t_b1);
						sql_write_rgbvalue_b0(sql_var_handle,0);
						sql_write_rgbvalue_b1(sql_var_handle,0);
						}
					if (cv_target[t] == 15)
						{
						sql_read_rgbvalues_nodim(sql_var_handle,&t_r0,&t_g0,&t_b0,&t_w0,&t_r1,&t_g1,&t_b1,&t_w1);
						if (t_w0 > 0) sqldb_write_long("/control/cv/storage/w0",t_w0);
						if (t_w1 > 0) sqldb_write_long("/control/cv/storage/w1",t_w1);
						sql_write_rgbvalue_w0(sql_var_handle,0);
						sql_write_rgbvalue_w1(sql_var_handle,0);
						}
					}
				}
			}
		}



	// Alte Werte merken
	for (t = 0;t < 6;t++)
		{
		old_cv[t] = cv[t];
		}

	goto hauptschleife;

// ende:
	sqlite3_close(sql_var_handle);												// Datenbank schlieen
	return(0);

errorende:
	return(-1);
	}
