// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   lcm.h   -   Lowlevel-Funktionen fr das LCD-Modul                                                             **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2009 - 2010 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************



// **********   Globale Variablen   **********


#define MAX_FILENAME_LENGTH 16
#define RESULT_OK 0x11
#define RESULT_FAIL 0x14
#define RESULT_LENGTH 16
#define CMD_MAX_LENGTH 32
#define STR_MAX_LENGTH 16
#define SELECT_TIMEOUT 10 //in seconds

// ***   useconds before get command results from LCM   ***
#define timing_val 100000

// ***   Commands to LCM   ***
extern char Reset_LCM[];
extern char Reset_LCM1[];
extern char Clear_display[];
extern char Return_home[];
extern char Display_ON[];
extern char Display_ON_NOCURSOR[];
extern char Display_OFF[];
extern char Bklight_OFF[];
extern char Bklight_ON[];

// ***   Command sets to Daemon   ***
extern char CMD_clear[];
extern char CMD_home[];
extern char CMD_disp[];
extern char CMD_bklight[];
extern char CMD_setpos[];
extern char CMD_write[];
extern char CMD_on[];
extern char CMD_off[];
extern char CMD_nocur[];



// **********   Funktionen   **********

void print_buf(char *buf, int count);
void writE(int fd,char bla[],int laenge);
char read_lcm(int fd,int read_max);
void reset_lcm(int fd);
int init_lcm(char * device_file);
void lcm_selectline(int fd,char linenumber);
void lcm_writetext(int fd,char bla[],int laenge);
