// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   led5000.c   -   Setzen der Frontpanel-LEDS (PCF8574, ID0) des ALL5000 (L:Ein)                                 **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2003 - 2010 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************



#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include "at91gpio.h"
#include "all_i2c.h"
#include "i2c_chips.h"


void print_usage()
	{
	printf("USAGE: led5000 led_number led_onoff\n");
	exit(0);
	}



// *****   Testprogramm   *****

int main(int argc,char **argv)
	{
	unsigned char bitmaske = 0;
	unsigned char led_nummer = 0;
	unsigned char led_sollstatus = 0;
	const unsigned char zp[8] = {1,2,4,8,16,32,64,128};
	unsigned char i;
	unsigned char busnummer = 0;


 	if (argc != 3)
		{
		print_usage();
		goto ende;
		}
  	
  led_nummer = atoi(argv[1]);
  led_sollstatus = atoi(argv[2]);
	
	
	
	gpio_devmem_open();																		// I/O-Memory-Filehandles initialiseren
	

		
	i2c_ruhe(busnummer);																	// Ruhe am Bus (Initialisierung auf Standardwerte)

	bitmaske = simplified_pcf8574_read(busnummer,0,0,40,0);
	// printf("Bitmaske (read) = %d\r\n",bitmaske);

	i = zp[led_nummer];
	if (led_sollstatus == 0)
		{
		// ausschalten (auf "1" setzen)
		bitmaske |= i;
		}
	else
		{
		// einschalten (auf "0" setzen)
		bitmaske &= (255 - i);
		}

	// printf("Bitmaske (write) = %d\r\n",bitmaske);
	simplified_pcf8574_write(busnummer,0,0,40,0,bitmaske);



/*
schleiferl:
	sleep(1);
	printf("1\n");
	simplified_all5000_led_set(0,0);
	// simplified_pcf8574_write(busnummer,0,0,40,0,255);
	sleep(1);
	printf("0\n");
	simplified_all5000_led_set(0,1);
	// simplified_pcf8574_write(busnummer,0,0,40,0,0);
	goto schleiferl;
*/

ende:
	return(0);
	}

