// **********   powermeter_demon.h - Abfrage der angeschlossenen Strombertrager   **********



// **********   Globale Variablen   **********

#define								POWERMETER_DEMON_VERSION "1.55ntc"
#define								POWERMETER_MAX_ALERTS 50
#define								MAX_NOTIFICATIONS 20

signed short int			hwmodel = 3690;																								// Hardware-ID
char									device_name[80];																							// Gertename
char									device_type[80];																							// Gertetyp
char									powermeter_logfile[80] = "/www/reports/powermeter_demon.log";	// Hier soll die Logdatei hin
signed short int			powermeter_loglevel = 3;																			// Loglevel (0: Nix, 4: Alles)
signed long int				ti = 0;																												// System-Timer
signed long int				adc_value_int[8];																							// Messwert 0...7 als int
signed long int				zero_offset[8];																								// Offset fr Nullung
signed long int				powermeter_adc[10];																						// ADC-Raw-Wert
double								powermeter_voltage[10];																				// Spannung fr W-Berechnung
double								powermeter_current[10];																				// Strom fr W-Berechnung
double								powermeter_multiply[10];																			// Multiplikator
double								powermeter_tmp[10];																						// Umrechnungspuffer
// double								powermeter_result[10];																				// Berechnungsergebnis
signed long int				powermeter_watt[10];																					// aktuelle Leistung in W nach allen Berechnungen
double								adc_value[8];																									// direkter Wert vom ADC
char									sqlite_db_filename[150];																			// Datenbank-Filename
signed long int				sqlite_db_timeinterval;																				// Zeitintervall fr Messungen
signed short int			notifications_max;																						// max. Anzahl Benachrichtigungen in der DB
signed short int			notifications_count;																					// tatschliche Anzahl Benachrichtigungen
signed short int			notification_reloadcounter;																		// Reloadcounter
signed char						notification_enabled[MAX_NOTIFICATIONS];											// Enabled 0/1
signed char						notification_action[MAX_NOTIFICATIONS];												// Art der Benachrichtigung
signed char						notification_sendtime_hour[MAX_NOTIFICATIONS];								// Versandzeit Stunde
signed char						notification_sendtime_minute[MAX_NOTIFICATIONS];							// Versandzeit Minute
char									notification_name[MAX_NOTIFICATIONS][80];											// Bezeichnung
char									notification_subject[MAX_NOTIFICATIONS][80];									// Email-Subject
char									notification_recipient[MAX_NOTIFICATIONS][80];								// Email-Empfnger
char									notification_body[MAX_NOTIFICATIONS][1024];										// Email-Body (vor den Mewerten)
unsigned char					flag_notification[MAX_NOTIFICATIONS];													// Flag fr Benachrichtigungen
signed long int				max_alerts;																										// Anzahl einstellbarer Alarme
signed short int			alert_phase[POWERMETER_MAX_ALERTS];														// Phase 0...2, 3:Summe oder -1 fr deaktiviert
signed long int				alert_minimum[POWERMETER_MAX_ALERTS];													// zulssiger Minimalwert W
signed long int				alert_maximum[POWERMETER_MAX_ALERTS];													// zulssiger Minimalwert W
signed short int			alert_duration[POWERMETER_MAX_ALERTS];												// Mindestzeit fr berschreitung
char									alert_recipient[POWERMETER_MAX_ALERTS][150];									// Email-Adresse des Empfngers
char									alert_subject[POWERMETER_MAX_ALERTS][150];										// Email-Subject
char									alert_body[POWERMETER_MAX_ALERTS][150];												// Email-Body
signed long int				alert_seccount[POWERMETER_MAX_ALERTS];												// Sekundenzhler fr Alarme
signed char						alert_time_day_montag[POWERMETER_MAX_ALERTS];									// Wochentagsflag
signed char						alert_time_day_dienstag[POWERMETER_MAX_ALERTS];								// Wochentagsflag
signed char						alert_time_day_mittwoch[POWERMETER_MAX_ALERTS];								// Wochentagsflag
signed char						alert_time_day_donnerstag[POWERMETER_MAX_ALERTS];							// Wochentagsflag
signed char						alert_time_day_freitag[POWERMETER_MAX_ALERTS];								// Wochentagsflag
signed char						alert_time_day_samstag[POWERMETER_MAX_ALERTS];								// Wochentagsflag
signed char						alert_time_day_sonntag[POWERMETER_MAX_ALERTS];								// Wochentagsflag
signed char						alert_time_from_hour[POWERMETER_MAX_ALERTS];									// Startzeit Stunde
signed char						alert_time_from_minute[POWERMETER_MAX_ALERTS];								// Startzeit Minute
signed char						alert_time_to_hour[POWERMETER_MAX_ALERTS];										// Endzeit Stunde
signed char						alert_time_to_minute[POWERMETER_MAX_ALERTS];									// Endzeit Minute
char									smtp_server[150];																							// Server fr Mailversand
char									smtp_username[150];																						// Loosername
char									smtp_password[150];																						// Passwort
char									smtp_sender[150];																							// FROM:
char									phase0_name[150];																							// Name von Phase 0
char									phase1_name[150];																							// Name von Phase 1
char									phase2_name[150];																							// Name von Phase 2
char									phase3_name[150];																							// Name von Phase 3
char									phase4_name[150];																							// Name von Phase 4
char									phase5_name[150];																							// Name von Phase 5
char									phase6_name[150];																							// Name von Phase 6
char									phase7_name[150];																							// Name von Phase 7
char									phase8_name[150];																							// Name von Phase 8
char									phase9_name[150];																							// Name von Phase 9
char									phaseall_name[150];																						// Name von allen Phasen
sqlite3								*sql_var_handle;																							// Handle fr die DB
signed long int				s0ticks[2];																										// Zhlerstnde fr den S0-Bus
signed long int				s0ticks_old[2];																								// alte Zhlerstnde fr den S0-Bus
signed long int				s0ticks_per_kwh[2];																						// Impulse pro KWh
double								d0_kwh[2];																										// Zhlerstnde fr den D0-Bus
double								d0_a[2];																											// Strme
double								d0_w[2];																											// Strme
double								d0_kwh_old[2] = {0,0};																				// alte Zhlerstnde fr den D0-Bus



// *****   Funktions-Prototypen   *****

void								schreibe_datenfile_sqlite										(signed long int w0,signed long int w1,signed long int w2,signed long int w3,signed long int w4,signed long int w5,signed long int w6,signed long int w7,signed long int w8,signed long int w9,signed long int sekunden);
void								schreibe_datenfile_xml											(void);
void								demon_readconfig														(void);
void								sensor_poll																	(void);
void								process_alerts															(void);
void								sql_lese_s0ticks														(sqlite3 *ptr);
void								sql_schreibe_s0ticks												(sqlite3 *ptr);
void								sql_erase_sensorvalues											(sqlite3 *ptr);
void								sql_lese_s0ticks_permanent									(void);
void								sql_schreibe_s0ticks_permanent							(void);
void								sql_lese_spannungen													(sqlite3 *ptr);
void								sql_schreibe_spannungen											(sqlite3 *ptr);
void								sql_lese_spannungen_permanent								(void);
void								lese_history																(void);
void								schreibe_history														(void);
void								notification_readconfig											(void);
void								process_notifications												(void);
void								notification_send														(signed short int nummer);
void								sqldb_read_measurement_sums									(char sql[],signed long int *ws0,signed long int *ws1,signed long int *ws2,signed long int *ws3,signed long int *ws4,signed long int *ws5,signed long int *ws6,signed long int *ws7,signed long int *ws8,signed long int *ws9);
// void								sql_lese_d0werte														(sqlite3 *ptr);
void								sql_lese_d0zaehler													(sqlite3 *ptr);
