// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   powermeter_timer.c   -   Timer zum Steuern von ALL3075/3076 Netzwerksteckdosen ber TCP/IP(alte STRDB ALL3690)**
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2011 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************

// **********   Eintrge in der Konfigurations-Datenbank, die vom Demon ausgewertet werden   **********
//
// /control/all3075/slaveXX/enabled								 			Enabled = 1
// /control/all3075/slaveXX/type									 			1: ALL3075, andere gibts momentan noch nicht
// /control/all3075/slaveXX/name												Name
// /control/all3075/slaveXX/comment											Blatext
// /control/all3075/slaveXX/ip_address									IP der Steckdose
// /control/all3075/slaveXX/user												Webserver Username
// /control/all3075/slaveXX/password										Webserver Pawort
// /control/all3075/slaveXX/mapfrom_actor								logischer Aktor, der die Dose kontrolliert
// /control/actors/actorXX/value"												gibt den zu schaltenden Wert; wird mit gepolltem Wert upgedated



#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <fcntl.h>
#include <termios.h>
#include <time.h>
#include <sys/time.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include "../sqlite/sqlite-3.7.3_arm/sqlite3.h"
#include "sqldb.h"
#include "powermeter_timer.h"
#include "logging.h"



// *****   Globale Variablen   *****

signed long int				timer_max_timers;																							// Anzahl tatschlich benutzter Timer
signed long int				timer_reload_counter;																					// Reload Counter
signed char						timer_enabled[MAX_TIMERS];																		// Timer Enabled 0/1
char									timer_name[MAX_TIMERS][40];																		// Timer Benennung
signed char						timer_start_monday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
signed char						timer_start_tuesday[MAX_TIMERS];															// Schaltzeitpunkt Wochentag
signed char						timer_start_wednesday[MAX_TIMERS];														// Schaltzeitpunkt Wochentag
signed char						timer_start_thursday[MAX_TIMERS];															// Schaltzeitpunkt Wochentag
signed char						timer_start_friday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
signed char						timer_start_saturday[MAX_TIMERS];															// Schaltzeitpunkt Wochentag
signed char						timer_start_sunday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
signed char						timer_start_hour[MAX_TIMERS];																	// Uhrzeit Stunde
signed char						timer_start_minute[MAX_TIMERS];																// Uhrzeit Minute
signed char						timer_start_second[MAX_TIMERS];																// Uhrzeit Sekunde
signed short int			timer_start_onoff[MAX_TIMERS];																// On/Off 0/1
signed short int			timer_start_actor[MAX_TIMERS];																// On/Off 0/1
signed char						timer_stop_monday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
signed char						timer_stop_tuesday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
signed char						timer_stop_wednesday[MAX_TIMERS];															// Schaltzeitpunkt Wochentag
signed char						timer_stop_thursday[MAX_TIMERS];															// Schaltzeitpunkt Wochentag
signed char						timer_stop_friday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
signed char						timer_stop_saturday[MAX_TIMERS];															// Schaltzeitpunkt Wochentag
signed char						timer_stop_sunday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
signed char						timer_stop_hour[MAX_TIMERS];																	// Uhrzeit Stunde
signed char						timer_stop_minute[MAX_TIMERS];																// Uhrzeit Minute
signed char						timer_stop_second[MAX_TIMERS];																// Uhrzeit Sekunde
signed short int			timer_stop_onoff[MAX_TIMERS];																	// On/Off 0/1
signed short int			timer_stop_actor[MAX_TIMERS];																	// On/Off 0/1
signed short int			timer_count;																									// Anzahl enabled Timers



// *****   all3075_schalte_egal() - Schalten von Slaves, egal was diese zurckmelden   *****

void all3075_schalte_egal(unsigned short int dosennummer,unsigned short int schaltwunsch)
	{
	char ep[512];
	char kommando[256];

	// printf("(exec)--ALL3075 Target:%d, Switch: %d\n",dosennummer,schaltwunsch);
	sprintf(kommando,"/usr/bin/php -q /www/all3075remote.php -s %d %d >/dev/null",dosennummer,schaltwunsch);
	// printf("cmd=%s\n",kommando);
	system(kommando);

	sprintf(ep,"all3075_schalte_egal(%d,%d)",dosennummer,schaltwunsch);
	log_append(4,ep);																			// Meldung ins Logfile schreiben
	}



// *****   plugwise_schalte_egal() - Schalten von Slaves, egal was diese zurckmelden   *****

void plugwise_schalte_egal(unsigned short int dosennummer,unsigned short int schaltwunsch)
	{
	char ep[512];
	char kommando[256];

	// printf("(exec)--Plugwise Target:%d, Switch: %d\n",dosennummer,schaltwunsch);
	sprintf(kommando,"/usr/sbin/plugwise_control %d %d >/dev/null",dosennummer,schaltwunsch);
	// printf("cmd=%s\n",kommando);
	system(kommando);

	sprintf(ep,"plugwise_schalte_egal(%d,%d)",dosennummer,schaltwunsch);
	log_append(4,ep);																			// Meldung ins Logfile schreiben
	}



// *****   timer_setzedefault()   -   Timertabelle auf Standardwerte setzen   *****

void timer_setzedefault(void)
	{
	unsigned short int t;

	for(t = 0;t < MAX_TIMERS;t++)
		{
		timer_enabled[t] = 0;																// Timer Enabled 0/1
		sprintf(timer_name[t],"Timer %d",t);								// Timer Benennung
		timer_start_monday[t] = 0;													// Schaltzeitpunkt Wochentag
		timer_start_tuesday[t] = 0;													// Schaltzeitpunkt Wochentag
		timer_start_wednesday[t] = 0;												// Schaltzeitpunkt Wochentag
		timer_start_thursday[t] = 0;												// Schaltzeitpunkt Wochentag
		timer_start_friday[t] = 0;													// Schaltzeitpunkt Wochentag
		timer_start_saturday[t] = 0;												// Schaltzeitpunkt Wochentag
		timer_start_sunday[t] = 0;													// Schaltzeitpunkt Wochentag
		timer_start_hour[t] = 0;														// Uhrzeit Stunde
		timer_start_minute[t] = 0;													// Uhrzeit Minute
		timer_start_second[t] = 0;													// Uhrzeit Sekunde
		timer_start_onoff[t] = 1;														// On/Off 0/1
		timer_start_actor[t] = -1;													// Ziel-Aktor
		timer_stop_monday[t] = 0;														// Schaltzeitpunkt Wochentag
		timer_stop_tuesday[t] = 0;													// Schaltzeitpunkt Wochentag
		timer_stop_wednesday[t] = 0;												// Schaltzeitpunkt Wochentag
		timer_stop_thursday[t] = 0;													// Schaltzeitpunkt Wochentag
		timer_stop_friday[t] = 0;														// Schaltzeitpunkt Wochentag
		timer_stop_saturday[t] = 0;													// Schaltzeitpunkt Wochentag
		timer_stop_sunday[t] = 0;														// Schaltzeitpunkt Wochentag
		timer_stop_hour[t] = 0;															// Uhrzeit Stunde
		timer_stop_minute[t] = 0;														// Uhrzeit Minute
		timer_stop_second[t] = 0;														// Uhrzeit Sekunde
		timer_stop_onoff[t] = 0;														// On/Off 0/1
		timer_stop_actor[t] = -1;														// Ziel-Aktor
		}
	}



// **********   Timer-Konfiguration einlesen   **********

void timer_readconfig(void)
	{
	char ep[1024];
	signed long int t;
	signed long int i;
	signed long int lcount;

	i = sqldb_read_long("/timers/max_timer");
	if(i > MAX_TIMERS)
		{
		sprintf(ep,"Configured value /timers/max_timer is %ld; larger than MAX_TIMERS, using MAX_TIMERS=%d instead.",i,MAX_TIMERS);
		log_append(2,ep);																			// Fehlermeldung ins Logfile schreiben
		timer_max_timers = MAX_TIMERS;
		}

	timer_setzedefault();
	lcount = 0;
	timer_reload_counter = sqldb_read_long("/timers/reload_timer");

	timer_count = 0;
	for(t = 0;t < i;t++)
		{
		sprintf(ep,"/timers/timer%ld/enabled",t);
		timer_enabled[t] = sqldb_read_long(ep);
		if(timer_enabled[t] > 0)
			{
			lcount++;
			timer_count++;

			sprintf(ep,"/timers/timer%ld/name",t);
			sqldb_read_string(ep,timer_name[t]);

			sprintf(ep,"/timers/timer%ld/start/mo",t);
			timer_start_monday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/tu",t);
			timer_start_tuesday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/we",t);
			timer_start_wednesday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/th",t);
			timer_start_thursday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/fr",t);
			timer_start_friday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/sa",t);
			timer_start_saturday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/su",t);
			timer_start_sunday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/hour",t);
			timer_start_hour[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/min",t);
			timer_start_minute[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/sec",t);
			timer_start_second[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/action",t);
			timer_start_onoff[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/actor",t);
			timer_start_actor[t] = sqldb_read_long(ep);

			sprintf(ep,"/timers/timer%ld/stop/mo",t);
			timer_stop_monday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/tu",t);
			timer_stop_tuesday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/we",t);
			timer_stop_wednesday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/th",t);
			timer_stop_thursday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/fr",t);
			timer_stop_friday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/sa",t);
			timer_stop_saturday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/su",t);
			timer_stop_sunday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/hour",t);
			timer_stop_hour[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/min",t);
			timer_stop_minute[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/sec",t);
			timer_stop_second[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/action",t);
			timer_stop_onoff[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/actor",t);
			timer_stop_actor[t] = sqldb_read_long(ep);
			}
		else
			{
			}
		}

	sprintf(ep,"Configuration data for %ld Timers read. (%d enabled)",lcount,timer_count);
	log_append(3,ep);																			// Meldung ins Logfile schreiben
	}



// *****   timer_execute   -   Timers prfen und abarbeiten   *****

void timer_execute(void)
	{
	char ep[256];
	signed long int t;
	signed long int now_sec;
	signed char now_tag;
	signed long int timer_sec;
	time_t timer;
	struct tm *tblock;


	timer = time(NULL);
	tblock = localtime(&timer);
	now_sec = tblock->tm_hour * 3600 + tblock->tm_min * 60 + tblock->tm_sec;
	now_tag = tblock->tm_wday; // 0:Sonntag, 1:Montag, ..., 6:Samstag

	// printf("TX (now=%ldsec, Tag:%d, %02d:%02d:%02d)\n",now_sec,now_tag,tblock->tm_hour,tblock->tm_min,tblock->tm_sec);
	for(t = 0;t < MAX_TIMERS;t++)
		{
		if(timer_enabled[t] > 0)
			{
			if ( ((timer_start_monday[t] > 0) && (now_tag == 1))
				|| ((timer_start_tuesday[t] > 0) && (now_tag == 2))
				|| ((timer_start_wednesday[t] > 0) && (now_tag == 3))
				|| ((timer_start_thursday[t] > 0) && (now_tag == 4))
				|| ((timer_start_friday[t] > 0) && (now_tag == 5))
				|| ((timer_start_saturday[t] > 0) && (now_tag == 6))
				|| ((timer_start_sunday[t] > 0) && (now_tag == 0)) )
				{
				timer_sec = timer_start_hour[t] * 3600 + timer_start_minute[t] * 60 + timer_start_second[t];
				// printf("T%ld (start=%ldsec, %02d:%02d:%02d)\n",t,timer_sec,timer_start_hour[t],timer_start_minute[t],timer_start_second[t]);
				if ((now_sec >= timer_sec) && (now_sec <= timer_sec + TIMER_GRACE_PERIOD))
					{
					// printf("TimerStart%ld: Actor%d:%d\n",t,timer_start_actor[t],timer_start_onoff[t]);
					if(timer_start_onoff[t] > 0)
						{
						if(timer_start_actor[t] >= 90)
							{
							all3075_schalte_egal(timer_start_actor[t] - 90,1);
							sprintf(ep,"TimerStart%ld: ALL3075_tActor %d ON",t,timer_start_actor[t] - 90);
							log_append(4,ep);															// Meldung ins Logfile schreiben
							}
						else
							{
							plugwise_schalte_egal(timer_start_actor[t],1);
							sprintf(ep,"TimerStart%ld: Plugwise_tActor %d ON",t,timer_start_actor[t]);
							log_append(4,ep);															// Meldung ins Logfile schreiben
							}
						}
					else
						{
						if(timer_start_actor[t] >= 90)
							{
							all3075_schalte_egal(timer_start_actor[t] - 90,0);
							sprintf(ep,"TimerStart%ld: ALL3075_tActor %d OFF",t,timer_start_actor[t] - 90);
							log_append(4,ep);															// Meldung ins Logfile schreiben
							}
						else
							{
							plugwise_schalte_egal(timer_start_actor[t],0);
							sprintf(ep,"TimerStart%ld: Plugwise_tActor %d OFF",t,timer_start_actor[t]);
							log_append(4,ep);															// Meldung ins Logfile schreiben
							}
						}
					}
				}

			if ( ((timer_stop_monday[t] > 0) && (now_tag == 1))
				|| ((timer_stop_tuesday[t] > 0) && (now_tag == 2))
				|| ((timer_stop_wednesday[t] > 0) && (now_tag == 3))
				|| ((timer_stop_thursday[t] > 0) && (now_tag == 4))
				|| ((timer_stop_friday[t] > 0) && (now_tag == 5))
				|| ((timer_stop_saturday[t] > 0) && (now_tag == 6))
				|| ((timer_stop_sunday[t] > 0) && (now_tag == 0)) )
				{
				timer_sec = timer_stop_hour[t] * 3600 + timer_stop_minute[t] * 60 + timer_stop_second[t];
				if ((now_sec >= timer_sec) && (now_sec <= timer_sec + TIMER_GRACE_PERIOD))
					{
					// printf("TimerStop%ld: Actor%d:%d\n",t,timer_start_actor[t],timer_start_onoff[t]);
					if(timer_stop_onoff[t] > 0)
						{
						if(timer_stop_actor[t] >= 90)
							{
							all3075_schalte_egal(timer_stop_actor[t] - 90,1);
							sprintf(ep,"TimerStop%ld: ALL3075_tActor %d ON",t,timer_stop_actor[t] - 90);
							log_append(4,ep);															// Meldung ins Logfile schreiben
							}
						else
							{
							plugwise_schalte_egal(timer_stop_actor[t],1);
							sprintf(ep,"TimerStop%ld: Plugwise_tActor %d ON",t,timer_stop_actor[t]);
							log_append(4,ep);															// Meldung ins Logfile schreiben
							}
						}
					else
						{
						if(timer_stop_actor[t] >= 90)
							{
							all3075_schalte_egal(timer_stop_actor[t] - 90,0);
							sprintf(ep,"TimerStop%ld: ALL3075_tActor %d OFF",t,timer_stop_actor[t] - 90);
							log_append(4,ep);															// Meldung ins Logfile schreiben
							}
						else
							{
							plugwise_schalte_egal(timer_stop_actor[t],0);
							sprintf(ep,"TimerStop%ld: Plugwise_tActor %d OFF",t,timer_stop_actor[t]);
							log_append(4,ep);															// Meldung ins Logfile schreiben
							}
						}
					}
				}

			}
		}
	}



// *****   Hauptschleife   *****

int main(int argc,char **argv)
	{
	unsigned long					ti = 0;													// Zhler, geht bei jedem Durchlauf um 1 hoch
	char									lstring[255];										// Puffer fr Logging
	char									ep[1024];												// Puffer fr Logfile-Meldungen


	// Logging-System initialisieren
	strcpy (log_filename,"/www/reports/powermeter_timer.log"); // Logfilenamen setzen
	log_level = 3;																				// Debuglevel setzen
	log_kill();																						// Logfile loeschen
	sprintf(ep,"----------   powermeter_timer started (debuglevel=%d)   ----------",log_level);
	log_append(1,ep);																			// Startmeldung ins Logfile schreiben





	// Einstellungen fr lokalen Timer
	timer_setzedefault();
	timer_readconfig();

	// Start loggen
	log_append(1,"**********   timer demon started   **********");
	sprintf(lstring,"%d timers read",timer_count);
	log_append(1,lstring);


	printf("Timer Demon started.\n");

hauptschleife:
	ti++;																									// Schleifenzhler erhhen
	usleep(250000);																				// 1/4 Sekunde Rechenzeit freigeben

	if (timer_reload_counter != sqldb_read_long("/timers/reload_timer"))
		{
		timer_readconfig();
		sprintf(ep,"Global Timer Configuration re-read.");
		log_append(1,ep);																		// Meldung ins Logfile schreiben
		goto hauptschleife;
		}

	timer_execute();																			// Timers abarbeiten
	goto hauptschleife;

	return(0);
	}
