// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   rgb_remote.c   -   Demon zum Abarbeiten der IR-Fernbedienungs-Signale fr ALL3651                             **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2011 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************

// **********   Eintrge in der Konfigurations-Datenbank, die vom Demon ausgewertet werden   **********
//
// TODO: Liste aktualisieren
// /control/rgb/bootdefault/b1													Startup



#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <string.h>
#include <netinet/in.h>
#include <fcntl.h>
#include <time.h>
#include <sys/time.h>
#include <sys/shm.h>
#include "at91gpio.h"
#include "all_i2c.h"
#include "i2c_chips.h"
#include "../sqlite/sqlite-3.7.3_arm/sqlite3.h"
#include "rgb_remote.h"
#include "sqldb.h"
#include "logging.h"
#include "shm_use.h"



// *****   Globale Variablen   *****

#define CONFIG_DATABASE_FILE "/etc/allnetenv/config.s3db"
#define VAR_DATABASE_FILE "/tmp/var.s3db"


signed short int	fernbedienung = -1;										// Typ der Fernbedienung (-1: Keine, 0: alte kleine FB mit altem Tiny85,
																												//                        1: PortaLuce FB mit neuem Tiny85,
																												//                        2: alte kleine FB mit neuem Tiny85)



// *****   rgb_set   -   wrapper fr sql_write_rgbvalues(ptr,   *****

void rgb_set (sqlite3 *ptr,unsigned char r0,unsigned char g0,unsigned char b0,unsigned char w0,unsigned char r1,unsigned char g1,unsigned char b1,unsigned char w1,unsigned char dim0,unsigned char dim1)
	{
	sql_write_rgbvalues(ptr,r0,g0,b0,w0,dim0,r1,g1,b1,w1,dim1);
	}



// *****   zufall_long - Ermitteln einer Zufallszahl zwischen 0...4294967295   *****

unsigned long int zufall_long() 
	{
	static long Wert_A = 26004;														// Random Seed A
	static long Wert_B = 26088;														// Random Seed B
	static long Letzte_ZahlX = 26004;											// old seed A
	static long Letzte_ZahlY = 26088;											// old seed B
	long x;
	long y;
	unsigned long int rw;

	x = Wert_A * (Letzte_ZahlX & 65535) + (Letzte_ZahlX >> 16);
	y = Wert_B * (Letzte_ZahlY & 65535) + (Letzte_ZahlY >> 16);

	rw = (x << 16) + (y & 65525);
	Letzte_ZahlX = x;
	Letzte_ZahlY = y;
	return (rw);
	}



// *****   sql_read_rgbvalues()   -   Daten aus der tmpDB holen   *****

void sql_read_rgbvalues(sqlite3 *ptr,unsigned char *r0,unsigned char *g0,unsigned char *b0,unsigned char *w0,unsigned char *d0,unsigned char *r1,unsigned char *g1,unsigned char *b1,unsigned char *w1,unsigned char *d1)
	{
	sqlite3_stmt *vm;
	char *sql_query;
	signed short int i = 0;
	char zs[96];
	signed short int rw;
	char sql[80] = "SELECT r0,g0,b0,w0,d0,r1,g1,b1,w1,d1 from rgboutput where id = 0;";


beginn:
	// printf("rgb_remote: read Start\n");
	//printf("SQL:\"%s\"\n",sql);
	sql_query = sqlite3_mprintf("%s",sql);								// Vorbereitung des SQL-Querys
	
	// Umwandlung des SQl Querys in Byte-code
	rw = sqlite3_prepare(ptr,sql_query,strlen(sql_query),&vm,NULL);
	if (rw != SQLITE_OK)
		{
		// printf("(Error %d bei \"%s\")\n",rw,sql);
		// printf("SQLITE Read lock problem !!!!!\n");
		sqlite3_finalize(vm);																// Loeschen des Statements
		sqlite3_free(sql_query);														// freigeben des Bytecodes
		usleep(25000);																			// 25 ms warten
		goto beginn;
		}

	// Ausgabe des Datensatzes
	while(sqlite3_step(vm) != SQLITE_DONE)
		{
		i++;
		if(sqlite3_column_text(vm,0) == NULL)
			{
			printf("rgb_remote: sql_read_rgbvalues: NULL Pointer als Result bei \"%s\" - alte Werte werden beibehalten !\n",sql);
/*
			*r0 = 0;
			*g0 = 0;
			*b0 = 0;
			*w0 = 0;
			*d0 = 0;
			*r1 = 0;
			*g1 = 0;
			*b1 = 0;
			*w1 = 0;
			*d1 = 0;
*/
			goto final;
			}
		// printf("%s\n",sqlite3_column_text(vm,0));						// Inhalt des Datensatzes ausgeben
		strcpy(zs,(char *)sqlite3_column_text(vm,0));				// String aus dem DB-Recordset kopieren
		// printf("RW0:\"%s\"\n",zs);
		*r0 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,1));				// String aus dem DB-Recordset kopieren
		*g0 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,2));				// String aus dem DB-Recordset kopieren
		*b0 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,3));				// String aus dem DB-Recordset kopieren
		*w0 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,4));				// String aus dem DB-Recordset kopieren
		*d0 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,5));				// String aus dem DB-Recordset kopieren
		*r1 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,6));				// String aus dem DB-Recordset kopieren
		*g1 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,7));				// String aus dem DB-Recordset kopieren
		*b1 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,8));				// String aus dem DB-Recordset kopieren
		*w1 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,9));				// String aus dem DB-Recordset kopieren
		*d1 = atol(zs);
		}
	if(i < 1)																							// wenn kein Datensatz, -1 zurckgeben
		{
		printf("rgb_remote: sql_read_rgbvalues: kein Datensatz - alte Werte werden beibehalten !\n");
/*
		*r0 = 0;
		*g0 = 0;
		*b0 = 0;
		*w0 = 0;
		*d0 = 0;
		*r1 = 0;
		*g1 = 0;
		*b1 = 0;
		*w1 = 0;
		*d1 = 0;
*/
		}

final:
	sqlite3_finalize(vm);																	// Loeschen des Statements
	sqlite3_free(sql_query);															// freigeben des Bytecodes
	// printf("rgb_remote: read Ende\n");
	}



// *****   sql_write_rgbvalues   -   Schreiben der RGB-Output-Werte in die tmpDB   *****

void sql_write_rgbvalues(sqlite3 *ptr,unsigned char r0,unsigned char g0,unsigned char b0,unsigned char w0,unsigned char d0,unsigned char r1,unsigned char g1,unsigned char b1,unsigned char w1,unsigned char d1)
	{
	char sql[255];

	// printf("rgb_remote: write Start\n");
	sprintf(sql,"UPDATE rgboutput SET r0=%d,g0=%d,b0=%d,w0=%d,d0=%d,r1=%d,g1=%d,b1=%d,w1=%d,d1=%d WHERE id = 0;",r0,g0,b0,w0,d0,r1,g1,b1,w1,d1);
	// printf("SQL: \"%s\"\n",sql);
	do_sqlyy(ptr,sql,0);
	// printf("rgb_remote: write Ende\n");
	}






// *****   sql_read_ir_keypress   -   Lesen der Fernbedienungs-Signale aus der tmpDB   *****

signed short int sql_read_ir_keypress(sqlite3 *ptr)
	{
	sqlite3_stmt *vm;
	char *sql_query;
	signed short int i = 0;
	char zs[96];
	signed short int rw;
	char sql[80] = "SELECT [ircounter],[ir] from [ir] where [id]=0;";
	static signed short int db_counter_old = 0;
	signed short int db_counter;
	signed short int db_keypress;


	//printf("SQL:\"%s\"\n",sql);
	sql_query = sqlite3_mprintf("%s",sql);								// Vorbereitung des SQL-Querys
	
	// Umwandlung des SQl Querys in Byte-code
	rw = sqlite3_prepare(ptr,sql_query,strlen(sql_query),&vm,NULL);
	if (rw != SQLITE_OK)
		{
		// printf("(Error %d bei \"%s\")\n",rw,sql);
		// printf("SQLITE Read lock problem !!!!!\n");
		sqlite3_finalize(vm);																// Loeschen des Statements
		sqlite3_free(sql_query);														// freigeben des Bytecodes
		rw = -999;																					// Rckmeldung: "Kein Tastendruck"
		goto ende;
		}

	// Ausgabe des Datensatzes
	while(sqlite3_step(vm) != SQLITE_DONE)
		{
		i++;
		if(sqlite3_column_text(vm,0) == NULL)
			{
			// printf("sql_read_ir_keypress: NULL Pointer als Result bei \"%s\" - alte Werte werden beibehalten !\n",sql);
			rw = -999;
			goto final;
			}
		// printf("%s\n",sqlite3_column_text(vm,0));						// Inhalt des Datensatzes ausgeben
		strcpy(zs,(char *)sqlite3_column_text(vm,0));				// String aus dem DB-Recordset kopieren
		// printf("RW0:\"%s\"\n",zs);
		db_counter = atoi(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,1));				// String aus dem DB-Recordset kopieren
		db_keypress = atoi(zs);
		if (db_counter != db_counter_old)
			{
			db_counter_old = db_counter;											// Counter merken
			rw = db_keypress;																	// Rckwert ist die aktuell gedrckte Taste
			}
		else
			{
			rw = -999;																				// Counter unverndert, also wurd keine Taste gedrckt
			}
		}
	if(i < 1)																							// wenn kein Datensatz, -1 zurckgeben
		{
		// printf("sql_read_ir_keypress: kein Datensatz - alte Werte werden beibehalten !\n");
		rw = -999;
		}

final:
	sqlite3_finalize(vm);																	// Loeschen des Statements
	sqlite3_free(sql_query);															// freigeben des Bytecodes

ende: return(rw);
	}



// *****   Blinken   *****

void blinke(sqlite3 *ptr,unsigned char kanaele)
	{
	unsigned short int w = 1000;
	unsigned char d = 0;
	unsigned char h = 50;

	if(kanaele == 1)
			{
			sql_write_rgbvalues(ptr,d,d,d,d,0,t_r1,t_g1,t_b1,t_w1,0);
			usleep(w);
			sql_write_rgbvalues(ptr,h,h,h,h,0,t_r1,t_g1,t_b1,t_w1,0);
			usleep(w);
			}
	if(kanaele == 2)
			{
			sql_write_rgbvalues(ptr,t_r0,t_g0,t_b0,t_w0,0,d,d,d,d,0);
			usleep(w);
			sql_write_rgbvalues(ptr,t_r0,t_g0,t_b0,t_w0,0,h,h,h,h,0);
			usleep(w);
			}
	if(kanaele == 3)
			{
			sql_write_rgbvalues(ptr,d,d,d,d,0,d,d,d,d,0);
			usleep(w);
			sql_write_rgbvalues(ptr,h,h,h,h,0,h,h,h,h,0);
			usleep(w);
			}

	sql_write_rgbvalues(ptr,t_r0,t_g0,t_b0,t_w0,0,t_r1,t_g1,t_b1,t_w1,0);
	usleep(w);
	sql_write_rgbvalues(ptr,t_r0,t_g0,t_b0,t_w0,t_dim0,t_r1,t_g1,t_b1,t_w1,t_dim1);
	}



// *****   Hauptschleife   *****

int main(int argc,char **argv)
	{
	unsigned char			t = 0;
	unsigned long			ti = 0;															// Zhler, geht bei jedem Durchlauf um 1 hoch
	signed long int		i;
	unsigned char			kanaele = 3;												// RGB-Kanle 0(1), 1(2), 0+1(3)  
	unsigned char			merk_t_r0 = 0;
	unsigned char			merk_t_g0 = 0;
	unsigned char			merk_t_b0 = 0;
	unsigned char			merk_t_w0 = 0;
	unsigned char			merk_t_r1 = 0;
	unsigned char			merk_t_g1 = 0;
	unsigned char			merk_t_b1 = 0;
	unsigned char			merk_t_w1 = 0;
	unsigned char			merk_rgb_farbe = 0;
	float							old_color;
	float							new_color;
	float							inc_faktor = 0.1;
	char							kommando[255];											// Kommandostring
	char							ep[1024];														// Puffer fr Logfile-Meldungen
	unsigned char			log_table[256];
	signed short int	lt;
	signed short int	t_ir = -999;												// Rckwert von der FB
	signed short int	t_ir_old = -999;										// alter Rckwert von der FB
	signed short int	az;																	// nderungszhler
	unsigned char 		old_r0 = 0;
	unsigned char 		old_g0 = 0;
	unsigned char 		old_b0 = 0;
	unsigned char 		old_w0 = 0;
	unsigned char 		old_dim0 = 0;
	unsigned char 		old_r1 = 0;
	unsigned char 		old_g1 = 0;
	unsigned char 		old_b1 = 0;
	unsigned char 		old_w1 = 0;
	unsigned char 		old_dim1 = 0;


	// auf existierendes Shared Memory fr Demonstatus zugreifen
	if (use_my_demonstatus_shm(3) != 1) goto errorende;		// MY_DEMON_ID = 1: rgb_remote

	// Status von Demon in SHM eintragen
	my_demonstatus_data[my_demon_id].demon_id = my_demon_id;														// 0 ist Default, hier wird die eigene ID eingetragen
	sprintf(my_demonstatus_data[my_demon_id].name_string,"rgb_remote");									// Name
	sprintf(my_demonstatus_data[my_demon_id].version_string,"%s",RGBREMOTE_VERSION);		// Versionsnummer
	my_demonstatus_data[my_demon_id].last_boot = time(0);																// Timestamp(UTC) des Starts
	my_demonstatus_data[my_demon_id].last_activity = time(0);														// Timestamp(UTC) der letzten Aktion
	my_demonstatus_data[my_demon_id].ti = ti;																						// Counter
	sprintf(my_demonstatus_data[my_demon_id].debug_message,"Start");										// letzte Debug-Meldung
	my_demonstatus_data[my_demon_id].error_message[0] = 0;															// letzte Fehlermeldung
	my_demonstatus_data[my_demon_id].status_long = 0;																		// numerischer Status
	sprintf(my_demonstatus_data[my_demon_id].status_string,"startup");									// String-Status

	// Logarithmen-Tabelle 
	for (lt = 0;lt <= 255;lt++)
		{
		i = lt / 8;
		if (i < 1) i = 1;
		log_table[lt] = i;
		}        

	// Logging-System initialisieren
	strcpy (log_filename,"/www/reports/rgb_remote.log");		// Logfilenamen setzen
	log_level = 4;																				// Debuglevel setzen
	log_kill();																						// Logfile loeschen
	sprintf(ep,"----------   rgb_remote V %s started (debuglevel=%d)   ----------",RGBREMOTE_VERSION,log_level);
	log_append(1,ep);																			// Startmeldung ins Logfile schreiben

	sqlite3_open(VAR_DATABASE_FILE,&sql_var_handle);			// SQLITE3-Datenbank ffnen

	// Einstellungen fr die Fernbedienung
	fernbedienung = sqldb_read_long("/control/rgb/remotecontrol/type");

	// Start loggen
	printf("RGB remote V %s started. (debuglevel:%d, FB_Type:%d)\n",RGBREMOTE_VERSION,log_level,fernbedienung);


	t_ir_old = sql_read_ir_keypress(sql_var_handle);			// aktuellen Wert als alten Wert holen

	update_demondebug("running");													// letzte Debug-Meldung
hauptschleife:
	update_demonstatus(ti,1,"main loop");									// Status von Demon in SHM aktualisieren

	usleep(1000);																					// 1 ms warten
	zufall_long();																				// Zufall immer schn mitlaufen lassen
	ti++;																									// Schleifenzhler erhhen
	// printf("ti=%ld\n",ti);





	// ----- IR-Fernbedienungstaste gedrckt ? Dann entsprechende Farbe setzen -----
	t_ir = sql_read_ir_keypress(sql_var_handle);
	if (t_ir != -999)
		{
		update_demonstatus(ti,100,"keypress");							// Status von Demon in SHM aktualisieren
		sprintf(ep,"Keycode:%d",t_ir);
		update_demondebug(ep);															// Status von Demon in SHM aktualisieren
		// printf("rgb_remote: Taste mit Code %d gedrckt **\n",t_ir);
		if (fernbedienung < 0) goto ignore_ir_remote;				// -1 ignoriert alles, was da reinkommt


		// ----- RGB-Werte aus der tmpDB lesen -----
		update_demonstatus(ti,101,"RGB read");							// Status von Demon in SHM aktualisieren
		sql_read_rgbvalues(sql_var_handle,&t_r0,&t_g0,&t_b0,&t_w0,&t_dim0,&t_r1,&t_g1,&t_b1,&t_w1,&t_dim1);
		// printf("R0:%d,G0:%d,B0:%d,W0:%d,  R1:%d,G1:%d,B1:%d,W1:%d\n",t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1);


		if (fernbedienung == 2)															// alte Fernbedienung mit neuem Attiny85
		{
		// printf("FB2 Taste %d\n",t_ir);
		if (t_ir == 96)																			// Taste "OFF"
			{
			if ((t_r0 > 0) || (t_g0 > 0) || (t_b0 > 0) || (t_r1 > 0) || (t_g1 > 0) || (t_b1 > 0)) // Wenn schon aus ist, nicht nochmal speichern !
				{
				merk_t_r0 = t_r0;																// RGB-Werte merken
				merk_t_g0 = t_g0;
				merk_t_b0 = t_b0;
				merk_t_w0 = t_w0;
				merk_t_r1 = t_r1;
				merk_t_g1 = t_g1;
				merk_t_b1 = t_b1;
				merk_t_w1 = t_w1;
				t_r0 = 0;																				// RGB-Werte auf 0 setzen
				t_g0 = 0;
				t_b0 = 0;
				t_w0 = 0;
				t_r1 = 0;
				t_g1 = 0;
				t_b1 = 0;
				t_w1 = 0;
				}
			}
		if (t_ir == 224)																		// Taste "ON"
			{
			if ((merk_t_r0 == 0) && (merk_t_g0 == 0) && (merk_t_b0 == 0) && (merk_t_w0 == 0) && (merk_t_r1 == 0) && (merk_t_g1 == 0) && (merk_t_b1 == 0) && (merk_t_w1 == 0))
				{
				t_r0 = 255;
				t_g0 = 255;
				t_b0 = 255;
				t_w0 = 255;
				t_r1 = 255;
				t_g1 = 255;
				t_b1 = 255;
				t_w1 = 255;
				}
			else
				{
				t_r0 = merk_t_r0;																// gemerkte RGB-Werte zurckholen
				t_g0 = merk_t_g0;
				t_b0 = merk_t_b0;
				t_w0 = merk_t_w0;
				t_r1 = merk_t_r1;
				t_g1 = merk_t_g1;
				t_b1 = merk_t_b1;
				t_w1 = merk_t_w1;
				}
			}
		if (t_ir == 240)																		// Taste "FLASH"
			{
			if ((kanaele == 1) || (kanaele == 3)) t_dim0 = 0;
			if ((kanaele == 2) || (kanaele == 3)) t_dim1 = 0;
			}
		if (t_ir == 232)																		// Taste "STROBE"
			{
			if ((kanaele == 1) || (kanaele == 3)) t_dim0 = 1;
			if ((kanaele == 2) || (kanaele == 3)) t_dim1 = 1;
			}
		if (t_ir == 216)																		// Taste "FADE"
			{
			if ((kanaele == 1) || (kanaele == 3)) t_dim0 = 4;
			if ((kanaele == 2) || (kanaele == 3)) t_dim1 = 4;
			}
		if (t_ir == 200)																		// Taste "SMOOTH"
			{
			if ((kanaele == 1) || (kanaele == 3)) t_dim0 = 20;
			if ((kanaele == 2) || (kanaele == 3)) t_dim1 = 20;
			}
		if (t_ir == 208)																		// Taste "W"
			{
			if (++kanaele > 3) kanaele = 1;
			if (kanaele == 1)
				{
				rgb_set(sql_var_handle,255,255,255,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,0,0,0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			if (kanaele == 2)
				{
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,255,255,255,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,0,0,0,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			if (kanaele == 3)
				{
				rgb_set(sql_var_handle,255,255,255,t_w0,255,255,255,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,0,0,0,t_w0,0,0,0,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,t_dim0,t_dim1);
			}
		if (t_ir == 144)																		// Taste "R"
			{
			merk_rgb_farbe = 'R';
			if (kanaele == 1)
				{
				rgb_set(sql_var_handle,255,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			if (kanaele == 2)
				{
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,255,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,0,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			if (kanaele == 3)
				{
				rgb_set(sql_var_handle,255,t_g0,t_b0,t_w0,255,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,0,t_g0,t_b0,t_w0,0,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			}
		if (t_ir == 16)	                    // Taste "G"
			{
			merk_rgb_farbe = 'G';
			if (kanaele == 1)
				{
				rgb_set(sql_var_handle,t_r0,255,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			if (kanaele == 2)
				{
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,255,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,0,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			if (kanaele == 3)
				{
				rgb_set(sql_var_handle,t_r0,255,t_b0,t_w0,t_r1,255,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,0,t_b0,t_w0,t_r1,0,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			}
		if (t_ir == 80)																		// Taste "B"
			{
			merk_rgb_farbe = 'B';
			if (kanaele == 1)
				{
				rgb_set(sql_var_handle,t_r0,t_g0,255,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			if (kanaele == 2)
				{
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_w1,255,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_w1,0,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			if (kanaele == 3)
				{
				rgb_set(sql_var_handle,t_r0,t_g0,255,t_w0,t_r1,t_g1,t_w1,255,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,0,t_w0,t_r1,t_g1,0,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			}
		if (t_ir == 160)																		// Taste "+"
			{
			if (merk_rgb_farbe == 'R')
				{
				if (kanaele == 1)
					{
					old_color = (float)t_r0;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255)
						{
						new_color = 255;
						rgb_set(sql_var_handle,0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_r0)) i++;
					t_r0 = i;
					}
				if (kanaele == 2)
					{
					old_color = (float)t_r1;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255)
						{
						new_color = 255;
						rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,0,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_r1)) i++;
					t_r1 = i;
					}
				if (kanaele == 3)
					{
					old_color = (float)t_r0;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255) new_color = 255;
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_r0)) i++;
					t_r0 = i;
					old_color = (float)t_r1;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255) new_color = 255;
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_r1)) i++;
					t_r1 = i;
					if ((t_r0 >= 255) || (t_r1 >= 255))
						{
						rgb_set(sql_var_handle,0,t_g0,t_b0,t_w0,0,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					}
				}
			if (merk_rgb_farbe == 'G')
				{
				if (kanaele == 1)
					{
					old_color = (float)t_g0;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255)
						{
						new_color = 255;
						rgb_set(sql_var_handle,t_r0,0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_g0)) i++;
					t_g0 = i;
					}
				if (kanaele == 2)
					{
					old_color = (float)t_g1;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255)
						{
						new_color = 255;
						rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,0,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_g1)) i++;
					t_g1 = i;
					}
				if (kanaele == 3)
					{
					old_color = (float)t_g0;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255) new_color = 255;
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_g0)) i++;
					t_g0 = i;
					old_color = (float)t_g1;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255) new_color = 255;
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_g1)) i++;
					t_g1 = i;
					if ((t_g0 >= 255) || (t_g1 >= 255))
						{
						rgb_set(sql_var_handle,t_r0,0,t_b0,t_w0,t_r1,0,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					}
				}
			if (merk_rgb_farbe == 'B')
				{
				if (kanaele == 1)
					{
					old_color = (float)t_b0;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255)
						{
						new_color = 255;
						rgb_set(sql_var_handle,t_r0,t_g0,0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_b0)) i++;
					t_b0 = i;
					}
				if (kanaele == 2)
					{
					old_color = (float)t_b1;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255)
						{
						new_color = 255;
						rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,0,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_b1)) i++;
					t_b1 = i;
					}
				if (kanaele == 3)
					{
					old_color = (float)t_b0;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255) new_color = 255;
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_b0)) i++;
					t_b0 = i;
					old_color = (float)t_b1;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255) new_color = 255;
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_b1)) i++;
					t_b1 = i;
					if ((t_b0 >= 255) || (t_b1 >= 255))
						{
						rgb_set(sql_var_handle,t_r0,t_g0,0,t_w0,t_r1,t_g1,0,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					}
				}
			}
		if (t_ir == 32)																		// Taste "-"
			{
			if (merk_rgb_farbe == 'R')
				{
				if (kanaele == 1)
					{
					old_color = (float)t_r0;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0)
						{
						new_color = 0;
						rgb_set(sql_var_handle,64,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_r0)) i--;
					t_r0 = i;
					}
				if (kanaele == 2)
					{
					old_color = (float)t_r1;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0)
						{
						new_color = 0;
						rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,64,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_r1)) i--;
					t_r1 = i;
					}
				if (kanaele == 3)
					{
					old_color = (float)t_r0;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0) new_color = 0;
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_r0)) i--;
					t_r0 = i;
					old_color = (float)t_r1;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0) new_color = 0;
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_r1)) i--;
					t_r1 = i;
					if ((t_r0 == 0) || (t_r1 == 0))
						{
						rgb_set(sql_var_handle,64,t_g0,t_b0,t_w0,64,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					}
				}
			if (merk_rgb_farbe == 'G')
				{
				if (kanaele == 1)
					{
					old_color = (float)t_g0;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0)
						{
						new_color = 0;
						rgb_set(sql_var_handle,t_r0,64,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_g0)) i--;
					t_g0 = i;
					}
				if (kanaele == 2)
					{
					old_color = (float)t_g1;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0)
						{
						new_color = 0;
						rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r0,64,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_g1)) i--;
					t_g1 = i;
					}
				if (kanaele == 3)
					{
					old_color = (float)t_g0;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0) new_color = 0;
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_g0)) i--;
					t_g0 = i;
					old_color = (float)t_g1;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0) new_color = 0;
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_g1)) i--;
					t_g1 = i;
					if ((t_g0 == 0) || (t_g1 == 0))
						{
						rgb_set(sql_var_handle,t_r0,64,t_b0,t_w0,t_r1,64,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					}
				}
			if (merk_rgb_farbe == 'B')
				{
				if (kanaele == 1)
					{
					old_color = (float)t_b0;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0)
						{
						new_color = 0;
						rgb_set(sql_var_handle,t_r0,t_g0,64,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_b0)) i--;
					t_b0 = i;
					}
				if (kanaele == 2)
					{
					old_color = (float)t_b1;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0)
						{
						new_color = 0;
						rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,64,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_b1)) i--;
					t_b1 = i;
					}
				if (kanaele == 3)
					{
					old_color = (float)t_b0;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0) new_color = 0;
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_b0)) i--;
					t_b0 = i;
					old_color = (float)t_b1;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0) new_color = 0;
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_b1)) i--;
					t_b1 = i;
					if ((t_b0 == 0) || (t_b1 == 0))
						{
						rgb_set(sql_var_handle,t_r0,t_g0,64,t_w0,t_r1,t_g1,64,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					}
				}
		}
		if (t_ir == 176)																		// Taste "Preset a" 100% Rot
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 255;
				t_g0 = 0;
				t_b0 = 0;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 255;
				t_g1 = 0;
				t_b1 = 0;
				}
			}
		if (t_ir == 168)																		// Taste "Preset d" 100% Rot, 25% Grn
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 255;
				t_g0 = 64;
				t_b0 = 0;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 255;
				t_g1 = 64;
				t_b1 = 0;
				}
			}
		if (t_ir == 152)																		// Taste "Preset g" 100% Rot, 50% Grn
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 255;
				t_g0 = 128;
				t_b0 = 0;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 255;
				t_g1 = 128;
				t_b1 = 0;
				}
			}
		if (t_ir == 136)																		// Taste "Preset j" 100% Rot, 100% Grn
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 255;
				t_g0 = 255;
				t_b0 = 0;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 255;
				t_g1 = 255;
				t_b1 = 0;
				}
			}
		if (t_ir == 48)																		// Taste "Preset b" 100% Grn, 50 % Blau
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 0;
				t_g0 = 255;
				t_b0 = 128;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 0;
				t_g1 = 255;
				t_b1 = 128;
				}
			}
		if (t_ir == 40)																		// Taste "Preset e" 75% Grn, 75 % Blau
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 0;
				t_g0 = 192;
				t_b0 = 192;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 0;
				t_g1 = 192;
				t_b1 = 192;
				}
			}
		if (t_ir == 24)																		// Taste "Preset h" 50% Grn, 100% Blau
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 0;
				t_g0 = 128;
				t_b0 = 255;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 0;
				t_g1 = 128;
				t_b1 = 255;
				}
			}
		if (t_ir == 8)																		// Taste "Preset k" 25% Grn, 100 % Blau
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 0;
				t_g0 = 64;
				t_b0 = 255;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 0;
				t_g1 = 64;
				t_b1 = 255;
				}
			}
		if (t_ir == 112)																		// Taste "Preset c" 100 % Blau
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 0;
				t_g0 = 0;
				t_b0 = 255;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 0;
				t_g1 = 0;
				t_b1 = 255;
				}
			}
		if (t_ir == 104)																		// Taste "Preset f" 100 % Blau, 25% Rot
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 64;
				t_g0 = 0;
				t_b0 = 255;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 64;
				t_g1 = 0;
				t_b1 = 255;
				}
			}
		if (t_ir == 88)																		// Taste "Preset i" 100 % Blau, 50% Rot
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 128;
				t_g0 = 0;
				t_b0 = 255;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 128;
				t_g1 = 0;
				t_b1 = 255;
				}
			}
		if (t_ir == 72)																		// Taste "Preset l" 100 % Blau, 100% Rot
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 255;
				t_g0 = 0;
				t_b0 = 255;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 255;
				t_g1 = 0;
				t_b1 = 255;
				}
			}
		}

	if (fernbedienung == 0)															// alte Fernbedienung mit altem Attiny85
		{
		// printf("FB0 Taste %d\n",t_ir);
		if (t_ir == '0')																		// Taste "OFF"
			{
			if ((t_r0 > 0) || (t_g0 > 0) || (t_b0 > 0) || (t_r1 > 0) || (t_g1 > 0) || (t_b1 > 0)) // Wenn schon aus ist, nicht nochmal speichern !
				{
				merk_t_r0 = t_r0;																// RGB-Werte merken
				merk_t_g0 = t_g0;
				merk_t_b0 = t_b0;
				merk_t_w0 = t_w0;
				merk_t_r1 = t_r1;
				merk_t_g1 = t_g1;
				merk_t_b1 = t_b1;
				merk_t_w1 = t_w1;
				t_r0 = 0;																				// RGB-Werte auf 0 setzen
				t_g0 = 0;
				t_b0 = 0;
				t_w0 = 0;
				t_r1 = 0;
				t_g1 = 0;
				t_b1 = 0;
				t_w1 = 0;
				}
			}
		if (t_ir == '1')																		// Taste "ON"
			{
			if ((merk_t_r0 == 0) && (merk_t_g0 == 0) && (merk_t_b0 == 0) && (merk_t_w0 == 0) && (merk_t_r1 == 0) && (merk_t_g1 == 0) && (merk_t_b1 == 0) && (merk_t_w1 == 0))
				{
				t_r0 = 255;
				t_g0 = 255;
				t_b0 = 255;
				t_w0 = 255;
				t_r1 = 255;
				t_g1 = 255;
				t_b1 = 255;
				t_w1 = 255;
				}
			else
				{
				t_r0 = merk_t_r0;																// gemerkte RGB-Werte zurckholen
				t_g0 = merk_t_g0;
				t_b0 = merk_t_b0;
				t_w0 = merk_t_w0;
				t_r1 = merk_t_r1;
				t_g1 = merk_t_g1;
				t_b1 = merk_t_b1;
				t_w1 = merk_t_w1;
				}
			}
		if (t_ir == 'F')																		// Taste "FLASH"
			{
			if ((kanaele == 1) || (kanaele == 3)) t_dim0 = 0;
			if ((kanaele == 2) || (kanaele == 3)) t_dim1 = 0;
			}
		if (t_ir == 'L')																		// Taste "STROBE"
			{
			if ((kanaele == 1) || (kanaele == 3)) t_dim0 = 1;
			if ((kanaele == 2) || (kanaele == 3)) t_dim1 = 1;
			}
		if (t_ir == 'A')																		// Taste "FADE"
			{
			if ((kanaele == 1) || (kanaele == 3)) t_dim0 = 4;
			if ((kanaele == 2) || (kanaele == 3)) t_dim1 = 4;
			}
		if (t_ir == 'S')																		// Taste "SMOOTH"
			{
			if ((kanaele == 1) || (kanaele == 3)) t_dim0 = 20;
			if ((kanaele == 2) || (kanaele == 3)) t_dim1 = 20;
			}
		if (t_ir == 'W')																		// Taste "W"
			{
			if (++kanaele > 3) kanaele = 1;
			if (kanaele == 1)
				{
				rgb_set(sql_var_handle,255,255,255,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,0,0,0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			if (kanaele == 2)
				{
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,255,255,255,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,0,0,0,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			if (kanaele == 3)
				{
				rgb_set(sql_var_handle,255,255,255,t_w0,255,255,255,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,0,0,0,t_w0,0,0,0,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,t_dim0,t_dim1);
			}
		if (t_ir == 'R')																		// Taste "R"
			{
			merk_rgb_farbe = 'R';
			if (kanaele == 1)
				{
				rgb_set(sql_var_handle,255,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			if (kanaele == 2)
				{
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,255,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,0,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			if (kanaele == 3)
				{
				rgb_set(sql_var_handle,255,t_g0,t_b0,t_w0,255,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,0,t_g0,t_b0,t_w0,0,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			}
		if (t_ir == 'G')                    // Taste "G"
			{
			merk_rgb_farbe = 'G';
			if (kanaele == 1)
				{
				rgb_set(sql_var_handle,t_r0,255,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			if (kanaele == 2)
				{
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,255,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,0,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			if (kanaele == 3)
				{
				rgb_set(sql_var_handle,t_r0,255,t_b0,t_w0,t_r1,255,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,0,t_b0,t_w0,t_r1,0,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			}
		if (t_ir == 'B')																		// Taste "B"
			{
			merk_rgb_farbe = 'B';
			if (kanaele == 1)
				{
				rgb_set(sql_var_handle,t_r0,t_g0,255,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			if (kanaele == 2)
				{
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_w1,255,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_w1,0,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			if (kanaele == 3)
				{
				rgb_set(sql_var_handle,t_r0,t_g0,255,t_w0,t_r1,t_g1,t_w1,255,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,0,t_w0,t_r1,t_g1,0,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
				usleep(30000); // delay_ms(30);
				}
			}
		if (t_ir == '+')																		// Taste "+"
			{
			if (merk_rgb_farbe == 'R')
				{
				if (kanaele == 1)
					{
					old_color = (float)t_r0;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255)
						{
						new_color = 255;
						rgb_set(sql_var_handle,0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_r0)) i++;
					t_r0 = i;
					}
				if (kanaele == 2)
					{
					old_color = (float)t_r1;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255)
						{
						new_color = 255;
						rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,0,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_r1)) i++;
					t_r1 = i;
					}
				if (kanaele == 3)
					{
					old_color = (float)t_r0;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255) new_color = 255;
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_r0)) i++;
					t_r0 = i;
					old_color = (float)t_r1;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255) new_color = 255;
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_r1)) i++;
					t_r1 = i;
					if ((t_r0 >= 255) || (t_r1 >= 255))
						{
						rgb_set(sql_var_handle,0,t_g0,t_b0,t_w0,0,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					}
				}
			if (merk_rgb_farbe == 'G')
				{
				if (kanaele == 1)
					{
					old_color = (float)t_g0;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255)
						{
						new_color = 255;
						rgb_set(sql_var_handle,t_r0,0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_g0)) i++;
					t_g0 = i;
					}
				if (kanaele == 2)
					{
					old_color = (float)t_g1;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255)
						{
						new_color = 255;
						rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,0,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_g1)) i++;
					t_g1 = i;
					}
				if (kanaele == 3)
					{
					old_color = (float)t_g0;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255) new_color = 255;
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_g0)) i++;
					t_g0 = i;
					old_color = (float)t_g1;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255) new_color = 255;
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_g1)) i++;
					t_g1 = i;
					if ((t_g0 >= 255) || (t_g1 >= 255))
						{
						rgb_set(sql_var_handle,t_r0,0,t_b0,t_w0,t_r1,0,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					}
				}
			if (merk_rgb_farbe == 'B')
				{
				if (kanaele == 1)
					{
					old_color = (float)t_b0;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255)
						{
						new_color = 255;
						rgb_set(sql_var_handle,t_r0,t_g0,0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_b0)) i++;
					t_b0 = i;
					}
				if (kanaele == 2)
					{
					old_color = (float)t_b1;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255)
						{
						new_color = 255;
						rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,0,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_b1)) i++;
					t_b1 = i;
					}
				if (kanaele == 3)
					{
					old_color = (float)t_b0;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255) new_color = 255;
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_b0)) i++;
					t_b0 = i;
					old_color = (float)t_b1;
					new_color = old_color * (1 + inc_faktor);
					if (new_color >= 255) new_color = 255;
					i = (unsigned char)new_color;
					if ((i < 255) && (i == t_b1)) i++;
					t_b1 = i;
					if ((t_b0 >= 255) || (t_b1 >= 255))
						{
						rgb_set(sql_var_handle,t_r0,t_g0,0,t_w0,t_r1,t_g1,0,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					}
				}
			}
		if (t_ir == '-')																		// Taste "-"
			{
			if (merk_rgb_farbe == 'R')
				{
				if (kanaele == 1)
					{
					old_color = (float)t_r0;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0)
						{
						new_color = 0;
						rgb_set(sql_var_handle,64,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_r0)) i--;
					t_r0 = i;
					}
				if (kanaele == 2)
					{
					old_color = (float)t_r1;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0)
						{
						new_color = 0;
						rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,64,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_r1)) i--;
					t_r1 = i;
					}
				if (kanaele == 3)
					{
					old_color = (float)t_r0;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0) new_color = 0;
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_r0)) i--;
					t_r0 = i;
					old_color = (float)t_r1;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0) new_color = 0;
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_r1)) i--;
					t_r1 = i;
					if ((t_r0 == 0) || (t_r1 == 0))
						{
						rgb_set(sql_var_handle,64,t_g0,t_b0,t_w0,64,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					}
				}
			if (merk_rgb_farbe == 'G')
				{
				if (kanaele == 1)
					{
					old_color = (float)t_g0;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0)
						{
						new_color = 0;
						rgb_set(sql_var_handle,t_r0,64,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_g0)) i--;
					t_g0 = i;
					}
				if (kanaele == 2)
					{
					old_color = (float)t_g1;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0)
						{
						new_color = 0;
						rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r0,64,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_g1)) i--;
					t_g1 = i;
					}
				if (kanaele == 3)
					{
					old_color = (float)t_g0;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0) new_color = 0;
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_g0)) i--;
					t_g0 = i;
					old_color = (float)t_g1;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0) new_color = 0;
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_g1)) i--;
					t_g1 = i;
					if ((t_g0 == 0) || (t_g1 == 0))
						{
						rgb_set(sql_var_handle,t_r0,64,t_b0,t_w0,t_r1,64,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					}
				}
			if (merk_rgb_farbe == 'B')
				{
				if (kanaele == 1)
					{
					old_color = (float)t_b0;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0)
						{
						new_color = 0;
						rgb_set(sql_var_handle,t_r0,t_g0,64,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_b0)) i--;
					t_b0 = i;
					}
				if (kanaele == 2)
					{
					old_color = (float)t_b1;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0)
						{
						new_color = 0;
						rgb_set(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,64,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_b1)) i--;
					t_b1 = i;
					}
				if (kanaele == 3)
					{
					old_color = (float)t_b0;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0) new_color = 0;
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_b0)) i--;
					t_b0 = i;
					old_color = (float)t_b1;
					new_color = old_color * (1 - inc_faktor);
					if (new_color <= 0) new_color = 0;
					i = (unsigned char)new_color;
					if ((i > 0) && (i == t_b1)) i--;
					t_b1 = i;
					if ((t_b0 == 0) || (t_b1 == 0))
						{
						rgb_set(sql_var_handle,t_r0,t_g0,64,t_w0,t_r1,t_g1,64,t_w1,0,0);
						usleep(30000); // delay_ms(30);
						}
					}
				}
		}
		if (t_ir == 'a')																		// Taste "Preset a" 100% Rot
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 255;
				t_g0 = 0;
				t_b0 = 0;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 255;
				t_g1 = 0;
				t_b1 = 0;
				}
			}
		if (t_ir == 'd')																		// Taste "Preset d" 100% Rot, 25% Grn
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 255;
				t_g0 = 64;
				t_b0 = 0;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 255;
				t_g1 = 64;
				t_b1 = 0;
				}
			}
		if (t_ir == 'g')																		// Taste "Preset g" 100% Rot, 50% Grn
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 255;
				t_g0 = 128;
				t_b0 = 0;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 255;
				t_g1 = 128;
				t_b1 = 0;
				}
			}
		if (t_ir == 'j')																		// Taste "Preset g" 100% Rot, 100% Grn
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 255;
				t_g0 = 255;
				t_b0 = 0;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 255;
				t_g1 = 255;
				t_b1 = 0;
				}
			}
		if (t_ir == 'b')																		// Taste "Preset b" 100% Grn, 50 % Blau
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 0;
				t_g0 = 255;
				t_b0 = 128;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 0;
				t_g1 = 255;
				t_b1 = 128;
				}
			}
		if (t_ir == 'e')																		// Taste "Preset e" 75% Grn, 75 % Blau
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 0;
				t_g0 = 192;
				t_b0 = 192;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 0;
				t_g1 = 192;
				t_b1 = 192;
				}
			}
		if (t_ir == 'h')																		// Taste "Preset h" 50% Grn, 100% Blau
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 0;
				t_g0 = 128;
				t_b0 = 255;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 0;
				t_g1 = 128;
				t_b1 = 255;
				}
			}
		if (t_ir == 'k')																		// Taste "Preset k" 25% Grn, 100 % Blau
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 0;
				t_g0 = 64;
				t_b0 = 255;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 0;
				t_g1 = 64;
				t_b1 = 255;
				}
			}
		if (t_ir == 'c')																		// Taste "Preset c" 100 % Blau
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 0;
				t_g0 = 0;
				t_b0 = 255;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 0;
				t_g1 = 0;
				t_b1 = 255;
				}
			}
		if (t_ir == 'f')																		// Taste "Preset f" 100 % Blau, 25% Rot
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 64;
				t_g0 = 0;
				t_b0 = 255;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 64;
				t_g1 = 0;
				t_b1 = 255;
				}
			}
		if (t_ir == 'i')																		// Taste "Preset i" 100 % Blau, 50% Rot
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 128;
				t_g0 = 0;
				t_b0 = 255;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 128;
				t_g1 = 0;
				t_b1 = 255;
				}
			}
		if (t_ir == 'l')																		// Taste "Preset l" 100 % Blau, 100% Rot
			{
			if ((kanaele == 1) || (kanaele == 3))
				{
				t_r0 = 255;
				t_g0 = 0;
				t_b0 = 255;
				}
			if ((kanaele == 2) || (kanaele == 3))
				{
				t_r1 = 255;
				t_g1 = 0;
				t_b1 = 255;
				}
			}
		}

// prfeFB
		if (fernbedienung == 1)															// neue Fernbedienung mit neuem Attiny85
			{
			// printf("FB1 Taste %d\n",t_ir);
			if (t_ir == 130)																		// Taste "OFF"
				{
				if ((t_r0 > 0) || (t_g0 > 0) || (t_b0 > 0) || (t_w0 > 0) || (t_r1 > 0) || (t_g1 > 0) || (t_b1 > 0) || (t_w1 > 0)) // Wenn schon aus ist, nicht nochmal speichern !
					{
					merk_t_r0 = t_r0;																// RGB-Werte merken
					merk_t_g0 = t_g0;
					merk_t_b0 = t_b0;
					merk_t_w0 = t_w0;
					merk_t_r1 = t_r1;
					merk_t_g1 = t_g1;
					merk_t_b1 = t_b1;
					merk_t_w1 = t_w1;
					t_r0 = 0;																				// RGB-Werte auf 0 setzen
					t_g0 = 0;
					t_b0 = 0;
					t_w0 = 0;
					t_r1 = 0;
					t_g1 = 0;
					t_b1 = 0;
					t_w1 = 0;
					}
				}
			if (t_ir == 2)																			// Taste "ON"
				{
				if ((merk_t_r0 == 0) && (merk_t_g0 == 0) && (merk_t_b0 == 0) && (merk_t_w0 == 0) && (merk_t_r1 == 0) && (merk_t_g1 == 0) && (merk_t_b1 == 0) && (merk_t_w1 == 0))
					{
					t_r0 = 255;
					t_g0 = 255;
					t_b0 = 255;
					t_w0 = 255;
					t_r1 = 255;
					t_g1 = 255;
					t_b1 = 255;
					t_w1 = 255;
					}
				else
					{
					t_r0 = merk_t_r0;																// gemerkte RGB-Werte zurckholen
					t_g0 = merk_t_g0;
					t_b0 = merk_t_b0;
					t_w0 = merk_t_w0;
					t_r1 = merk_t_r1;
					t_g1 = merk_t_g1;
					t_b1 = merk_t_b1;
					t_w1 = merk_t_w1;
					}
				}
			if (t_ir == 40)																			// Taste "Fast"
				{
				if ((kanaele == 1) || (kanaele == 3)) t_dim0 = 0;
				if ((kanaele == 2) || (kanaele == 3)) t_dim1 = 0;
				}
			if (t_ir == 168)																		// Taste "Med"
				{
				if ((kanaele == 1) || (kanaele == 3)) t_dim0 = 2;
				if ((kanaele == 2) || (kanaele == 3)) t_dim1 = 2;
				}
			if (t_ir == 104)																		// Taste "Slow"
				{
				if ((kanaele == 1) || (kanaele == 3)) t_dim0 = 10;
				if ((kanaele == 2) || (kanaele == 3)) t_dim1 = 10;
				}
			if (t_ir == 50)																			// Taste "Channel 0"
				{
				kanaele = 1;
				blinke(sql_var_handle,kanaele);
				}
			if (t_ir == 248)																		// Taste "Channel 1"
				{
				kanaele = 2;
				blinke(sql_var_handle,kanaele);
				}
			if (t_ir == 216)																		// Taste "Channels 0+1"
				{
				kanaele = 3;
				blinke(sql_var_handle,kanaele);
				}
			if (t_ir == 26)																			// Taste "R+"
				{
				if ((kanaele == 1) || (kanaele == 3))							// Channel 0
					{
					if (t_r0 <= 255)
						{
						if (255 - t_r0 > log_table[t_r0])
							{
							t_r0 += log_table[t_r0];
							}
						else
							{
							t_r0 = 255; 
							}
						}
					}
				if ((kanaele == 2) || (kanaele == 3))						// Channel 1
					{
					if (t_r1 <= 255)
						{
						if (255 - t_r1 > log_table[t_r1])
							{
							t_r1 += log_table[t_r1];
							}
						else
							{
							t_r1 = 255;
							}
						}
					}
				if((t_r0 >= 255) || (t_r1 >= 255))
					{
					blinke(sql_var_handle,kanaele);
					}
				}
			if (t_ir == 42)																			// Taste "R-"
				{
				if ((kanaele == 1) || (kanaele == 3))							// Channel 0
					{
					if (t_r0 >= 0)
						{
						if (t_r0 >= log_table[t_r0])
							{
							t_r0 -= log_table[t_r0];
							}
						else
							{
							t_r0 = 0;
							blinke(sql_var_handle,kanaele);
							}
						}
					}
				if ((kanaele == 2) || (kanaele == 3))							// Channel 1
					{
					if (t_r1 >= 0)
						{
						if (t_r1 >= log_table[t_r1])
							{
							t_r1 -= log_table[t_r1];
							}
						else
							{
							t_r1 = 0;
							blinke(sql_var_handle,kanaele);
							}
						}
					}
				if((t_r0 >= 255) || (t_r1 >= 255))
					{
					blinke(sql_var_handle,kanaele);
					}
				}
			if (t_ir == 154)																		// Taste "G+"
				{
				if ((kanaele == 1) || (kanaele == 3))							// Channel 0
					{
					if (t_g0 <= 255)
						{
						if (255 - t_g0 > log_table[t_g0])
							{
							t_g0 += log_table[t_g0];
							}
						else
							{
							t_g0 = 255; 
							}
						}
					}
				if ((kanaele == 2) || (kanaele == 3))						// Channel 1
					{
					if (t_g1 <= 255)
						{
						if (255 - t_g1 > log_table[t_g1])
							{
							t_g1 += log_table[t_g1];
							}
						else
							{
							t_g1 = 255;
							}
						}
					}
				if((t_g0 >= 255) || (t_g1 >= 255))
					{
					blinke(sql_var_handle,kanaele);
					}
				}
			if (t_ir == 170)																		// Taste "G-"
				{
				if ((kanaele == 1) || (kanaele == 3))							// Channel 0
					{
					if (t_g0 >= 0)
						{
						if (t_g0 >= log_table[t_g0])
							{
							t_g0 -= log_table[t_g0];
							}
						else
							{
							t_g0 = 0;
							blinke(sql_var_handle,kanaele);
							}
						}
					}
				if ((kanaele == 2) || (kanaele == 3))							// Channel 1
					{
					if (t_g1 >= 0)
						{
						if (t_g1 >= log_table[t_g1])
							{
							t_g1 -= log_table[t_g1];
							}
						else
							{
							t_g1 = 0;
							blinke(sql_var_handle,kanaele);
							}
						}
					}
				if((t_g0 >= 255) || (t_g1 >= 255))
					{
					blinke(sql_var_handle,kanaele);
					}
				}
			if (t_ir == 162)																		// Taste "B+"
				{
				if ((kanaele == 1) || (kanaele == 3))							// Channel 0
					{
					if (t_b0 <= 255)
						{
						if (255 - t_b0 > log_table[t_b0])
							{
							t_b0 += log_table[t_b0];
							}
						else
							{
							t_b0 = 255; 
							}
						}
					}
				if ((kanaele == 2) || (kanaele == 3))						// Channel 1
					{
					if (t_b1 <= 255)
						{
						if (255 - t_b1 > log_table[t_b1])
							{
							t_b1 += log_table[t_b1];
							}
						else
							{
							t_b1 = 255;
							}
						}
					}
				if((t_b0 >= 255) || (t_b1 >= 255))
					{
					blinke(sql_var_handle,kanaele);
					}
				}
			if (t_ir == 146)																		// Taste "B-"
				{
				if ((kanaele == 1) || (kanaele == 3))							// Channel 0
					{
					if (t_b0 >= 0)
						{
						if (t_b0 >= log_table[t_b0])
							{
							t_b0 -= log_table[t_b0];
							}
						else
							{
							t_b0 = 0;
							blinke(sql_var_handle,kanaele);
							}
						}
					}
				if ((kanaele == 2) || (kanaele == 3))							// Channel 1
					{
					if (t_b1 >= 0)
						{
						if (t_b1 >= log_table[t_b1])
							{
							t_b1 -= log_table[t_b1];
							}
						else
							{
							t_b1 = 0;
							blinke(sql_var_handle,kanaele);
							}
						}
					}
				if((t_b0 >= 255) || (t_b1 >= 255))
					{
					blinke(sql_var_handle,kanaele);
					}
				}
			if (t_ir == 34)																			// Taste "W+"
				{
				if ((kanaele == 1) || (kanaele == 3))							// Channel 0
					{
					if (t_w0 <= 255)
						{
						if (255 - t_w0 > log_table[t_w0])
							{
							t_w0 += log_table[t_w0];
							}
						else
							{
							t_w0 = 255; 
							}
						}
					}
				if ((kanaele == 2) || (kanaele == 3))						// Channel 1
					{
					if (t_w1 <= 255)
						{
						if (255 - t_w1 > log_table[t_w1])
							{
							t_w1 += log_table[t_w1];
							}
						else
							{
							t_w1 = 255;
							}
						}
					}
				if((t_w0 >= 255) || (t_w1 >= 255))
					{
					blinke(sql_var_handle,kanaele);
					}
				}
			if (t_ir == 18)																			// Taste "W-"
				{
				if ((kanaele == 1) || (kanaele == 3))							// Channel 0
					{
					if (t_w0 >= 0)
						{
						if (t_w0 >= log_table[t_w0])
							{
							t_w0 -= log_table[t_w0];
							}
						else
							{
							t_w0 = 0;
							blinke(sql_var_handle,kanaele);
							}
						}
					}
				if ((kanaele == 2) || (kanaele == 3))							// Channel 1
					{
					if (t_w1 >= 0)
						{
						if (t_w1 >= log_table[t_w1])
							{
							t_w1 -= log_table[t_w1];
							}
						else
							{
							t_w1 = 0;
							blinke(sql_var_handle,kanaele);
							}
						}
					}
				if((t_w0 >= 255) || (t_w1 >= 255))
					{
					blinke(sql_var_handle,kanaele);
					}
				}
			if (t_ir == 58)																			// Taste "+"
				{
				if ((kanaele == 1) || (kanaele == 3))							// Channel 0
					{
					if (t_r0 <= 255)																// Rot
						{
						if (255 - t_r0 > log_table[t_r0])
							{
							t_r0 += log_table[t_r0];
							}
						else
							{
							t_r0 = 255; 
							}
						}
					if (t_g0 <= 255)																// Grn
						{
						if (255 - t_g0 > log_table[t_g0])
							{
							t_g0 += log_table[t_g0];
							}
						else
							{
							t_g0 = 255; 
							}
						}
					if (t_b0 <= 255)																// Blau
						{
						if (255 - t_b0 > log_table[t_b0])
							{
							t_b0 += log_table[t_b0];
							}
						else
							{
							t_b0 = 255; 
							}
						}
					// if (t_w0 <= 255)																// Wei
					//	{
					//	if (255 - t_w0 > log_table[t_w0])
					//		{
					//		t_w0 += log_table[t_w0];
					//		}
					//	else
					//		{
					//		t_w0 = 255; 
					//		}
					//	}
					}
				if ((kanaele == 2) || (kanaele == 3))						// Channel 1
					{
					if (t_r1 <= 255)															// Rot
						{
						if (255 - t_r1 > log_table[t_r1])
							{
							t_r1 += log_table[t_r1];
							}
						else
							{
							t_r1 = 255;
							}
						}
					if (t_g1 <= 255)															// Grn
						{
						if (255 - t_g1 > log_table[t_g1])
							{
							t_g1 += log_table[t_g1];
							}
						else
							{
							t_g1 = 255;
							}
						}
					if (t_b1 <= 255)															// Blau
						{
						if (255 - t_b1 > log_table[t_b1])
							{
							t_b1 += log_table[t_b1];
							}
						else
							{
							t_b1 = 255;
							}
						}
					// if (t_w1 <= 255)															// Wei
					//	{
					//	if (255 - t_w1 > log_table[t_w1])
					//		{
					//		t_w1 += log_table[t_w1];
					//		}
					//	else
					//		{
					//		t_w1 = 255;
					//		}
					//	}
					}
				}
			if (t_ir == 186)																		// Taste "-"
				{
				if ((kanaele == 1) || (kanaele == 3))							// Channel 0
					{
					if (t_r0 >= 0)																	// Rot
						{
						if (t_r0 >= log_table[t_r0])
							{
							t_r0 -= log_table[t_r0];
							}
						else
							{
							t_r0 = 0;
							}
						}
					if (t_g0 >= 0)																	// Grn
						{
						if (t_g0 >= log_table[t_g0])
							{
							t_g0 -= log_table[t_g0];
							}
						else
							{
							t_g0 = 0;
							}
						}
					if (t_b0 >= 0)																	// Blau
						{
						if (t_b0 >= log_table[t_b0])
							{
							t_b0 -= log_table[t_b0];
							}
						else
							{
							t_b0 = 0;
							}
						}
					// if (t_w0 >= 0)																	// Wei
					//	{
					//	if (t_w0 >= log_table[t_w0])
					//		{
					//		t_w0 -= log_table[t_w0];
					//		}
					//	else
					//		{
					//		t_w0 = 0;
					//		}
					//	}
					}
				if ((kanaele == 2) || (kanaele == 3))							// Channel 1
					{
					if (t_r1 >= 0)																	// Rot
						{
						if (t_r1 >= log_table[t_r1])
							{
							t_r1 -= log_table[t_r1];
							}
						else
							{
							t_r1 = 0;
							}
						}
					if (t_g1 >= 0)																	// Grn
						{
						if (t_g1 >= log_table[t_g1])
							{
							t_g1 -= log_table[t_g1];
							}
						else
							{
							t_g1 = 0;
							}
						}
					if (t_b1 >= 0)																	// Blau
						{
						if (t_b1 >= log_table[t_b1])
							{
							t_b1 -= log_table[t_b1];
							}
						else
							{
							t_b1 = 0;
							}
						}
					// if (t_w1 >= 0)																	// Wei
					//	{
					//	if (t_w1 >= log_table[t_w1])
					//		{
					//		t_w1 -= log_table[t_w1];
					//		}
					//	else
					//		{
					//		t_w1 = 0;
					//		}
					//	}
					}
				}
			if (t_ir == 10)																			// Taste "Preset A" 100% Rot
				{
				if ((kanaele == 1) || (kanaele == 3))
					{
					t_r0 = 255;
					t_g0 = 0;
					t_b0 = 0;
					t_w0 = 0;
					}
				if ((kanaele == 2) || (kanaele == 3))
					{
					t_r1 = 255;
					t_g1 = 0;
					t_b1 = 0;
					t_w1 = 0;
					}
				}
			if (t_ir == 138)																		// Taste "Preset B" 100% Blau
				{
				if ((kanaele == 1) || (kanaele == 3))
					{
					t_r0 = 0;
					t_g0 = 0;
					t_b0 = 255;
					t_w0 = 0;
					}
				if ((kanaele == 2) || (kanaele == 3))
					{
					t_r1 = 0;
					t_g1 = 0;
					t_b1 = 255;
					t_w1 = 0;
					}
				}
			if (t_ir == 178)																		// Taste "Preset C" 100% wei
				{
				if ((kanaele == 1) || (kanaele == 3))
					{
					t_r0 = 0;
					t_g0 = 0;
					t_b0 = 0;
					t_w0 = 255;
					}
				if ((kanaele == 2) || (kanaele == 3))
					{
					t_r1 = 0;
					t_g1 = 0;
					t_b1 = 0;
					t_w1 = 255;
					}
				}
			if (t_ir == 56)																			// Taste "Preset D" (Gelb) 100% Rot, 100% Grn
				{
				if ((kanaele == 1) || (kanaele == 3))
					{
					t_r0 = 255;
					t_g0 = 255;
					t_b0 = 0;
					t_w0 = 0;
					}
				if ((kanaele == 2) || (kanaele == 3))
					{
					t_r1 = 255;
					t_g1 = 255;
					t_b1 = 0;
					t_w1 = 0;
					}
				}
			if (t_ir == 184)																		// Taste "Preset E" (Cyan) 100% Grn, 100 % Blau
				{
				if ((kanaele == 1) || (kanaele == 3))
					{
					t_r0 = 0;
					t_g0 = 255;
					t_b0 = 255;
					t_w0 = 0;
					}
				if ((kanaele == 2) || (kanaele == 3))
					{
					t_r1 = 0;
					t_g1 = 255;
					t_b1 = 255;
					t_w1 = 0;
					}
				}
			if (t_ir == 120)																		// Taste "Preset F" (Orange) 226 Rot, 106 Grn
				{
				if ((kanaele == 1) || (kanaele == 3))
					{
					t_r0 = 226;
					t_g0 = 106;
					t_b0 = 0;
					t_w0 = 0;
					}
				if ((kanaele == 2) || (kanaele == 3))
					{
					t_r1 = 226;
					t_g1 = 106;
					t_b1 = 0;
					t_w1 = 0;
					}
				}
			if (t_ir == 24)																			// Taste "Preset G" 100% Grn
				{
				if ((kanaele == 1) || (kanaele == 3))
					{
					t_r0 = 0;
					t_g0 = 255;
					t_b0 = 0;
					t_w0 = 0;
					}
				if ((kanaele == 2) || (kanaele == 3))
					{
					t_r1 = 0;
					t_g1 = 255;
					t_b1 = 0;
					t_w1 = 0;
					}
				}
			if (t_ir == 152)																		// Taste "Preset H" (Lila) 100% Rot, 100 % Blau
				{
				if ((kanaele == 1) || (kanaele == 3))
					{
					t_r0 = 255;
					t_g0 = 0;
					t_b0 = 255;
					t_w0 = 0;
					}
				if ((kanaele == 2) || (kanaele == 3))
					{
					t_r1 = 255;
					t_g1 = 0;
					t_b1 = 255;
					t_w1 = 0;
					}
				}
			if (t_ir == 88)																			// Taste "Preset I" (rosa) 100 % Rot, 50% Wei
				{
				if ((kanaele == 1) || (kanaele == 3))
					{
					t_r0 = 255;
					t_g0 = 0;
					t_b0 = 0;
					t_w0 = 128;
					}
				if ((kanaele == 2) || (kanaele == 3))
					{
					t_r1 = 255;
					t_g1 = 0;
					t_b1 = 0;
					t_w1 = 128;
					}
				}


	// /control/rgb/remotecontrol/rmt_prog0
	//                                  ...
	// /control/rgb/remotecontrol/rmt_prog7
	// Werte:
	// <0: nichts ausgewhlt
	// >= Nummer des zu startenden Programms

			if (t_ir == 232)																		// Taste "Programm STOP"
				{
				sprintf(ep,"Program STOP");
				log_append(4,ep);
				do_sqlyy(sql_var_handle,"UPDATE [program] SET [new_command]=-2 WHERE [id] = 0;",0);
				}
			if (t_ir == 8)																			// Taste "Programm 0"
				{
				t = sqldb_read_long("/control/rgb/remotecontrol/rmt_prog0");
				sprintf(ep,"START Program0: %d",t);
				log_append(4,ep);
				if (t >= 0)
					{
					sprintf(ep,"UPDATE [program] SET [new_command]=%d WHERE [id]=0;",t + 10000);
					do_sqlyy(sql_var_handle,ep,0);
					}
				}
			if (t_ir == 136)																		// Taste "Programm 1"
				{
				t = sqldb_read_long("/control/rgb/remotecontrol/rmt_prog1");
				sprintf(ep,"START Program1: %d",t);
				log_append(4,ep);
				if (t >= 0)
					{
					sprintf(ep,"UPDATE [program] SET [new_command]=%d WHERE [id]=0;",t + 10000);
					do_sqlyy(sql_var_handle,ep,0);
					}
				}
			if (t_ir == 72)																			// Taste "Programm 2"
				{
				t = sqldb_read_long("/control/rgb/remotecontrol/rmt_prog2");
				sprintf(ep,"START Program2: %d",t);
				log_append(4,ep);
				if (t >= 0)
					{
					sprintf(ep,"UPDATE [program] SET [new_command]=%d WHERE [id]=0;",t + 10000);
					do_sqlyy(sql_var_handle,ep,0);
					}
				}
			if (t_ir == 200)																		// Taste "Programm 3"
				{
				t = sqldb_read_long("/control/rgb/remotecontrol/rmt_prog3");
				sprintf(ep,"START Program3: %d",t);
				log_append(4,ep);
				if (t >= 0)
					{
					sprintf(ep,"UPDATE [program] SET [new_command]=%d WHERE [id]=0;",t + 10000);
					do_sqlyy(sql_var_handle,ep,0);
					}
				}
			if (t_ir == 48)																			// Taste "Programm 4"
				{
				t = sqldb_read_long("/control/rgb/remotecontrol/rmt_prog4");
				sprintf(ep,"START Program4: %d",t);
				log_append(4,ep);
				if (t >= 0)
					{
					sprintf(ep,"UPDATE [program] SET [new_command]=%d WHERE [id]=0;",t + 10000);
					do_sqlyy(sql_var_handle,ep,0);
					}
				}
			if (t_ir == 176)																		// Taste "Programm 5"
				{
				t = sqldb_read_long("/control/rgb/remotecontrol/rmt_prog5");
				sprintf(ep,"START Program5: %d",t);
				log_append(4,ep);
				if (t >= 0)
					{
					sprintf(ep,"UPDATE [program] SET [new_command]=%d WHERE [id]=0;",t + 10000);
					do_sqlyy(sql_var_handle,ep,0);
					}
				}
			if (t_ir == 112)																		// Taste "Programm 6"
				{
				t = sqldb_read_long("/control/rgb/remotecontrol/rmt_prog6");
				sprintf(ep,"START Program6: %d",t);
				log_append(4,ep);
				if (t >= 0)
					{
					sprintf(ep,"UPDATE [program] SET [new_command]=%d WHERE [id]=0;",t + 10000);
					do_sqlyy(sql_var_handle,ep,0);
					}
				}
			if (t_ir == 240)																		// Taste "Programm 7"
				{
				t = sqldb_read_long("/control/rgb/remotecontrol/rmt_prog7");
				sprintf(ep,"START Program7: %d",t);
				log_append(4,ep);
				if (t >= 0)
					{
					sprintf(ep,"UPDATE [program] SET [new_command]=%d WHERE [id]=0;",t + 10000);
					do_sqlyy(sql_var_handle,ep,0);
					}
				}

	
	// /control/rgb/remotecontrol/rmt_switch0
	// /control/rgb/remotecontrol/rmt_switch1
	// /control/rgb/remotecontrol/rmt_switch2
	// /control/rgb/remotecontrol/rmt_switch3
	// Werte:
	// <0: nichts ausgewhlt
	// >= Nummer des logischen Aktors

			if (t_ir == 16)																			// Taste "ON 0"
				{
				t = sqldb_read_long("/control/rgb/remotecontrol/rmt_switch0");
				if (t >= 0)
					{
					sprintf(ep,"ON0: Actor %d ON",t);
					log_append(4,ep);
					sprintf(kommando,"/usr/sbin/actor_w_write \"%d\" \"%d\" >/dev/null",t,1);
					system(kommando);
					}
				}
			if (t_ir == 144)																		// Taste "ON 1"
				{
				t = sqldb_read_long("/control/rgb/remotecontrol/rmt_switch1");
				if (t >= 0)
					{
					sprintf(ep,"ON1: Actor %d ON",t);
					log_append(4,ep);
					sprintf(kommando,"/usr/sbin/actor_w_write \"%d\" \"%d\" >/dev/null",t,1);
					system(kommando);
					}
				}
			if (t_ir == 80)																			// Taste "ON 2"
				{
				t = sqldb_read_long("/control/rgb/remotecontrol/rmt_switch2");
				if (t >= 0)
					{
					sprintf(ep,"ON2: Actor %d ON",t);
					log_append(4,ep);
					sprintf(kommando,"/usr/sbin/actor_w_write \"%d\" \"%d\" >/dev/null",t,1);
					system(kommando);
					}
				}
			if (t_ir == 208)																		// Taste "ON 3"
				{
				t = sqldb_read_long("/control/rgb/remotecontrol/rmt_switch3");
				if (t >= 0)
					{
					sprintf(ep,"ON3: Actor %d ON",t);
					log_append(4,ep);
					sprintf(kommando,"/usr/sbin/actor_w_write \"%d\" \"%d\" >/dev/null",t,1);
					system(kommando);
					}
				}
			if (t_ir == 32)																			// Taste "OFF 0"
				{
				t = sqldb_read_long("/control/rgb/remotecontrol/rmt_switch0");
				if (t >= 0)
					{
					sprintf(ep,"OFF0: Actor %d OFF",t);
					log_append(4,ep);
					sprintf(kommando,"/usr/sbin/actor_w_write \"%d\" \"%d\" >/dev/null",t,0);
					system(kommando);
					}
				}
			if (t_ir == 160)																		// Taste "OFF 1"
				{
				t = sqldb_read_long("/control/rgb/remotecontrol/rmt_switch1");
				if (t >= 0)
					{
					sprintf(ep,"OFF1: Actor %d OFF",t);
					log_append(4,ep);
					sprintf(kommando,"/usr/sbin/actor_w_write \"%d\" \"%d\" >/dev/null",t,0);
					system(kommando);
					}
				}
			if (t_ir == 96)																			// Taste "OFF 2"
				{
				t = sqldb_read_long("/control/rgb/remotecontrol/rmt_switch2");
				if (t >= 0)
					{
					sprintf(ep,"OFF2: Actor %d OFF",t);
					log_append(4,ep);
					sprintf(kommando,"/usr/sbin/actor_w_write \"%d\" \"%d\" >/dev/null",t,0);
					system(kommando);
					}
				}
			if (t_ir == 224)																		// Taste "OFF 3"
				{
				t = sqldb_read_long("/control/rgb/remotecontrol/rmt_switch3");
				if (t >= 0)
					{
					sprintf(ep,"OFF3: Actor %d OFF",t);
					log_append(4,ep);
					sprintf(kommando,"/usr/sbin/actor_w_write \"%d\" \"%d\" >/dev/null",t,0);
					system(kommando);
					}
				}
			}
		}

	// ----- Prfen, ob sich gegenber dem letztenmal etwas gendert hat -----
	az = 0;
	if (old_r0				!= t_r0				) az++;
	if (old_g0				!= t_g0				) az++;
	if (old_b0				!= t_b0				) az++;
	if (old_w0				!= t_w0				) az++;
	if (old_r1				!= t_r1				) az++;
	if (old_g1				!= t_g1				) az++;
	if (old_b1				!= t_b1				) az++;
	if (old_w1				!= t_w1				) az++;
	if (old_dim0			!= t_dim0			) az++;
	if (old_dim1			!= t_dim1			) az++;

	if (az > 0)
		{
		update_demonstatus(ti,200,"RGB write");							// Status von Demon in SHM aktualisieren
		sql_write_rgbvalues(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_dim0,t_r1,t_g1,t_b1,t_w1,t_dim1);
		}

	// Alte Werte merken
	old_r0 = t_r0;
	old_g0 = t_g0;
	old_b0 = t_b0;
	old_w0 = t_w0;
	old_r1 = t_r1;
	old_g1 = t_g1;
	old_b1 = t_b1;
	old_w1 = t_w1;
	old_dim0 = t_dim0;
	old_dim1 = t_dim1;

ignore_ir_remote:
	t_ir_old = t_ir;
	goto hauptschleife;

// ende:
	sqlite3_close(sql_var_handle);												// Datenbank schlieen
errorende:
	return(0);
	}
