// **********   sensor_demon.h - Abfrage der angeschlossenen Sensoren und Aktoren   **********



// **********   Globale Variablen   **********

struct sensordemon_datenpaket
	{
	char client_server;
	char kommando;
	signed short int sensor_number;
	signed long int rw;
	signed long int error;
	signed long int parameter1;
	signed long int parameter2;
	};

#define								SENSORDEMON_VERSION "2.05"
#define								MAX_SENSORS 128
#define								MAX_LOGICAL_SENSORS 128
#define								MAX_REMOTE_SENSORS 32
#define								MAX_LOGICAL_ACTORS 128
#define								MAX_PHYSICAL_AGE 3
#define								MAX_MATRIX_RULES 128
#define								MAX_TIMERS 128
#define								TIMER_GRACE_PERIOD 3
#define								MAX_ALERTS 128
#define								ALERT_TRESHOLD_COUNT 10
#define								MAX_MAIL_RECIPIENTS 50
#define								MAX_MOBOTIX_UPLOADS 25



signed short int			max_units;																										// Anzahl Einheiten
char									scale_unit[32][25];																						// Einheiten-Bezeichner
signed short int			portscan_max_physical_sensors;																// Beim Portscan ermittelte Anzahl
signed short int			portscan_max_logical_sensors;																	// Beim Portscan ermittelte Anzahl
signed short int			portscan_max_logical_actors;																	// Beim Portscan ermittelte Anzahl
signed short int			sensor_valid_flag = 0;																				// Sensordaten sind erst nach diesem Flag gltig
signed long int				alert_max_alerts;																							// Anzahl tatschlich benutzter Alerts
signed long int				alert_reload_counter;																					// Reload Counter
signed char						alert_enabled[MAX_ALERTS];																		// Enabled 0/1
char									alert_name[MAX_ALERTS][40];																		// Benennung
char									alert_description[MAX_ALERTS][80];														// Blatext
signed short int			alert_sensor[MAX_ALERTS];																			// Sensornummer, die zu berwachen ist
double								alert_treshold[MAX_ALERTS];																		// Grenzwert
signed char						alert_comparison[MAX_ALERTS];																	// Vergleichsoperator
signed short int			alert_email_to[MAX_ALERTS];																		// Email-Adressnummer
char									alert_email_subject[MAX_ALERTS][161];													// Email-Subject
signed short int			alert_sms_to[MAX_ALERTS];																			// SMS-Adressnummer
char									alert_sms_subject[MAX_ALERTS][161];														// SMS-Subject
signed short int			alert_actor[MAX_ALERTS];																			// zu schaltender Aktor
signed short int			alert_onoff[MAX_ALERTS];																			// Schaltwunsch 0/1
signed short int			alert_status[MAX_ALERTS];																			// Alarm-Status (0:kein Alarm, 1:Alarm, -1:undefiniert)
signed short int			alert_okcount[MAX_ALERTS];																		// OK-Zhler (fr kein Alarm)
signed short int			alert_errcount[MAX_ALERTS];																		// Error-Zhler (fr Alarm)
char									alert_script[MAX_ALERTS][80];																	// auszufhrendes Kommando
signed char						alert_include_values[MAX_ALERTS];															// Mewerte mitschicken 0/1

signed long int				timer_max_timers;																							// Anzahl tatschlich benutzter Timer
signed long int				timer_reload_counter;																					// Reload Counter
signed char						timer_enabled[MAX_TIMERS];																		// Timer Enabled 0/1
char									timer_name[MAX_TIMERS][40];																		// Timer Benennung
signed char						timer_start_monday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
signed char						timer_start_tuesday[MAX_TIMERS];															// Schaltzeitpunkt Wochentag
signed char						timer_start_wednesday[MAX_TIMERS];														// Schaltzeitpunkt Wochentag
signed char						timer_start_thursday[MAX_TIMERS];															// Schaltzeitpunkt Wochentag
signed char						timer_start_friday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
signed char						timer_start_saturday[MAX_TIMERS];															// Schaltzeitpunkt Wochentag
signed char						timer_start_sunday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
signed char						timer_start_hour[MAX_TIMERS];																	// Uhrzeit Stunde
signed char						timer_start_minute[MAX_TIMERS];																// Uhrzeit Minute
signed char						timer_start_second[MAX_TIMERS];																// Uhrzeit Sekunde
signed short int			timer_start_onoff[MAX_TIMERS];																// On/Off 0/1
signed short int			timer_start_actor[MAX_TIMERS];																// On/Off 0/1
signed char						timer_stop_monday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
signed char						timer_stop_tuesday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
signed char						timer_stop_wednesday[MAX_TIMERS];															// Schaltzeitpunkt Wochentag
signed char						timer_stop_thursday[MAX_TIMERS];															// Schaltzeitpunkt Wochentag
signed char						timer_stop_friday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
signed char						timer_stop_saturday[MAX_TIMERS];															// Schaltzeitpunkt Wochentag
signed char						timer_stop_sunday[MAX_TIMERS];																// Schaltzeitpunkt Wochentag
signed char						timer_stop_hour[MAX_TIMERS];																	// Uhrzeit Stunde
signed char						timer_stop_minute[MAX_TIMERS];																// Uhrzeit Minute
signed char						timer_stop_second[MAX_TIMERS];																// Uhrzeit Sekunde
signed short int			timer_stop_onoff[MAX_TIMERS];																	// On/Off 0/1
signed short int			timer_stop_actor[MAX_TIMERS];																	// On/Off 0/1

signed long int				matrix_actor_value[MAX_LOGICAL_ACTORS];												// Double Buffer wg. SHM-Problematik
signed char						matrix_actor_flag[MAX_LOGICAL_ACTORS];												// nderungsflag
unsigned short int		config_demon_historyinterval = 60;														// History-Intervall in Sekunden
char									sensordemon_version[20] = "1.01";															// Versionsnummer
char									sensordemon_logfile[80] = "/www/reports/sensor_demon.log";		// Hier soll die Logdatei hin
signed short int			sensordemon_loglevel = 4;																			// Loglevel (0: Nix, 4: Alles)
char									device_name[40];																							// Benutzerdefinierter Gertename
char									device_type[40];																							// vom System vergebener Gertetyp
signed long int				ti = 0;																												// System-Timer
unsigned long int			config_demon_delay = 1;																				// Zeitintervall fr Messungen
unsigned long int			config_sekundenlock = 0;																			// Zeitintervall fr Messungen
unsigned long int			config_demon_ps_enabled = 0;																	// Powersaving Ein/Aus
unsigned long int			config_demon_ps_offtime = 60;																	// Powersaving Zeit, die abgeschaltet gewartet wird
unsigned long int			config_demon_ps_boottime = 5;																	// Powersaving Zeit nach dem Einschalten, bevor Sensoren gepollt werden
unsigned char					config_demon_lcd_enabled = 0;																	// Soll das LCD mit Sensorwerten gefllt werden ?
unsigned short int		config_demon_lcd_delay = 0;																		// Verzgerung in Loops zwischen Sensorupdates
double								ortsueblicher_luftdruck;																			// Einstellung fr Absolutdruck-Korrektur
unsigned long int			physical_max_sensors = 10;																		// Max. Anzahl physikalischer Sensoren in der STRDB
unsigned long int			logical_max_sensors = 10;																			// Max. Anzahl logischer Sensoren in der STRDB
unsigned long int			scanned_max_sensors = 10;																			// Max. Anzahl gescannter Sensoren in der STRDB
unsigned long int			display_max_sensors = 10;																			// Max. Anzahl anzuzeigender Sensoren in der STRDB
unsigned long int			display_max_actors = 10;																			// Max. Anzahl anzuzeigender Aktoren in der STRDB

unsigned short int		display_sensor[MAX_SENSORS];																	// Display-Puffer fr autom. Zuordnung
unsigned short int		display_actor[MAX_LOGICAL_ACTORS];														// Display-Puffer fr autom. Zuordnung
char									display_mapflag[MAX_SENSORS];																	// Flag, ob der Sensor schon irgendwohin gemappt wurde
char									physical_name[MAX_SENSORS][40];																// Name
char									physical_comment[MAX_SENSORS][80];														// Bemerkungen
signed short int			physical_enabled[MAX_SENSORS];																// Enabled ?
signed short int			physical_chipid[MAX_SENSORS];																	// Chip-ID
char									physical_chipname[MAX_SENSORS][20];														// Name des ICs
signed short int			physical_chipadresse[MAX_SENSORS];														// Adresse
signed short int			physical_channels[MAX_SENSORS];																// Anzahl Ports Eingang
signed short int			physical_outchannels[MAX_SENSORS];														// Anzahl Ports Ausgang
signed short int			physical_bus[MAX_SENSORS];																		// an welchem Bus hngt dieser Sensor ?
signed short int			physical_group[MAX_SENSORS];																	// an welcher Gruppe hngt der Sensor ?
signed short int			physical_port[MAX_SENSORS];																		// an welchem Port dieser Gruppe ist der Sensor ?
signed short int			physical_speed[MAX_SENSORS];																	// Delay-Parameter
signed short int			physical_all4000_typ[MAX_SENSORS];														// ALL4000-Typ
time_t								physical_timestamp[MAX_SENSORS];															// Timestamp der letzten gltigen Messung (z.B. fr RFID)
signed short int			physical_priority[MAX_SENSORS];																// Prioritt (0:normal, -1: Low)
signed short int			physical_mux_enabled[MAX_SENSORS];														// Gemultiplexter Port (0:nein, 1: Ja, ALL4504 vorhanden)
signed short int			physical_mux_port[MAX_SENSORS];																// Portnummer am Multiplexer (0...7)

signed long int				physical_value_int[8][MAX_SENSORS];														// Messwert 0...7 als int
double								physical_value_float[8][MAX_SENSORS];													// Messwert 0...7 als float
char									physical_value_string[8][MAX_SENSORS][80];										// Messwert 0...7 als String
signed short int			physical_mapto_sensor[8][MAX_SENSORS];												// Auf welches Target soll gemappt werden
signed short int			physical_mapto_function[8][MAX_SENSORS];											// Auf welches Target soll gemappt werden
signed short int			physical_mapto_math_enabled[8][MAX_SENSORS];									// Rechenoperationen aktivieren
double								physical_mapto_math_add1[8][MAX_SENSORS];											// Addition 1
double								physical_mapto_math_multiply1[8][MAX_SENSORS];								// Multiplikation 1
double								physical_mapto_math_add2[8][MAX_SENSORS];											// Addition 2
double								physical_mapto_math_multiply2[8][MAX_SENSORS];								// Multiplikation 2
signed short int			physical_outcmd[8][MAX_SENSORS];															// Ausgabe-Kommando 0...7
signed long int				physical_outvalue_int[8][MAX_SENSORS];												// Ausgabewert 0...7 als int
double								physical_outvalue_float[8][MAX_SENSORS];											// Ausgabewert 0...7 als float
char									physical_outvalue_string[8][MAX_SENSORS][80];									// Ausgabewert 0...7 als String
signed short int			physical_mapfrom_actor[8][MAX_SENSORS];												// Welcher Aktor steuert diesen Chip

char									logical_name[MAX_LOGICAL_SENSORS][40];												// Name
char									logical_comment[MAX_LOGICAL_SENSORS][80];											// Bemerkungen
signed short int			logical_function[MAX_LOGICAL_SENSORS];												// Sensorfunktion
signed short int			logical_chipid[MAX_LOGICAL_SENSORS];													// Sensorchip ID
signed short int			logical_all4000_typ[MAX_LOGICAL_SENSORS]; 										// ALL4000 Typ
double								logical_limit_min[MAX_LOGICAL_SENSORS];												// Limit Minimum
double								logical_limit_max[MAX_LOGICAL_SENSORS];												// Limit Maximum
double								logical_display_min[MAX_LOGICAL_SENSORS];											// Anzeige Minimum
double								logical_display_max[MAX_LOGICAL_SENSORS];											// Anzeige Maximum
signed long int				logical_int[MAX_LOGICAL_SENSORS];															// logischer Sensor als int
double								logical_float[MAX_LOGICAL_SENSORS];														// logischer Sensor als float
char									logical_string[MAX_LOGICAL_SENSORS][80];											// logischer Sensor als String
signed long int				logical_old_int[MAX_LOGICAL_SENSORS];													// logischer Sensor als int
double								logical_old_float[MAX_LOGICAL_SENSORS];												// logischer Sensor als float
char									logical_old_string[MAX_LOGICAL_SENSORS][80];									// logischer Sensor als String
double								logical_minimum[MAX_LOGICAL_SENSORS];													// Minimum-Wert
double								logical_maximum[MAX_LOGICAL_SENSORS];													// Maximum-Wert
unsigned char					logical_minimum_counter[MAX_LOGICAL_SENSORS];									// Minimum-Wert
unsigned char					logical_maximum_counter[MAX_LOGICAL_SENSORS];									// Maximum-Wert
unsigned long int			logical_timestamp[MAX_LOGICAL_SENSORS];												// Timestamp fr Aging
double								sql_sensorvalue_old_float[MAX_LOGICAL_SENSORS];								// Shadow-Variable fr SQL-Update-Optimierung
char									function_unit[256][10];																				// Einheiten fr die Anzeige und den Stringwert
char									logical_svg_bgcolor[MAX_LOGICAL_SENSORS][20];									// Hintergrundfarbe fr SVG-Grafiken
char									logical_svg_gridcolor[MAX_LOGICAL_SENSORS][20];								// Gitterfarbe fr SVG-Grafiken
char									logical_svg_graphcolor[MAX_LOGICAL_SENSORS][20];							// Farbe fr Standardgraphen fr SVG-Grafiken
signed short int			logical_svg_graphstyle[MAX_LOGICAL_SENSORS];									// Linientyp fr Standardgraphen fr SVG-Grafiken
signed short int			logical_meta_enabled[MAX_LOGICAL_SENSORS];										// Meta-Sensor ? 0/1
signed short int			logical_meta_source[MAX_LOGICAL_SENSORS][4];									// Datenquelle (logischer Sensor oder -1)
char									logical_meta_graphcolor[MAX_LOGICAL_SENSORS][4][20];					// Linienfarbe
signed short int			logical_meta_graphstyle[MAX_LOGICAL_SENSORS][4];							// Linientyp
signed short int			logical_svg_includevalues;																		// Werte in Grafik einfgen ?
signed short int			logical_math_enabled[MAX_LOGICAL_SENSORS];										// Mathematik-Funktionen aktiviert ? 0/1
signed short int			logical_math_operation[MAX_LOGICAL_SENSORS][4];								// -1:nix, 0:copy, 1:+, 2:-, 3:*, 4:/
signed short int			logical_math_source[MAX_LOGICAL_SENSORS][4];									// Datenquelle (logischer Sensor oder -1)
double								logical_math_constant[MAX_LOGICAL_SENSORS][4];								// Konstante
double								logical_sum_float[MAX_LOGICAL_SENSORS];												// Summe logischer Werte als Float
signed long int				logical_sum_count;																						// Summe logischer Werte (Anzahl)
double								logical_change[MAX_LOGICAL_SENSORS];													// Vernderung gegenber dem letzten Wert

signed short int			scanned_bus[MAX_SENSORS];																			// an welchem Bus hngt dieser Sensor ?
signed short int			scanned_group[MAX_SENSORS];																		// an welcher Gruppe hngt der Sensor ?
signed short int			scanned_port[MAX_SENSORS];																		// an welchem Port dieser Gruppe ist der Sensor ?
signed short int			scanned_speed[MAX_SENSORS];																		// Delay-Parameter
signed short int			scanned_chipid[MAX_SENSORS];																	// Chip-ID
signed short int			scanned_chipaddress[MAX_SENSORS];															// Adresse
char									scanned_chipname[MAX_SENSORS][20];														// Chip-Bezeichnung
signed short int			scanned_function[MAX_SENSORS];																// Funktion
signed short int			scanned_channels[MAX_SENSORS];																// Anzahl Kanle (In)
signed short int			scanned_outchannels[MAX_SENSORS];															// Anzahl Kanle (Out)
char									scanned_guess_name[MAX_SENSORS][25];													// Sensor-Bezeichnung
signed short int			scanned_all4000_typ[MAX_SENSORS];															// ALL4000 Typ
signed short int			alarmcount;																										// Alarm-Zhler
signed short int			demon_all4000_ad;																							// ALL4000 AD
signed short int			demon_all4000_f;																							// ALL4000 Fahrenheit
signed short int			demon_all4000_sensorx;																				// ALL4000 Sensors Y
signed short int			demon_all4000_sensory;																				// ALL4000 Sensors X
signed short int			demon_all4000_px;																							// ALL4000 Pixels X
signed short int			demon_all4000_py;																							// ALL4000 Pixels Y
signed short int			demon_all4000_muell;																					// ALL4000 Zeitintervall fr Grafik
unsigned short int		svg_x;																												// Breite der zu erzeugenden SVG-Grafiken
unsigned short int		svg_y;																												// Hhe der zu erzeugenden SVG-Grafiken

signed long int				sensor_remote_reload_counter;																	// Reload Counter
unsigned short int		sensor_remote_anzahl;																					// Anzahl definierter Remote-Sensoren
signed short int			sensor_remote_enabled[MAX_REMOTE_SENSORS];										// Enabled (0/1)
char									sensor_remote_local_filename[MAX_REMOTE_SENSORS][80];					// XML-Dateiname
unsigned short int		sensor_remote_max_sensors[MAX_REMOTE_SENSORS];								// Anzahl Sensoren
unsigned short int		sensor_remote_max_age[MAX_REMOTE_SENSORS];										// Alter in Sekunden, bevor der Sensor als ungltig verworfen wird
char									sensor_remote_xmltag[MAX_REMOTE_SENSORS][32][40];							// XML-Tagname
signed short int			sensor_remote_target[MAX_REMOTE_SENSORS][32];									// logischer Zielsensor fr die Daten
signed long int				sensor_remote_timestamp[MAX_REMOTE_SENSORS][32];							// Datum der letzten Aktualisierung
char									sensor_remote_value_string[MAX_REMOTE_SENSORS][32][256];			// ausgelesene Daten

struct s_shm_sensordata	*shm_sensordata;																						// Sensordaten im Shared-RAM
unsigned long int			*shm_sensorcount;																							// Zhler fr Sensordaten-Update
struct s_shm_actordata	*shm_actor_r_data;																					// Aktordaten im Shared-RAM
unsigned long int			*shm_actor_r_count;																						// Zhler fr Aktordaten-Update
struct s_shm_actordata	*shm_actor_w_data;																					// Aktordaten im Shared-RAM
unsigned long int			*shm_actor_w_count;																						// Zhler fr Aktordaten-Update
signed long int				sql_actorvalue_old_read[MAX_LOGICAL_ACTORS];									// Shadow-Variable fr SQL-Update-Optimierung
signed long int				sql_actorvalue_old_write[MAX_LOGICAL_ACTORS];									// Shadow-Variable fr SQL-Update-Optimierung
signed short int			actor_enabled[MAX_LOGICAL_ACTORS];														// Typ des Aktors
char									actor_name[MAX_LOGICAL_ACTORS][40];														// Bezeichnung des Aktors
signed short int			actor_type[MAX_LOGICAL_ACTORS];																// Typ des Aktors
signed long int				actormapping_mapto_sensor[MAX_LOGICAL_ACTORS];								// auf welchen Sensor soll der I/O-Status gemappt werden ?
signed long int				actormapping_wattmapto_sensor[MAX_LOGICAL_ACTORS];						// auf welchen Sensor soll die Wattzahl gemappt werden ?
signed long int				actormapping_bootdefault[MAX_LOGICAL_ACTORS];									// Aktor aktiv ?
signed short int			actor_anzahl;
signed long int				actor_reload_counter;																					// Zhler fr nderungen

signed short int			matrix_rule_enabled[MAX_MATRIX_RULES];												// Regel aktiv
signed short int			matrix_rule_parameterset[MAX_MATRIX_RULES];										// Parmeter 0:log.Sensoren, 1:log.Changes
signed short int			matrix_rule_left_number[MAX_MATRIX_RULES];										// Index auf Sensornummer (-1: keiner)
signed short int			matrix_rule_operator_type[MAX_MATRIX_RULES];									// Vergleichsoperator
signed short int			matrix_rule_right_number[MAX_MATRIX_RULES];										// Index auf Sensornummer (-1: keiner, -2: Konstante)
double								matrix_rule_right_parameter[MAX_MATRIX_RULES];								// Konstante fr Vergleich
signed short int			matrix_rule_action_on[MAX_MATRIX_RULES];											// Aktor-Index fr Einschalten (-1: Keiner)
signed short int			matrix_rule_action_off[MAX_MATRIX_RULES];											// Aktor-Index fr Ausschalten (-1: Keiner)
signed short int			matrix_rule_action_toggle[MAX_MATRIX_RULES];									// Aktor-Index fr Toggeln (-1: Keiner)
char									matrix_rule_action_script[MAX_MATRIX_RULES][150];							// Auszufhrendes Shellscript
unsigned long int			matrix_merker;																								// Zhler fr Schaltmatrix
sqlite3								*sql_var_handle;																							// Handle fr die DB
sqlite3								*sql_config_handle;																						// Handle fr die DB
signed short int			hwmodel;																											// Hardware-ID (4500 oder 5000)

signed long int				zeit_verwaltung1 = 0;																					// Zeit fr Verwaltungsaufgaben
signed long int				zeit_pollr = 0;																								// Zeit fr Sensor-Polling
signed long int				zeit_pollw = 0;																								// Zeit fr Sensor-Polling
signed long int				zeit_verwaltung2 = 0;																					// Zeit fr Verwaltungsaufgaben
signed long int				zeit_gesamt = 0;																							// Gesamt bentigte Zeit
signed long int				zeit_start = 0;
signed long int				zeit_remote_poll = 0;
signed long int				zeit_matrix = 0;
signed long int				zeit_timer = 0;
signed long int				zeit_matrix_actor_copy = 0;
signed long int				zeit_alert = 0;
signed long int				zeit_sensor_copyvalues = 0;
signed long int				zeit_actor_copy_from_shm = 0;
signed long int				zeit_logic_copy_to_shm = 0;
signed long int				zeit_actor_copyvalues = 0;
signed long int				zeit_lcd = 0;
signed long int				zeit_schreibe_datenfile = 0;
signed long int				zeit_update_sensorvalues = 0;
signed long int				zeit_update_actorvalues = 0;
signed long int				anzahl_pollr = 0;
signed long int				anzahl_pollw = 0;


unsigned long int			db_merker;																										// Zhler fr Datenbank
signed short int			db_enabled;																										// Enabled 0/1
signed short int			db_fields;																										// Anzahl Datenfelder
signed short int			db_interval;																									// Zeitintervall Minuten
char									db_name[80];																									// Filename
char									db_path[80];																									// Pfad
signed short int			db_type;																											// 1:SQL, 0:Text
time_t								db_timestamp;																									// Timestamp des letzten DB-Eintrags
time_t								db_next;																											// Timestamp des nchsten Eintrags

signed char						statusmail_boot_enabled[MAX_MAIL_RECIPIENTS];									// Bootmail einabled
signed char						statusmail_continous_enabled[MAX_MAIL_RECIPIENTS];						// Continous mail einabled
signed short int			statusmail_continous_interval[MAX_MAIL_RECIPIENTS];						// Continous mail Zeitintervall
signed char						statusmail_daily_enabled[MAX_MAIL_RECIPIENTS];								// Single mail einabled
signed char						statusmail_daily_hour[MAX_MAIL_RECIPIENTS];										// Single mail Stunde
signed char						statusmail_daily_minute[MAX_MAIL_RECIPIENTS];									// Single mail Minute
signed long int				statusmail_counter = -197;																		// Statusmail Config-Zhler
signed short int			statusmail_max_recipients;																		// Anzahl tatschlich vorhandener Empfnger
char									statusmail_recipient[MAX_MAIL_RECIPIENTS][80];								// Empfngername
char									statusmail_subject[MAX_MAIL_RECIPIENTS][80];									// Subject
signed char						statusmail_lasthour = 0;																			// letzte Stunde
signed char						statusmail_lastminute = 0;																		// letzte Minute
signed short int			statusmail_interval_counter[MAX_MAIL_RECIPIENTS];							// Minutenzhler fr Zeitintervalle

signed long int				mobotix_upload_reload_counter;																	// Reload Counter
unsigned short int		mobotix_upload_anzahl;																					// Anzahl definierter Kameras
signed short int			mobotix_upload_enabled[MAX_MOBOTIX_UPLOADS];										// Enabled (0/1)
char									mobotix_upload_ip[MAX_MOBOTIX_UPLOADS][80];											// IP-Adresse der Kamera
char									mobotix_upload_username[MAX_MOBOTIX_UPLOADS][80];								// Username bei der Kamera
char									mobotix_upload_password[MAX_MOBOTIX_UPLOADS][80];								// Passwort bei der Kamera
char									mobotix_upload_name[MAX_MOBOTIX_UPLOADS][80];										// Benennung
char									mobotix_upload_text_top[MAX_MOBOTIX_UPLOADS][80];								// Einzublendender Text vor den Sensordaten
char									mobotix_upload_text_bottom[MAX_MOBOTIX_UPLOADS][80];						// Einzublendender Text nach den Sensordaten
signed long int				mobotix_upload_insert_timestamp[MAX_MOBOTIX_UPLOADS];						// Soll ein Timestamp eingeblendet werden ?
signed long int				mobotix_upload_time_interval[MAX_MOBOTIX_UPLOADS];							// Seitspanne zwischen Aktualisierungen
signed long int				mobotix_upload_timestamp[MAX_MOBOTIX_UPLOADS];									// Datum der letzten Aktualisierung
signed short int			mobotix_upload_sensor[MAX_MOBOTIX_UPLOADS][32];									// logischer Sensor als Datenquelle
signed short int			mobotix_upload_sensors[MAX_MOBOTIX_UPLOADS];										// Anzahl genutzter logischer Sensoren



// *****   Funktions-Prototypen   *****

void								mobotix_upload_setzedefault									(void);
void								mobotix_upload_readconfig										(void);
void								mobotix_upload															(void);
void								actor_setzedefault													(void);
void								sensor_setzedefault													(void);
void								logic_setzedefault													(void);
void								logic_copy_to_shm														(void);
void								logic_analyze_changes												(void);
signed short int		logical_getfirstfree												(void);
signed short int		physical_getfirstfree												(void);
void								schreibe_datenfile_xml											(void);
void								demon_readconfig														(void);
unsigned long int		physical_readconfig													(void);
void								physical_write_single												(signed short int nummer);
unsigned long int		logic_readconfig														(void);
void								logical_write_single												(signed short int nummer);
void								remote_poll																	(void);
signed long int			sensor_poll_read														(void);
signed long int			sensor_poll_write														(void);
signed long int			sensor_do_poll															(signed short int t,signed short int writeflag);
void								sensor_copyvalues														(void);
void								sensor_math																	(void);
signed short int		actor_readconfig														(void);
void								actor_copyvalues														(void);
void								actor_write_single													(unsigned long int t);
void								scan_report																	(FILE *f,signed short int nummer,char chip_name[],signed short int bus_nummer,signed short int bus_group,
																																 signed short int bus_port,signed short int chip_id,signed short int chip_address,signed short int bus_speed,
																																 signed long int i,signed short int function,signed short int channels,signed short int outchannels,char guess_name[],signed short int all4000_typ);
signed long int			scan_port																		(unsigned char bus_nummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay,FILE *f,signed long int begin_target);
void								do_portscan																	(FILE *f);
void								matrix_read_config													(void);
void								matrix_setzedefault													(void);
void								matrix_execute															(void);
void								do_sql																			(sqlite3 *ptr,char kommando[],unsigned char wait_for_write);
void								sql_erase_sensorvalues											(sqlite3 *ptr);
void								sql_update_sensorvalues											(sqlite3 *ptr);
void								sql_update_actorvalues											(sqlite3 *ptr);
void								sql_update_timevalues												(sqlite3 *ptr);
void								timer_setzedefault													(void);
void								timer_readconfig														(void);
void								timer_execute																(void);
void								portscan_add_internalsensors								(void);
void								alert_readconfig														(void);
void								alert_execute																(void);
void								alert_setzedefault													(void);
void								db_readconfig																(void);
void								db_write_sensordata													(void);
void								lcd_show_sensors														(void);
void								statusmail_readconfig												(void);
void								statusmail_setzedefault											(void);
void								statusmail_boot															(void);
void								statusmail_work															(void);
signed short int		versende_email															(signed short int smtp_encoding,char smtp_username[],char smtp_password[],char smtp_server[],char from[],char to[],char subject[],char body[]);
void								mail_log_append															(unsigned char level,char meldung[]);
void								insert_sensor_values												(FILE *f);
void								strcompress																	(char *destination,char *source);
