// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   sensor_view.c   -   Anzeigen der Sensordaten aus dem Shared Memory                                            **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2009 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <time.h>
#include <sys/time.h>
#include <unistd.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include "../sqlite/sqlite-3.7.3_arm/sqlite3.h"
#include "at91gpio.h"
#include "all_i2c.h"
#include "i2c_chips.h"
#include "sqldb.h"
#include "sensor_demon.h"
#include "shm_use.h"



// *****   Hauptschleife   *****

int main(int argc,char **argv)
	{
	struct s_shm_sensordata*	shm_sensordata;							// Sensordaten im Shared-RAM
	unsigned long int					*shm_sensorcount;						// Zhler fr Sensordaten-Update
	unsigned long int					t;
	unsigned long int					old_count;									// Merker fr alten Zhlerstand
	int												shID;


	// auf existierendes Shared Memory fr Sensordaten zugreifen
	shID = shmget(SHM_ID_SENSORDATA,SHM_SENSORDATA_SIZE,0666);
	if (shID >= 0)
		{
		shm_sensordata = shmat(shID,0,0);
		if (shm_sensordata == (struct s_shm_sensordata *)-1)
			{
			printf("Problem beim Zugriff auf SENSORDATA shared memory !\n");
			goto ende;
			}
		else
			{
			printf("SHM_Sensordata OK.\n");
			}
		}
	else
		{
		// shmget lief schief
		printf("shmget fr SHM_Sensordata war erfolglos ! (shm_create nicht aufgerufen ?)\n");
		goto ende;
    }

	// auf existierendes Shared Memory fr Sensorcount zugreifen
	shID = shmget(SHM_ID_SENSORCOUNT,SHM_SENSORCOUNT_SIZE,0666);
	if (shID >= 0)
		{
		shm_sensorcount = shmat(shID,0,0);
		if (shm_sensorcount == (unsigned long int *)-1)
			{
			printf("Problem beim Zugriff auf SENSORCOUNT shared memory !\n");
			goto ende;
			}
		else
			{
			printf("SHM_Sensorcount OK.\n");
			}
		}
	else
		{
		// shmget lief schief
		printf("shmget fr SHM_Sensorcount war erfolglos ! (shm_create nicht aufgerufen ?)\n");
		goto ende;
    }



	old_count = 0;
looping:
	usleep(50000);																				// 50 ms warten
	if (*shm_sensorcount == old_count) goto looping;			// warten, wenn sich nichts gendert hat
	old_count = *shm_sensorcount;

	printf("\nCount: %ld\n",old_count);
	for(t = 0;t < MAX_LOGICAL_SENSORS;t++)
		{
		if(shm_sensordata[t].value_long > -204800000)
			{
			printf("Sensor %ld: %s\n",t,shm_sensordata[t].value_string);
			}
		}
	goto looping;


ende:
	return(0);
	}
