// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   shm_destroy.c   -   Lschen der Shared-Memory-Bereiche                                                        **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2009 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <time.h>
#include <sys/time.h>
#include <unistd.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include "../sqlite/sqlite-3.7.3_arm/sqlite3.h"
#include "at91gpio.h"
#include "all_i2c.h"
#include "i2c_chips.h"
#include "sensor_demon.h"
#include "shm_use.h"



// *****   Hauptschleife   *****

int main(int argc,char **argv)
	{
	int shID;


	// DUMMY
	shID = shmget(SHM_ID_DUMMY,SHM_DUMMY_SIZE,0666);
	if (shID >= 0) shmctl(shID,IPC_RMID,0);

	// SENSORDATA
	shID = shmget(SHM_ID_SENSORDATA,SHM_SENSORDATA_SIZE,0666);
	if (shID >= 0) shmctl(shID, IPC_RMID, 0);
	// SENSORCOUNT
	shID = shmget(SHM_ID_SENSORCOUNT,SHM_SENSORCOUNT_SIZE,0666);
	if (shID >= 0) shmctl(shID, IPC_RMID, 0);

	// AKTORDATA R
	shID = shmget(SHM_ID_ACTOR_R_DATA,SHM_ACTOR_R_DATA_SIZE,0666);
	if (shID >= 0) shmctl(shID, IPC_RMID, 0);
	// AKTORCOUNT R
	shID = shmget(SHM_ID_ACTOR_R_COUNT,SHM_ACTOR_R_COUNT_SIZE,0666);
	if (shID >= 0) shmctl(shID, IPC_RMID, 0);

	// AKTORDATA W
	shID = shmget(SHM_ID_ACTOR_W_DATA,SHM_ACTOR_W_DATA_SIZE,0666);
	if (shID >= 0) shmctl(shID, IPC_RMID, 0);
	// AKTORCOUNT W
	shID = shmget(SHM_ID_ACTOR_W_COUNT,SHM_ACTOR_W_COUNT_SIZE,0666);
	if (shID >= 0) shmctl(shID, IPC_RMID, 0);

	// DMX512
	shID = shmget(SHM_ID_DMX,SHM_DMX_SIZE,0666);
	if (shID >= 0) shmctl(shID,IPC_RMID,0);

	// Demonstatus
	shID = shmget(SHM_ID_DEMONSTATUS,SHM_DEMONSTATUS_SIZE,0666);
	if (shID >= 0) shmctl(shID,IPC_RMID,0);

	// ADC
	shID = shmget(SHM_ID_ADC,SHM_ADC_SIZE,0666);
	if (shID >= 0) shmctl(shID,IPC_RMID,0);


	return(0);
	}
