// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   sqldb_read.c   -   Commandline-Client zum Lesen aus der STRDB                                                 **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2009 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************



#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <fcntl.h>
#include <time.h>
#include "../sqlite/sqlite-3.7.3_arm/sqlite3.h"

#define CONFIG_DATABASE_FILE "/etc/allnetenv/config.s3db"



// *****   Hauptprogramm   *****

int main(int argc,char **argv)
	{
	int rw = -1;
	char xml_tagname[1024];
	sqlite3 *sql_config_handle;														// Handle fr die DB
	char sql[300];
	sqlite3_stmt *vm;
	char *sql_query;
	signed short int i = 0;


	// printf("sqldb_read  V0.01\n");

	if (argc != 2)
		{
		printf("ERROR: usage: sqldb_read \"tagname\"\n");
		rw = -2;
		goto ende;
		}

	memset(xml_tagname,0,1024);														// Name mit Nullen vorfllen
	strcpy(xml_tagname,argv[1]);													// Name aus der Commandline hineinschreiben

	sqlite3_open(CONFIG_DATABASE_FILE,&sql_config_handle);// SQLITE3-Datenbank ffnen
	sprintf(sql,"SELECT value FROM config WHERE tag='%s';",xml_tagname);

	// printf("SQL:\"%s\"\n",sql);
	sql_query = sqlite3_mprintf("%s",sql);								// Vorbereitung des SQL-Querys
	
	// Umwandlung des SQl Querys in Byte-code
	sqlite3_prepare(sql_config_handle,sql_query,strlen(sql_query),&vm,NULL);

	// Ausgabe des Datensatzes
	while(sqlite3_step(vm) != SQLITE_DONE)
		{
		i++;
		printf("%s\n",sqlite3_column_text(vm,0));						// Inhalt des Datensatzes ausgeben
		}

	if(i < 1) printf("\n");																// wenn kein Datensatz, leere Zeile ausgeben


	sqlite3_finalize(vm);																	// Loeschen des Statements

ende: 
	sqlite3_close(sql_config_handle);											// Datenbank schlieen
	return(0);
	}

