// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   sqldb_write.c   -   Commandline-Client zum Schreiben in die STRDB                                             **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2009 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************



#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <fcntl.h>
#include <time.h>
#include "../sqlite/sqlite-3.7.3_arm/sqlite3.h"

#define CONFIG_DATABASE_FILE "/etc/allnetenv/config.s3db"



// *****   do_sql   -   Ausfhren eines Querys   *****

void do_sql(sqlite3 *ptr,char kommando[],unsigned char wait_for_write)
	{
	signed long int t;
	char *zErrMsg = 0;
	unsigned short int max_retries = 30;
	unsigned short int retries = 0;
	char kommando2[512];


	if(wait_for_write > 0)
		{
		strcpy(kommando2,"PRAGMA count_changes = 0; ");
		strcat(kommando2,kommando);
		}
	else
		{
		strcpy(kommando2,"PRAGMA count_changes = 0; PRAGMA synchronous = 0; ");
		strcat(kommando2,kommando);
		}
again:
	t = sqlite3_exec(ptr,kommando2,NULL,NULL,&zErrMsg);

	if (t != SQLITE_OK)
		{
		if((t == SQLITE_BUSY) || (t == SQLITE_LOCKED))
			{
			usleep(33333);																		// 33 ms warten
			retries++;
			// printf("Retry %d...\n",retries);
			if(retries <= max_retries) goto again;						// wieder probieren
			// printf("Nach %d Versuchen: ",retries);						// max. 1 Sekunde
			}
    fprintf(stderr,"(SQL: \"%s\"\n",kommando);
    fprintf(stderr,"SQL error #%ld: %s\n",t,zErrMsg);
		sqlite3_free(zErrMsg);
		}
	}



// *****   Hauptprogramm   *****

int main(int argc,char **argv)
	{
	char xml_tagname[1024];
	char xml_value[1024];
	sqlite3 *sql_config_handle;														// Handle fr die DB
	char sql[2500];
	sqlite3_stmt *vm;
	char *sql_query;
	signed short int i = 0;


	// printf("sqldb_write  V0.01\n");

	if (argc != 3)
		{
		printf("ERROR: usage: sqldb_write \"tagname\" \"tagvalue\"\n");
		goto ende;
		}

	memset(xml_tagname,0,1024);														// Name mit Nullen vorfllen
	strcpy(xml_tagname,argv[1]);													// Name aus der Commandline hineinschreiben
	memset(xml_value,0,1024);															// Wert mit Nullen vorfllen
	strcpy(xml_value,argv[2]);														// Wert aus der Commandline hineinschreiben


	sqlite3_open(CONFIG_DATABASE_FILE,&sql_config_handle);// SQLITE3-Datenbank ffnen

	// *** Versuchen, zu lesen ***
	sprintf(sql,"SELECT value FROM config WHERE tag='%s';",xml_tagname);
	sql_query = sqlite3_mprintf("%s",sql);								// Vorbereitung des SQL-Querys
	// Umwandlung des SQl Querys in Byte-code
	sqlite3_prepare(sql_config_handle,sql_query,strlen(sql_query),&vm,NULL);

	while(sqlite3_step(vm) != SQLITE_DONE)
		{
		i++;																								// Funstellen zhlen
		}
	sqlite3_finalize(vm);																	// Loeschen des Statements



	printf("%s\n",xml_value);															// Wert anzeigen
	if(i < 1) 
		{
		// nicht gefunden, es muss ein INSERT durchgefhrt werden
		// printf("nicht gefunden\n");																// wenn kein Datensatz, leere Zeile ausgeben
		sprintf(sql,"INSERT INTO config (tag,value) values ('%s','%s');",xml_tagname,xml_value);
		}
	else
		{
		// gefunden, ein UPDATE reicht
		// printf("gefunden !\n");
		sprintf(sql,"UPDATE config SET value='%s' where tag='%s';",xml_value,xml_tagname);
		}
	do_sql(sql_config_handle,sql,1);											// Befehl ausfhren
ende:
	sqlite3_close(sql_config_handle);											// Datenbank schlieen
	return(0);
	}
