// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   timer_demon.c   -   Demon zum zeitgesteuerten Steuern von logischen Aktoren                                   **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2010 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************

// **********   Eintrge in der Konfigurations-Datenbank, die vom Demon ausgewertet werden   **********
//
// TODO: aktualisieren


#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <fcntl.h>
#include <termios.h>
#include <time.h>
#include <sys/time.h>
// #include <sys/ipc.h>
#include <sys/shm.h>
#include "../sqlite/sqlite-3.7.3_arm/sqlite3.h"
#include "at91gpio.h"
#include "all_i2c.h"
#include "i2c_chips.h"
#include "sqldb.h"
#include "shm_use.h"
#include "timer_demon.h"
#include "logging.h"



// *****   timer_setzedefault()   -   Timertabelle auf Standardwerte setzen   *****

void timer_setzedefault(void)
	{
	unsigned short int t;

	for(t = 0;t < MAX_TIMERS;t++)
		{
		timer_enabled[t] = 0;																// Timer Enabled 0/1
		sprintf(timer_name[t],"Timer %d",t);								// Timer Benennung
		timer_start_monday[t] = 0;													// Schaltzeitpunkt Wochentag
		timer_start_tuesday[t] = 0;													// Schaltzeitpunkt Wochentag
		timer_start_wednesday[t] = 0;												// Schaltzeitpunkt Wochentag
		timer_start_thursday[t] = 0;												// Schaltzeitpunkt Wochentag
		timer_start_friday[t] = 0;													// Schaltzeitpunkt Wochentag
		timer_start_saturday[t] = 0;												// Schaltzeitpunkt Wochentag
		timer_start_sunday[t] = 0;													// Schaltzeitpunkt Wochentag
		timer_start_hour[t] = 0;														// Uhrzeit Stunde
		timer_start_minute[t] = 0;													// Uhrzeit Minute
		timer_start_second[t] = 0;													// Uhrzeit Sekunde
		timer_start_onoff[t] = 1;														// On/Off 0/1
		timer_start_actor[t] = -1;													// Ziel-Aktor
		timer_stop_monday[t] = 0;														// Schaltzeitpunkt Wochentag
		timer_stop_tuesday[t] = 0;													// Schaltzeitpunkt Wochentag
		timer_stop_wednesday[t] = 0;												// Schaltzeitpunkt Wochentag
		timer_stop_thursday[t] = 0;													// Schaltzeitpunkt Wochentag
		timer_stop_friday[t] = 0;														// Schaltzeitpunkt Wochentag
		timer_stop_saturday[t] = 0;													// Schaltzeitpunkt Wochentag
		timer_stop_sunday[t] = 0;														// Schaltzeitpunkt Wochentag
		timer_stop_hour[t] = 0;															// Uhrzeit Stunde
		timer_stop_minute[t] = 0;														// Uhrzeit Minute
		timer_stop_second[t] = 0;														// Uhrzeit Sekunde
		timer_stop_onoff[t] = 0;														// On/Off 0/1
		timer_stop_actor[t] = -1;														// Ziel-Aktor
		}
	}



// **********   Timer-Konfiguration einlesen   **********

void timer_readconfig(void)
	{
	char ep[1024];
	signed long int t;
	signed long int i;
	signed long int lcount;

	i = sqldb_read_long("/timers/max_timer");
	if(i > MAX_TIMERS)
		{
		sprintf(ep,"Configured value /timers/max_timer is %ld; larger than MAX_TIMERS, using MAX_TIMERS=%d instead.",i,MAX_TIMERS);
		log_append(2,ep);																			// Fehlermeldung ins Logfile schreiben
		timer_max_timers = MAX_TIMERS;
		}

	timer_setzedefault();
	lcount = 0;
	timer_reload_counter = sqldb_read_long("/timers/reload_timer");

	for(t = 0;t < i;t++)
		{
		sprintf(ep,"/timers/timer%ld/enabled",t);
		timer_enabled[t] = sqldb_read_long(ep);
		if(timer_enabled[t] > 0)
			{
			lcount++;

			sprintf(ep,"/timers/timer%ld/name",t);
			sqldb_read_string(ep,timer_name[t]);

			sprintf(ep,"/timers/timer%ld/start/mo",t);
			timer_start_monday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/tu",t);
			timer_start_tuesday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/we",t);
			timer_start_wednesday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/th",t);
			timer_start_thursday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/fr",t);
			timer_start_friday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/sa",t);
			timer_start_saturday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/su",t);
			timer_start_sunday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/hour",t);
			timer_start_hour[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/min",t);
			timer_start_minute[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/sec",t);
			timer_start_second[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/action",t);
			timer_start_onoff[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/start/actor",t);
			timer_start_actor[t] = sqldb_read_long(ep);

			sprintf(ep,"/timers/timer%ld/stop/mo",t);
			timer_stop_monday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/tu",t);
			timer_stop_tuesday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/we",t);
			timer_stop_wednesday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/th",t);
			timer_stop_thursday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/fr",t);
			timer_stop_friday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/sa",t);
			timer_stop_saturday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/su",t);
			timer_stop_sunday[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/hour",t);
			timer_stop_hour[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/min",t);
			timer_stop_minute[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/sec",t);
			timer_stop_second[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/action",t);
			timer_stop_onoff[t] = sqldb_read_long(ep);
			sprintf(ep,"/timers/timer%ld/stop/actor",t);
			timer_stop_actor[t] = sqldb_read_long(ep);
			}
		else
			{
			}
		}

	sprintf(ep,"Configuration data for %ld Timers read.",lcount);
	log_append(3,ep);																			// Meldung ins Logfile schreiben
	sprintf(ep,"%ld timers",lcount);
	update_demondebug(ep);
	}



// *****   timer_execute   -   Timers prfen und abarbeiten   *****

void timer_execute(signed long int ti)
	{
	char ep[256];
	signed long int t;
	signed long int now_sec;
	signed char now_tag;
	signed long int timer_sec;
	time_t timer;
	struct tm *tblock;
	char sql[256];
	char kommando[512];
	signed short int timer_count = 0;


	timer = time(NULL);
	tblock = localtime(&timer);
	now_sec = tblock->tm_hour * 3600 + tblock->tm_min * 60 + tblock->tm_sec;
	now_tag = tblock->tm_wday; // 0:Sonntag, 1:Montag, ..., 6:Samstag

	// printf("TX (now=%ldsec, Tag:%d, %02d:%02d:%02d)\n",now_sec,now_tag,tblock->tm_hour,tblock->tm_min,tblock->tm_sec);
	for(t = 0;t < MAX_TIMERS;t++)
		{
		if(timer_enabled[t] > 0)
			{
			timer_count++;
			if ( ((timer_start_monday[t] > 0) && (now_tag == 1))
				|| ((timer_start_tuesday[t] > 0) && (now_tag == 2))
				|| ((timer_start_wednesday[t] > 0) && (now_tag == 3))
				|| ((timer_start_thursday[t] > 0) && (now_tag == 4))
				|| ((timer_start_friday[t] > 0) && (now_tag == 5))
				|| ((timer_start_saturday[t] > 0) && (now_tag == 6))
				|| ((timer_start_sunday[t] > 0) && (now_tag == 0)) )
				{
				timer_sec = timer_start_hour[t] * 3600 + timer_start_minute[t] * 60 + timer_start_second[t];
				// printf("T%ld (start=%ldsec, %02d:%02d:%02d)\n",t,timer_sec,timer_start_hour[t],timer_start_minute[t],timer_start_second[t]);
				// if ((now_sec >= timer_sec) && (now_sec <= timer_sec + TIMER_GRACE_PERIOD))
				if (now_sec == timer_sec)
					{
					// printf("TimerStart%ld: Actor%d:%d\n",t,timer_start_actor[t],timer_start_onoff[t]);
					if(timer_start_onoff[t] > 0)
						{
						if (timer_start_onoff[t] < 70000)
							{
							shm_actor_w_data[timer_start_actor[t]].value_long = 1;
							shm_actor_w_data[timer_start_actor[t]].value_float = 1;
							sprintf(ep,"TimerStart%ld: tActor %d ON",t,timer_start_actor[t]);
							log_append(4,ep);															// Meldung ins Logfile schreiben
							}
						if (timer_start_onoff[t] == 70000)
							{
							// printf("TIMER_start: Starten von RGB-Programm %d\n",timer_start_actor[t]);
							sprintf(sql,"UPDATE [program] SET [new_command]='%ld' WHERE [id]='0';",10000L + (signed long int)timer_start_actor[t]);
							sprintf(kommando,"sqlite3 /tmp/var.s3db \"%s\"",sql);
							system(kommando);
							sprintf(ep,"TimerStart%ld: Programm %d START",t,timer_start_actor[t]);
							log_append(4,ep);															// Meldung ins Logfile schreiben
							}
						if (timer_start_onoff[t] == 70001)
							{
							system("sqlite3 /tmp/var.s3db \"UPDATE [program] SET [new_command]='-2' WHERE [id]='0';\"");
							sprintf(ep,"TimerStart%ld: Programm STOP",t);
							log_append(4,ep);															// Meldung ins Logfile schreiben
							}
						}
					else
						{
						shm_actor_w_data[timer_start_actor[t]].value_long = 0;
						shm_actor_w_data[timer_start_actor[t]].value_float = 0;
						sprintf(ep,"TimerStart%ld: tActor %d OFF",t,timer_start_actor[t]);
						log_append(4,ep);														// Meldung ins Logfile schreiben
						}
					}
				}

			if ( ((timer_stop_monday[t] > 0) && (now_tag == 1))
				|| ((timer_stop_tuesday[t] > 0) && (now_tag == 2))
				|| ((timer_stop_wednesday[t] > 0) && (now_tag == 3))
				|| ((timer_stop_thursday[t] > 0) && (now_tag == 4))
				|| ((timer_stop_friday[t] > 0) && (now_tag == 5))
				|| ((timer_stop_saturday[t] > 0) && (now_tag == 6))
				|| ((timer_stop_sunday[t] > 0) && (now_tag == 0)) )
				{
				timer_sec = timer_stop_hour[t] * 3600 + timer_stop_minute[t] * 60 + timer_stop_second[t];
				// if ((now_sec >= timer_sec) && (now_sec <= timer_sec + TIMER_GRACE_PERIOD))
				if (now_sec == timer_sec)
					{
					// printf("TimerStop%ld: Actor%d:%d\n",t,timer_start_actor[t],timer_start_onoff[t]);
					if(timer_stop_onoff[t] > 0)
						{
						if (timer_stop_onoff[t] < 70000)
							{
							shm_actor_w_data[timer_start_actor[t]].value_long = 1;
							shm_actor_w_data[timer_start_actor[t]].value_float = 1;
							sprintf(ep,"TimerStop%ld: tActor %d ON",t,timer_stop_actor[t]);
							log_append(4,ep);													// Meldung ins Logfile schreiben
							}
						if (timer_stop_onoff[t] == 70000)
							{
							// printf("TIMER_stop: Starten von RGB-Programm %d\n",timer_stop_actor[t]);
							sprintf(sql,"UPDATE [program] SET [new_command]='%ld' WHERE [id]='0';",10000L + (signed long int)timer_stop_actor[t]);
							sprintf(kommando,"sqlite3 /tmp/var.s3db \"%s\"",sql);
							system(kommando);
							sprintf(ep,"TimerStop%ld: Programm %d START",t,timer_stop_actor[t]);
							log_append(4,ep);													// Meldung ins Logfile schreiben
							}
						if (timer_stop_onoff[t] == 70001)
							{
							system("sqlite3 /tmp/var.s3db \"UPDATE [program] SET [new_command]='-2' WHERE [id]='0';\"");
							sprintf(ep,"TimerStop%ld: Programm STOP",t);
							log_append(4,ep);													// Meldung ins Logfile schreiben
							}
						}
					else
						{
						shm_actor_w_data[timer_start_actor[t]].value_long = 0;
						shm_actor_w_data[timer_start_actor[t]].value_float = 0;
						sprintf(ep,"TimerStop%ld: tActor %d OFF",t,timer_stop_actor[t]);
						log_append(4,ep);														// Meldung ins Logfile schreiben
						}
					}
				}

			}
		}
	if (timer_count == 0)
		{
		update_demonstatus(ti,20,"no timers");							// Status von Demon in SHM aktualisieren
		update_demondebug("no timers");											// Status von Demon in SHM aktualisieren
		sleep(3);																						// dann knnen wir auch lnger schlafen
		}
	}



// *****   Hauptschleife   *****

int main(int argc,char **argv)
	{
	unsigned long					ti = 0;													// Zhler, geht bei jedem Durchlauf um 1 hoch
	char									ep[1024];												// Puffer fr Logfile-Meldungen
	signed long int				now_sec;
	signed char						now_tag;
	signed long int				last_sec = 0;
	time_t								timer;
	struct tm							*tblock;


	// auf existierendes Shared Memory fr Demonstatus zugreifen
	if (use_my_demonstatus_shm(7) != 1) goto errorende;		// MY_DEMON_ID = 7: timer_demon

	// Status von Demon in SHM eintragen
	my_demonstatus_data[my_demon_id].demon_id = my_demon_id;														// 0 ist Default, hier wird die eigene ID eingetragen
	sprintf(my_demonstatus_data[my_demon_id].name_string,"timer_demon");								// Name
	sprintf(my_demonstatus_data[my_demon_id].version_string,"%s",TIMER_DEMON_VERSION);// Versionsnummer
	my_demonstatus_data[my_demon_id].last_boot = time(0);																// Timestamp(UTC) des Starts
	my_demonstatus_data[my_demon_id].last_activity = time(0);														// Timestamp(UTC) der letzten Aktion
	my_demonstatus_data[my_demon_id].ti = ti;																						// Counter
	sprintf(my_demonstatus_data[my_demon_id].debug_message,"Start");										// letzte Debug-Meldung
	my_demonstatus_data[my_demon_id].error_message[0] = 0;															// letzte Fehlermeldung
	my_demonstatus_data[my_demon_id].status_long = 0;																		// numerischer Status
	sprintf(my_demonstatus_data[my_demon_id].status_string,"startup");									// String-Status

	// Logging-System initialisieren
	strcpy (log_filename,"/www/reports/timer_demon.log");	// Logfilenamen setzen
	log_level = 4;																				// Debuglevel setzen
	// log_kill();																						// Logfile loeschen
	timer_readconfig();																		// Konfig-Daten laden
	sprintf(ep,"----------   timer_demon V %s started (debuglevel=%d)   ----------",TIMER_DEMON_VERSION,log_level);
	log_append(1,ep);																			// Startmeldung ins Logfile schreiben



	// auf existierendes Shared Memory fr Aktordaten Write zugreifen
	shID = shmget(SHM_ID_ACTOR_W_DATA,SHM_ACTOR_W_DATA_SIZE,0666);
	if (shID >= 0)
		{
		shm_actor_w_data = shmat(shID,0,0);
		if (shm_actor_w_data == (struct s_shm_actordata *)-1)
			{
			printf("Problem beim Zugriff auf ACTOR_W_DATA shared memory !\n");
			goto ende;
			}
		else
			{
			// printf("SHM_Actor_w_data OK.\n");
			}
		}
	else
		{
		// shmget lief schief
		printf("shmget fr SHM_Actor_w_data war erfolglos ! (shm_create nicht aufgerufen ?)\n");
		goto ende;
    }

	// Start loggen
	sprintf(ep,"**********   timer demon V %s started   **********",TIMER_DEMON_VERSION);
	log_append(1,ep);
	printf("timer demon V %s started.\n",TIMER_DEMON_VERSION);


	update_demondebug("running");													// letzte Debug-Meldung
hauptschleife:
	update_demonstatus(ti,1,"main loop");									// Status von Demon in SHM aktualisieren
	timer = time(NULL);
	tblock = localtime(&timer);
	now_sec = tblock->tm_hour * 3600 + tblock->tm_min * 60 + tblock->tm_sec;
	now_tag = tblock->tm_wday; // 0:Sonntag, 1:Montag, ..., 6:Samstag

	ti++;																									// Schleifenzhler erhhen
	usleep(200000);																				// 200 ms Rechenzeit freigeben

	if (last_sec == now_sec) goto hauptschleife;					// erst weitermachen, wenn die Sekunde umspringt

	last_sec = now_sec;																		// aktuelle Sekunde merken
	// printf("TimerDemon (now=%ldsec, Tag:%d, %02d:%02d:%02d)\n",now_sec,now_tag,tblock->tm_hour,tblock->tm_min,tblock->tm_sec);

	if (timer_reload_counter != sqldb_read_long("/timers/reload_timer"))
		{
		update_demonstatus(ti,2,"reload");									// Status von Demon in SHM aktualisieren
		timer_readconfig();
		sprintf(ep,"Global Timer Configuration re-read.");
		log_append(1,ep);																		// Meldung ins Logfile schreiben
		goto hauptschleife;
		}

	timer_execute(ti);																		// Timers abarbeiten
	goto hauptschleife;


ende:
	return(0);

errorende:
	return(-1);
	}
